Package: spMC
Type: Package
Title: Continuous-Lag Spatial Markov Chains
Version: 0.3.16
Date: 2026-08-23
Authors@R: person(given = "Luca", 
                  family = "Sartore",
                  role = c("aut", "cre"),
                  email = "drwolf85@gmail.com",
                  comment = "ORCID = \"0000-0002-0446-1328\"")
Author: Luca Sartore [aut, cre] (ORCID = "0000-0002-0446-1328")
Maintainer: Luca Sartore <drwolf85@gmail.com>
Description: A set of functions is provided for 1) the stratum lengths analysis along a chosen direction, 2) fast estimation of continuous lag spatial Markov chains model parameters and probability computing (also for large data sets), 3) transition probability maps and transiograms drawing, 4) simulation methods for categorical random fields. More details on the methodology are discussed in Sartore (2013) <doi:10.32614/RJ-2013-022> and Sartore et al. (2016) <doi:10.1016/j.cageo.2016.06.001>.
Depends: R (>= 4.5.0), base, methods, datasets, utils, grDevices,
        graphics, stats
License: GPL (>= 2)
LazyLoad: yes
NeedsCompilation: yes
Packaged: 2026-09-05 18:39:14 UTC; sartore
Repository: CRAN
Date/Publication: 2026-09-05 19:40:02 UTC

import(graphics)
import(methods)
import(stats)
import(datasets)
import(utils)
import(grDevices)
exportPattern("^[[:alpha:]]+")
useDynLib(spMC, .registration = TRUE)
if(getRversion() >= "3.6.0") {
    S3method(spMC::boxplot, lengths)
    S3method(spMC::contour, pemt)
    S3method(spMC::density, lengths)
    S3method(spMC::hist, lengths)
    S3method(spMC::image, multi_tpfit)
    S3method(spMC::image, pemt)
#    S3method(spMC::is, lengths)
#    S3method(spMC::is, multi_tpfit)
#    S3method(spMC::is, multi_transiogram)
#    S3method(spMC::is, pemt)
#    S3method(spMC::is, tpfit)
#    S3method(spMC::is, transiogram)
    S3method(spMC::persp, multi_tpfit)
    S3method(spMC::persp, pemt)
    S3method(spMC::plot, density.lengths)
    S3method(spMC::plot, hist.lengths)
    S3method(spMC::plot, lengths)
    S3method(spMC::plot, transiogram)
    S3method(spMC::predict, multi_tpfit)
    S3method(spMC::predict, tpfit)
    S3method(spMC::print, density.lengths)
    S3method(spMC::print, lengths)
    S3method(spMC::print, multi_tpfit)
    S3method(spMC::print, multi_transiogram)
    S3method(spMC::print, summary.lengths)
    S3method(spMC::print, tpfit)
    S3method(spMC::print, transiogram)
    S3method(spMC::summary, lengths)
} else {
    S3method(boxplot, lengths)
    S3method(contour, pemt)
    S3method(density, lengths)
    S3method(hist, lengths)
    S3method(image, multi_tpfit)
    S3method(image, pemt)
#    S3method(is, lengths)
#    S3method(is, multi_tpfit)
#    S3method(is, multi_transiogram)
#    S3method(is, pemt)
#    S3method(is, tpfit)
#    S3method(is, transiogram)
    S3method(persp, multi_tpfit)
    S3method(persp, pemt)
    S3method(plot, density.lengths)
    S3method(plot, hist.lengths)
    S3method(plot, lengths)
    S3method(plot, transiogram)
    S3method(predict, multi_tpfit)
    S3method(predict, tpfit)
    S3method(print, density.lengths)
    S3method(print, lengths)
    S3method(print, multi_tpfit)
    S3method(print, multi_transiogram)
    S3method(print, summary.lengths)
    S3method(print, tpfit)
    S3method(print, transiogram)
    S3method(summary, lengths)
}

# spMC: Continuous-Lag Spatial Markov Chains

### Authors <img src="man/figures/logo.svg" align="right" alt="spMC logo" />
[Luca Sartore](mailto://drwolf85@gmail.com)[<img alt="ORCID iD" src="https://cran.r-project.org/web/orcid.svg" width="16px" height="16px" style="width:16px; height:16px; margin-left:4px; margin-right:4px; vertical-align:middle">](https://orcid.org/0000-0002-0446-1328) 

Maintainer: [Luca Sartore](mailto://drwolf85@gmail.com)

[![](https://www.r-pkg.org/badges/version/spMC)](https://CRAN.R-project.org/package=spMC)
[![GPLv2 license](https://img.shields.io/badge/License-GPLv2-yellow.svg)](https://perso.crans.org/besson/LICENSE.html)
[![DOI](https://zenodo.org/badge/doi/10.32614/RJ-2013-022.svg)](https://dx.doi.org/10.32614/rj-2013-022)
[![DOI](https://zenodo.org/badge/doi/10.1016/j.cageo.2016.06.001.svg)](https://dx.doi.org/10.1016/j.cageo.2016.06.001)
[![CRAN RStudio mirror downloads](https://cranlogs.r-pkg.org/badges/spMC)](https://www.r-pkg.org/pkg/spMC)
[![Total Downloads from CRAN RStudio mirror](https://cranlogs.r-pkg.org/badges/grand-total/spMC?color=orange)](https://CRAN.R-project.org/package=spMC)


## Features of the package
The main goal of the **spMC** package is to provide a set of functions for
  1. the stratum lengths analysis along a chosen direction,
  2. fast estimation of continuous lag spatial Markov chains model parameters and probability computing (also for large data sets), 
  3. transition probability maps and transiograms drawing, 
  4. simulation methods for categorical random fields.

Several functions are available for the stratum lengths analysis, in particular they compute the stratum lengths for each stratum category, they compute the empirical distributions and many other tools for a graphical analysis.

Usually, the basic inputs for the most of the functions are a vector of categorical data and their location coordinates. They are used to estimate empirical transition probabilities (`transiogram`), to estimate model parameters (`tpfit` for one-dimensional Markov chains or `multi_tpfit` for multidimensional Markov chains). Once parameters are estimated, it's possible to compute theoretical transition probabilities by the use of the function `predict.tpfit` for one-dimensional Markov chains and `predict.multi_tpfit` for multidimensional ones.

The function `plot.transiogram` allows to plot one-dimensional transiograms, while `image.multi_tpfit` permit to draw transition probability maps. A powerful tool to explore graphically the anisotropy of such process is given by the functions `pemt` and `image.pemt`, which let the user to draw "quasi-empirical" transition probability maps.

Simulation methods are based on Indicator Kriging (`sim_ik`), Indicator Cokriging (`sim_ck`), Fixed or Random Path algorithms (`sim_path`) and Multinomial Categorical Simulation technique (`sim_mcs`).

For a complete list of exported functions, use `library(help = "spMC")` once the **spMC** package is installed.

## References

Allard, D., D'Or, D., Froidevaux, R. (2011) An efficient maximum entropy approach for categorical variable prediction. *European Journal of Soil Science*, **62**(3), 381-393.

Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. *Mathematical Geology*, **29**(7), 891-918.

Dynkin, E. B. (1961) *Theory of Markov Processes*. Englewood Cliffs, N.J.: Prentice-Hall, Inc.

Higham, N. J. (2008) *Functions of Matrices: Theory and Computation*. Society for Industrial and Applied Mathematics.

Li, W. (2007) A Fixed-Path Markov Chain Algorithm for Conditional Simulation of Discrete Spatial Variables. *Mathematical Geology*, **39**(2), 159-176.

Li, W. (2007) Markov Chain Random Fields for Estimation of Categorical Variables. *Mathematical Geology*, **39**(June), 321-335.

Li, W. (2007) Transiograms for Characterizing Spatial Variability of Soil Classes. *Soil Science Society of America Journal*, **71**(3), 881-893.

Pickard, D. K. (1980) Unilateral Markov Fields. *Advances in Applied Probability*, **12**(3), 655-671.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.

Sartore, L. (2013). spMC: Modelling Spatial Random Fields with Continuous Lag Markov Chains. *The R Journal*, **5**(2), 16-28.

Sartore, L., Fabbri, P. and Gaetan, C. (2016). spMC: an R-package for 3D lithological reconstructions based on spatial Markov chains. *Computers & Geosciences*, **94**(September), 40-47.

Weise, T. (2009) *Global Optimization Algorithms - Theory and Application*. [[Archived copy]](https://archive.org/details/Thomas_Weise__Global_Optimization_Algorithms_Theory_and_Application/page/n57/mode/2up).

plot.transiogram <-
function(x, ..., main, legend = FALSE, ci = NULL) {
  # Plot transition probabilities matrixes 1D
  #
  #          x transiogram object
  #        ... other args to pass to plot()
  #       main title string
  #     legend number of points per axes
  #         ci confidence intervall significance (e.g. `ci = 0.95`)

  n <- dim(x$Tmat)[1]
  if (!is.null(ci)) {
    if (ci >= 1 | ci <= 0) stop("\"ci\" must be a number between 0 and 1")
  }
  if (missing(main) || !is.character(main)) main <- "One-dimensional transiogram"
  
  ly <- matrix(c(rep(1, n), rep(0, n), 2:(n^2+1), rep(n^2+3, n), rep(n^2+4, n)), ncol = n, byrow = TRUE)
  yl0 <- c(rep(0, n + 4))
  yln <- c(rep(0, 2), rep(n^2 + 2, n), rep(0, 2))
  ly <- cbind(yln, yln, ly, yl0, yl0)
  widths <- c(3, 4/3.5, rep(30/n, n), 4/3.5, 3) / 4 
  heights <- c(0.75, 1/3.5, rep(7.5/n, n), 2.5/3.5, 1)
  if (!legend) {
    ly <- ly[-n^2-4, ]
    heights <- heights[-n^2-4]
  }
  ly <- layout(ly, widths = widths, heights = heights, respect = TRUE)

  par(mar=c(0.3, 0.1, 0.3, 0.1))
  plot.new()
  text(0.5, 0.5, main, cex = 2)

  nomi <- colnames(x$Tmat)

  UppBnd <- NULL #upper bound
  LowBnd <- NULL #lower bound
  if(!is.null(x$LOSE) & !is.null(ci)) {
    a <- .5 - ci * .5
    LogOdds <- .C('transLogOdds', mdim = as.integer(dim(x$LOSE)), 
                  empTR = as.double(x$Tmat), empTLO = double(prod(dim(x$LOSE))),
                  NAOK = TRUE, PACKAGE = "spMC")$empTLO
    UppBnd <- LogOdds - qnorm(a) * x$LOSE
    LowBnd <- LogOdds + qnorm(a) * x$LOSE
    UppBnd <- array(.C('LogOddstrans', mdim = as.integer(dim(x$LOSE)),
                       empTLO = as.double(UppBnd),  empTR = as.double(UppBnd),
                       NAOK = TRUE, PACKAGE = "spMC")$empTR, dim = dim(x$LOSE))
    LowBnd <- array(.C('LogOddstrans', mdim = as.integer(dim(x$LOSE)),
                       empTLO = as.double(LowBnd), empTR = as.double(LowBnd),
                       NAOK = TRUE, PACKAGE = "spMC")$empTR, dim = dim(x$LOSE))
  }

  par(mar = 2 * (rep(1.25, 4) + c(1, 1, 0, 0)) / n)
  xpos <- mean(range(na.omit(x$lags)))
  for(j in 1:n) {
    for(k in 1:n) {
      myseq <- na.omit(cbind(x$lags, x$Tmat[j, k, ]))
      if(dim(myseq)[1] != 0) {
        plot(myseq[, 1], myseq[, 2], ylab = "", xlab = "", ..., ylim = 0:1, axes = FALSE)
        if(!is.null(LowBnd)) {
          myseq <- na.omit(cbind(x$lags, LowBnd[j, k, ]))
          lines(myseq[, 1], myseq[, 2], lty = 2, ...)
        }
        if(!is.null(UppBnd)) {
          myseq <- na.omit(cbind(x$lags, UppBnd[j, k, ]))
          lines(myseq[, 1], myseq[, 2], lty = 2, ...)
        }
      }
      else {
        plot.new()
      }
      box()
      if (k == 1) axis(2)
      if (k == n) axis(4, .5, labels = nomi[j], tick = FALSE, font = 3)
      if (j == n) axis(1)
      if (j == 1) axis(3, xpos, labels = nomi[k], tick = FALSE, font = 3)
    }
  }
  par(mar = rep(.005, 4))
  plot.new()
  text(0.3, 0.5, "Transition probabilities", srt = 90, cex = 1.3)
  plot.new()
  text(0.5, 0.2, "Lags", cex = 1.3)

  if (legend) {
    args <- list(...)
    orgs <- list()
    orgs$col <- par("col")
    orgs$lty <- NA
    orgs$lwd <- NA
    orgs$pch <- NA
    orgs$pt.cex <- NA
    if (!is.null(args$col)) orgs$col <- args$col
    if (is.null(args$type)) {
      orgs$pch <- 1
      orgs$pt.cex <- 1
    }
    else {
      if (args$type == "p") {
        if (!is.null(args$pch)) orgs$pch <- args$pch else orgs$pch <- 1
        if (!is.null(args$cex)) orgs$pt.cex <- args$cex else orgs$pt.cex <- 1
      }
      if (args$type %in% c("b", "c", "o")) {
        if (!is.null(args$pch)) orgs$pch <- args$pch else orgs$pch <- 1
        if (!is.null(args$cex)) orgs$pt.cex <- args$cex else orgs$pt.cex <- 1
        if (!is.null(args$lty)) orgs$lty <- args$lty else orgs$lty <- 1
        if (!is.null(args$lwd)) orgs$lwd <- args$lwd else orgs$lwd <- 1
      }
      if (args$type %in% c("l", "h", "s", "S")) {
        if (!is.null(args$lty)) orgs$lty <- args$lty else orgs$lty <- 1
        if (!is.null(args$lwd)) orgs$lwd <- args$lwd else orgs$lwd <- 1
      }
    }
    par(mar=c(1.2, 0.1, 2.2, 0.1))
    plot.new()
    legend("center", legend = paste(x$type, "transiogram"),
           lty = orgs$lty, lwd = orgs$lwd, pch = orgs$pch, 
           pt.cex = orgs$pt.cex, col = orgs$col, bty = "n",
           cex = 1.5, box.lwd = 0, box.lty = 0, horiz = TRUE)
  }

}

sim_mcs <-
function(x, data, coords, grid, knn = NULL, entropy = FALSE) {
  # Generation of Multinomial Categorical Simulation (MCS)
  #
  #       x a multi_tpfit object
  #    data vector of data
  #  coords coordinates matrix
  #    grid simulation points
  #     knn number of k-nearest neighbours (if NULL all data are neighbours)
  #  radius radius to find neighbour points
  # entropy logical value to compute uncertainties

  if(!is.multi_tpfit(x)) stop("argument \"x\" must be a 'multi_tpfit' object.")

  if (missing(grid)) stop("simulation grid is missing.")
  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  if (!is.matrix(grid)) grid <- as.matrix(grid)
  storage.mode(coords) <- "double"
  storage.mode(grid) <- "double"

  hmany <- length(data)
  nc <- dim(coords)[2]
  nr.orig <- dim(coords)[1]
  if (hmany != nr.orig) stop("the number of data is not equal to the number of coordinates")
  if (nc != dim(grid)[2]) stop("coordinates and simulation grid must have the same number of columns")
  if (!is.null(knn)) {
    knn <- if ((knn > 0) && (knn < hmany)) { as.integer(ceiling(knn)) } else { NULL }
  }
  nk <- nlevels(data)
  levelLab <- levels(data)
  nrs <- dim(grid)[1] #total number of simulation

  data <- as.integer(data)
  dire.mat <- diag(, nc)
  if (!is.null(x$rotation)) {
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(x$rotation),
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- matrix(dire.mat, nc, nc)
  }
  knn <- NULL
  if (is.null(knn)) {
    path <- 1:nrs
    prhat <- matrix(x$prop, nk, nrs)
    # APPROXIMATING PROBABILITIES WITH ALL DATA #
    prhat <- .C('jointProbsMCS', coords = as.double(coords), hmany = as.integer(hmany),
                grid = as.double(grid), nrs = as.integer(nrs), nc = as.integer(nc),
                nk = as.integer(nk), ndata = as.integer(data),
                coefs = as.double(unlist(x$coefficients)), matdir = as.double(dire.mat),
                rota = as.integer(!is.null(x$rotation)), pProbs = as.double(prhat), 
                PACKAGE = "spMC")$pProbs
  }
  else {
    prhat <- matrix(1, nk, nrs)
    new.coords <- coords
    new.grid <- grid
    if (!is.null(x$rotation)) {
      new.coords <- matrix(.C('fastMatProd', nr = as.integer(nr.orig), ni = as.integer(nc),
                              mat1 = as.double(coords), nc = as.integer(nc),
                              mat2 = as.double(dire.mat), res = as.double(new.coords),
                              PACKAGE = "spMC")$res, nrow = nr.orig, ncol = nc)
      new.grid <- matrix(.C('fastMatProd', nr = as.integer(nrs), ni = as.integer(nc),
                            mat1 = as.double(grid), nc = as.integer(nc),
                            mat2 = as.double(dire.mat), res = as.double(new.grid),
                            PACKAGE = "spMC")$res, nrow = nrs, ncol = nc)
    }
    # FINDING THE k-NEAREST NEIGHBOURS #
    indices <- matrix(0L, nrow = knn, ncol = nrs)
    indices <- matrix(.C('knear', nc = as.integer(nc), nr = as.integer(nr.orig),
                         coords = as.double(new.coords), nrs = as.integer(nrs),
                         grid = as.double(new.grid), knn = as.integer(knn),
                         indices = as.integer(indices), PACKAGE = "spMC")$indices,
                      nrow = knn, ncol = nrs)
#    indices <- replicate(nrs, sample.int(nr.orig, knn)) - 1L
    # SORTING SIMULATION GRID #
    path <- do.call("order", as.data.frame(t(indices)))
    indices <- indices[, path]
    grid <- grid[path, ]
    # APPROXIMATING PROBABILITIES WITH k-NEAREST NEIGHBOURS #
    prhat <- .C('KjointProbsMCS', coords = as.double(new.coords), hmany = as.integer(hmany),
                grid = as.double(new.grid), nrs = as.integer(nrs), nc = as.integer(nc),
                nk = as.integer(nk), ndata = as.integer(data), knn = as.integer(knn),
                coefs = as.double(unlist(x$coefficients)), indices = as.integer(indices),
                pProbs = as.double(prhat), PACKAGE = "spMC")$pProbs
  }
  prhat <- matrix(prhat, nrs, nk, byrow = TRUE)
  sim <- vector("integer", nrs)

  sim <- .C('tsimCate', nk = as.integer(nk), n = as.integer(nrs), prhat = as.double(prhat), 
            initSim = as.integer(sim), PACKAGE = "spMC")$initSim
  pred <- apply(prhat, 1, which.max)

  rownames(grid) <- NULL
  rownames(sim) <- NULL
  rownames(pred) <- NULL
  rownames(prhat) <- NULL
  tmpfct <- 1:nk
  tmpfct <- factor(tmpfct, labels = levelLab)
  sim <- tmpfct[sim]
  pred <- tmpfct[pred]
  # COMPUTATION OF THE ENTROPY
  if (entropy) {
    entr <- .C("entropy", n = dim(prhat), probs = as.double(prhat),
               entr = double(2 * nrs), PACKAGE = "spMC")$entr
    res <- data.frame(grid, sim, pred, prhat, matrix(entr, nrs, 2L))
    names(res) <- c(colnames(coords), "Simulation", "Prediction", levelLab, 
                    "Entropy", "Std.Entropy")
  } else {
    res <- data.frame(grid, sim, pred, prhat)
    names(res) <- c(colnames(coords), "Simulation", "Prediction", levelLab)
  }
  res[path, ] <- res
  attr(res, "type") <- "Multinomial Categorical Simulation"
  attr(res, "entropy") <- entropy
  attr(res, "packageVersion") <- paste(packageVersion("spMC"))
  class(res) <- c("data.frame", "spsim")
  return(res)
}

print.multi_tpfit <-
function(x, ...) {
  nc <- length(x$coefficients)
  dire.mat <- diag(, nc)
  if (!is.null(x$rotation)) {
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(x$rotation),
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- t(matrix(dire.mat, nc, nc))
  } 
  for(i in 1:nc) {
    cat("Direction (", sep = "")
    cat(dire.mat[i,], sep = ", ")
    cat(")\n", sep = "")
    print(x$coefficients[[i]], ...)
  }
  cat("Estimated proportions:\n\n")
  proportions <- as.vector(x$prop)
  names(proportions) <- names(x$prop)
  print(proportions, ...)
  cat("\n")
  invisible(x)
}

boxplot.lengths <-
function (x, ..., log = FALSE, zeros.rm = TRUE) {
  newlen <- x$length + 0
  if (zeros.rm & x$zeros) {
    newlen <- x$length + x$maxcens
  }
  if (log) newlen <- log(newlen)
  boxplot(newlen ~ x$categories, ...)
}

# transiogram <-
# function(data, coords, direction, max.dist = Inf, mpoints = 20, tolerance = pi/8) {
#   # Empirical transition probabilities estimated by points
#   #
#   #       data vector of data
#   #     coords coordinates matrix
#   #  direction vector (or versor) of choosen direction
#   #   max.dist maximum distance for counting
#   #    mpoints number of lags
#   #  tolerance angle tolerance (in radians)
# 
#   if (!is.numeric(max.dist) || max.dist < 0) stop("\"max.dist\" must be numeric and non negative")
#   if (!is.factor(data)) data <- as.factor(data)
#   if (!is.matrix(coords)) coords <- as.matrix(coords)
#   if (!is.numeric(mpoints) || mpoints <= 0) stop("\"mpoints\" must be positive number")
#   mpoints <- as.integer(ceiling(mpoints))
#   nk <- nlevels(data) # number of categories
#   n <- length(data)   # sample size
#   if (n != dim(coords)[1]) stop("the number of data is not equal to the number of coordinates")
#   nc <- dim(coords)[2]
#   if (length(direction) != nc) stop("wrong length of direction vector")
#   labels <- levels(data)
# 
#   storage.mode(coords) <- "double"
#   storage.mode(direction) <- "double"
# 
#   # definition of bins through I(x <= vDeltaH)
#   direction <- direction / sqrt(sum(direction^2))
#   RNG <- apply(coords, 2, range)
#   dr <- sqrt(sum(diff(RNG)^2))
#   deltah <- min(dr, max.dist) / mpoints
#   vDeltaH <- cumsum(rep(deltah, mpoints))
# 
#   # count transition occurences
#   Tcount <- .C('transCount', n = as.integer(n), data = as.integer(data), 
#                nc = as.integer(nc), coords = as.double(coords),
#                dire = as.double(direction), tolerance = as.double(tolerance), 
#                mpoints = as.integer(mpoints), bins = as.double(vDeltaH), 
#                nk = as.integer(nk), trans = as.double(vector("numeric", nk^2 * mpoints)),
#                DUP = FALSE, PACKAGE = "spMC")$trans
#   Tcount <- array(Tcount, dim = c(nk, nk, mpoints))
#   rwSum <- apply(Tcount, 3, .rowSums, m = nk, n = nk)
#   mtSum <- apply(Tcount, 3, sum)
#   nonComputable <- mtSum == 0
#   if (all(nonComputable)) stop("\"max.dist\" is lower than the minimum distance")
#   # compute transition probabilities
#   Tcount <- .C('transProbs', mpoints = as.integer(mpoints), nk = as.integer(nk), 
#                rwsum = as.double(rwSum), empTR = as.double(Tcount),
#                DUP = FALSE, PACKAGE = "spMC")$empTR
#   res <- list()
#   res$Tmat <- array(Tcount, dim = c(nk, nk, mpoints))
#   res$Tmat <- array(c(diag(, nk), res$Tmat[, , !nonComputable]),
#                     dim = c(nk, nk, mpoints - sum(nonComputable) + 1))
#   colnames(res$Tmat) <- rownames(res$Tmat) <- labels
# 
#   res$lags <- apply(cbind(c(0, vDeltaH[-mpoints]), vDeltaH), 1, mean)[!nonComputable]
#   res$lags <- c(0, res$lags)
#   res$type <- "Empirical"
#   class(res) <- "transiogram"
#   return(res)
# }

transiogram <-
function(data, coords, direction, max.dist = Inf, mpoints = 20, tolerance = pi/8, reverse = FALSE) {
  # Empirical transition probabilities estimated by points
  #
  #       data vector of data
  #     coords coordinates matrix
  #  direction vector (or versor) of choosen direction
  #   max.dist maximum distance for counting
  #    mpoints number of lags
  #  tolerance angle tolerance (in radians)
  #    reverse logical, if TRUE compute probabilities also for the reversible chain

  if (!is.logical(reverse)) stop("\"reverse\" must be a logical value")
  reverse <- reverse[1]
  if (!is.numeric(max.dist) || max.dist < 0) stop("\"max.dist\" must be numeric and non negative")
  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  if (!is.numeric(mpoints) || mpoints <= 0) stop("\"mpoints\" must be positive number")
  mpoints <- as.integer(ceiling(mpoints))
  nk <- nlevels(data) # number of categories
  n <- length(data)   # sample size
  if (n != dim(coords)[1]) stop("the number of data is not equal to the number of coordinates")
  nc <- dim(coords)[2]
  if (length(direction) != nc) stop("wrong length of direction vector")
  labels <- levels(data)

  storage.mode(coords) <- "double"
  storage.mode(direction) <- "double"

  # definition of bins through I(x <= vDeltaH)
  direction <- direction / sqrt(sum(direction^2))
  RNG <- apply(coords, 2, range)
  dr <- sqrt(sum(diff(RNG)^2))
  deltah <- min(dr, max.dist) / (mpoints * 2^reverse)
  vDeltaH <- cumsum(rep(deltah, mpoints))

  # count transition occurences along the chosen direction
  Tcount <- .C('transCount', n = as.integer(n), data = as.integer(data), 
               nc = as.integer(nc), coords = as.double(coords),
               dire = as.double(direction), tolerance = as.double(tolerance), 
               mpoints = as.integer(mpoints), bins = as.double(vDeltaH), 
               nk = as.integer(nk), trans = as.double(vector("numeric", nk^2 * mpoints)),
               PACKAGE = "spMC")$trans
  Tcount <- array(Tcount, dim = c(nk, nk, mpoints))
  mtSum <- apply(Tcount, 3, sum)
  computable <- mtSum != 0
  computablerev <- c()
  if (reverse) { # count transition occurences along the opposite chosen direction
    revdire <- -1 * direction
    Tcountrev <- vector("numeric", nk^2 * mpoints)
    Tcountrev <- .C('transCount', n = as.integer(n), data = as.integer(data), 
                    nc = as.integer(nc), coords = as.double(coords),
                    dire = as.double(revdire), tolerance = as.double(tolerance), 
                    mpoints = as.integer(mpoints), bins = as.double(vDeltaH), 
                    nk = as.integer(nk), trans = as.double(Tcountrev),
                    PACKAGE = "spMC")$trans
    Tcountrev <- array(Tcountrev, dim = c(nk, nk, mpoints))
    mtSumrev <- apply(Tcountrev, 3, sum)
    computablerev <- mtSumrev != 0
  }
  if (all(!c(computable, computablerev))) stop("\"max.dist\" is lower than the minimum distance")
  # compute transition probabilities
  rwSum <- apply(Tcount, 3, .rowSums, m = nk, n = nk)
  LOSEmat <- .C('transSE', mpoints = as.integer(mpoints), nk = as.integer(nk),
                 rwsum = as.double(rwSum), empTR = as.double(Tcount),
                 se = double(as.integer(mpoints) * nk^2L), PACKAGE = "spMC")$se
  Tcount <- .C('transProbs', mpoints = as.integer(mpoints), nk = as.integer(nk), 
               rwsum = as.double(rwSum), empTR = as.double(Tcount),
               PACKAGE = "spMC")$empTR
  if (reverse) {
    rwSumrev <- apply(Tcountrev, 3, .rowSums, m = nk, n = nk)
    LOSEmatrev <- .C('transSE', mpoints = as.integer(mpoints), nk = as.integer(nk),
                   rwsum = as.double(rwSumrev), empTR = as.double(Tcountrev),
                   se = double(as.integer(mpoints) * nk^2L), PACKAGE = "spMC")$se
    Tcountrev <- .C('transProbs', mpoints = as.integer(mpoints),
                    nk = as.integer(nk), rwsum = as.double(rwSumrev),
                    empTR = as.double(Tcountrev), PACKAGE = "spMC")$empTR
  }
  res <- list()
  if (reverse) {
    wh <- which(c(computablerev, TRUE, computable))
    sq <- seq_len(sum(computablerev))
    wh[sq] <- wh[rev(sq)]
    res$Tmat <- array(c(Tcountrev, diag(, nk), Tcount), dim = c(nk, nk, 1L + 2L * mpoints))[, , wh]
    res$LOSE <- array(c(LOSEmatrev, matrix(0, nk, nk), LOSEmat), dim = c(nk, nk, 1L + 2L * mpoints))[, , wh]
    res$lags <- apply(cbind(c(0, vDeltaH[-mpoints]), vDeltaH), 1, mean)
    res$lags <- c(-rev(res$lags[computablerev]), 0, res$lags[computable])
  }
  else {
    res$Tmat <- array(Tcount, dim = c(nk, nk, mpoints))
    res$Tmat <- array(c(diag(, nk), res$Tmat[, , computable]),
                      dim = c(nk, nk, mpoints - sum(!computable) + 1))
    res$LOSE <- array(LOSEmat, dim = c(nk, nk, mpoints))
    res$LOSE <- array(c(matrix(0, nk, nk), res$LOSE[, , computable]),
                      dim = c(nk, nk, mpoints - sum(!computable) + 1))
    res$lags <- apply(cbind(c(0, vDeltaH[-mpoints]), vDeltaH), 1, mean)[computable]
    res$lags <- c(0, res$lags)
  }
  colnames(res$Tmat) <- rownames(res$Tmat) <- labels

  res$type <- "Empirical"
  class(res) <- "transiogram"
  return(res)
}

.onLoad <- function(lib, pkg) {
       .C('setNumSlaves', n = as.integer(1L), PACKAGE = "spMC")
}

.onAttach <- function(lib, pkg) {
       if (.Call("isOmp", PACKAGE = "spMC")) {
           packageStartupMessage("Package built with openMP.")
       }
       else {
           packageStartupMessage("Package built without openMP.")
       }
       nn <- setCores()
       if (nn > 0L) packageStartupMessage("Use the function setCores() to change the number of CPU cores.")
}

print.summary.lengths <-
function (x, ...) {
  cat("Direction (")
  cat(x$direction, sep = ", ")
  cat(")\n")
  n <- length(x)
  nms <- names(x)
  for (i in 1:n) {
    cat("Stratum lengths of category \"", nms[i], "\"\n", sep = "")
    print(x[[i]], ...)
    if (i != n) cat("\n")
  }
  invisible(x)
}

print.multi_transiogram <-
function(x, ...) {
  for(i in 1:dim(x$Tmat)[3]) {
    cat(x$type, " transition probabilities at lag (", sep = "")
    cat(unlist(x$lags[i, ]), sep = ", ")
    cat(")\n\n")
    print(x$Tmat[, , i], ...)
    if(i != length(x)) cat("\n")
  }
  invisible(x)
}

which_lines <-
function(coords, direction, tolerance = pi/8) {
  # Segments indicator
  #
  #     coords coordinates matrix
  #  direction vector (or versor) of choosen direction
  #  tolerance angle tolerance (in radians)

  if (!is.matrix(coords)) coords <- as.matrix(coords)
  n <- dim(coords)[1]
  nc <- dim(coords)[2]
  if (length(direction) != nc) stop("wrong length of direction vector")
  storage.mode(coords) <- "double"
  storage.mode(direction) <- "double"

  id <- .C('wl', n = as.integer(n), nc = as.integer(nc), 
            coords = as.double(coords), dire = as.double(direction),
            tolerance = as.double(tolerance), 
            id = as.integer(vector("integer", n)), PACKAGE = "spMC")$id
  return(as.integer(as.factor(id)))
}

quench <-
function(x, data, coords, sim, GA = FALSE, optype = c("param", "fullprobs", "semiprobs", "coordprobs"), max.it = 1000, knn = 12) {
  # Perform quenching algorithm for reducing artifacts on simulations
  #
  #        x a multi_tpfit object
  #     data vector of data
  #   coords coordinates matrix
  #      sim simulation results (tipically an "spsim" object)
  #       GA boolean (if TRUE genetic algorithm is applied rather than simulated annealing)
  #   optype character with the objective function to minimize after the simulation
  #   max.it maximum number of iteration for the optimization method
  #      knn number of k-nearest neighbours

  if(!is.multi_tpfit(x)) stop("argument \"x\" must be a 'multi_tpfit' object.")
  if(!all(class(sim) %in% c("data.frame", "spsim"))) stop("argument \"sim\" must be an 'spsim' object.")
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  nc <- dim(coords)[2]
  nr <- dim(coords)[1]
  grid <- sim[, 1L:nc]
  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(grid)) grid <- as.matrix(grid)

  probs <- sim[, -1L:-(nc + 2L)]

  nrs <- dim(grid)[1]
  nk <- nlevels(data)
  if (is.null(knn)) {knn <- nr} else {knn <- as.integer(knn)}
  levLabels <- levels(data)
  data <- as.integer(data)
  storage.mode(coords) <- "double"
  storage.mode(grid) <- "double"
  if (length(optype) > 1) optype <- optype[1]

  initSim <- sim$Simulation
  pred <- sim$Prediction

  dire.mat <- diag(, nc)
  new.coords <- coords
  new.grid <- grid
  if (!is.null(x$rotation)) {
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(x$rotation), 
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- matrix(dire.mat, nc, nc)
    new.coords <- matrix(.C('fastMatProd', nr = as.integer(nr), ni = as.integer(nc),
                          mat1 = as.double(coords), nc = as.integer(nc),
                          mat2 = as.double(dire.mat), res = as.double(new.coords),
                          PACKAGE = "spMC")$res, nrow = nr, ncol = nc)
    new.grid <- matrix(.C('fastMatProd', nr = as.integer(nrs), ni = as.integer(nc),
                          mat1 = as.double(grid), nc = as.integer(nc),
                          mat2 = as.double(dire.mat), res = as.double(new.grid),
                          PACKAGE = "spMC")$res, nrow = nrs, ncol = nc)
  }

  # FINDING THE k-NEAREST NEIGHBOURS #
  indices <- matrix(0L, nrow = knn, ncol = nrs)
  indices <- matrix(.C('knear', nc = as.integer(nc), nr = as.integer(nr),
                       coords = as.double(new.coords), nrs = as.integer(nrs),
                       grid = as.double(new.grid), knn = as.integer(knn),
                       indices = as.integer(indices), PACKAGE = "spMC")$indices,
                    nrow = knn, ncol = nrs)

  # SORTING SIMULATION GRID #
  path <- do.call("order", as.data.frame(t(indices)))
  indices <- indices[, path]
  grid <- grid[path, ]
  new.grid <- new.grid[path, ]
  groups <- !duplicated(t(indices))
  groups <- cumsum(groups)
  initSim <- initSim[path]

  # OPTIMIZATION PROCEDURE #
  toOptim <- function(x, mySim, grid) {
    mySim <- levLabels[mySim]
    xnew <- list()
    xnew$coefficients <- lapply(1L:nc, function(i) {
      ml <- mlen(mySim, grid, loc.id[, i], dire.mat[i, ])
      Rmat <- embed_MC(mySim, grid, loc.id[, i], dire.mat[i, ])
      diag(Rmat) <- -1
      Rmat <- diag(1 / ml) %*% Rmat
      return(Rmat)
    })
    xnew$prop <- table(mySim)
    xnew$prop <- xnew$prop / sum(xnew$prop)
    if(length(unlist(x$coefficients)) != length(unlist(xnew$coefficients))) return(Inf)
    if(length(unlist(x$prop)) != length(unlist(xnew$prop))) return(Inf)
    return(sum((unlist(xnew$coefficients) - unlist(x$coefficients))^2) + sum((xnew$prop - x$prop)^2))
  }
  if(optype == "fullprobs") {
    toOptim <- function(x, mySim, grid) {
      res <- 0
      res <- .C('objfun', nrs = as.integer(nrs), nk = as.integer(nk), nc = as.integer(nc),
         mySim = as.integer(mySim), grid = as.double(grid),
         coef = as.double(unlist(x$coefficients)), prop = as.double(x$prop),
         res = as.double(res), PACKAGE = "spMC")$res
      return(res)
    }
  }
  if(optype == "semiprobs") {
    sknn <- knn + 1L
    storage.mode(sknn) <- "integer"
    if(nrs < sknn) sknn <- nrs
    indicesim <- matrix(0L, nrow = sknn, ncol = nrs)
    indicesim <- matrix(.C('knear', nc = as.integer(nc), nr = as.integer(nrs),
                         coords = as.double(new.grid), nrs = as.integer(nrs),
                         grid = as.double(new.grid), knn = as.integer(sknn),
                         indices = as.integer(indicesim),
                         PACKAGE = "spMC")$indices,
                      nrow = sknn, ncol = nrs)
    sknn <- sknn - 1L
    toOptim <- function(x, mySim, grid) {
      res <- 0
      res <- .C('fastobjfun', knn = as.integer(sknn),
         indices = as.integer(indicesim[-1L, ]), nrs = as.integer(nrs), nk = as.integer(nk),
         nc = as.integer(nc), nr = as.integer(nrs), mySim = as.integer(mySim),
         grid = as.double(grid), coef = as.double(unlist(x$coefficients)),
         prop = as.double(x$prop), data = as.integer(mySim), coords = as.double(grid),
         res = as.double(res), PACKAGE = "spMC")$res
      return(res)
    }
  }
  if(optype == "coordprobs") {
    toOptim <- function(x, mySim, grid) {
      res <- 0
      res <- .C('fastobjfun', knn = as.integer(knn), indices = as.integer(indices),
         nrs = as.integer(nrs), nk = as.integer(nk), nc = as.integer(nc), nr = as.integer(nr),
         mySim = as.integer(mySim), grid = as.double(grid),
         coef = as.double(unlist(x$coefficients)), prop = as.double(x$prop),
         data = as.integer(data), coords = as.double(coords), res = as.double(res),
         PACKAGE = "spMC")$res
      return(res)
    }
  }
  if (max.it > 0 & !(optype %in% c("fullprobs", "semiprobs", "coordprobs"))) {
    loc.id <- apply(dire.mat, 1, function(d) which_lines(grid, d, tolerance = x$tolerance))
  }
  storage.mode(initSim) <- "integer"
  storage.mode(max.it) <- "integer"
  Rnv <- new.env()
  Rnv <- parent.env(Rnv)

  if (!GA) { # SIMULATED ANNEALING #
    old <- .Call("annealingSIM", max.it, initSim, x, grid, quote(toOptim(x, pp, grid)), Rnv, PACKAGE = "spMC")
  }
  else {     # GENETIC ALGORITHM #
    old <- .Call("geneticSIM", max.it, initSim, x, grid, quote(toOptim(x, pp, grid)), Rnv, PACKAGE = "spMC")
  }
  tmpfct <- 1:nk
  tmpfct <- factor(tmpfct, labels = levLabels)
  old <- tmpfct[old]
  res <- data.frame(grid, old, pred, probs)
  names(res) <- c(colnames(coords), "Simulation", "Prediction", levLabels)
  res[path, ] <- res
  attr(res, "type") <- attr(sim, "type")
  class(res) <- c("data.frame", "spsim")
  return(res)
}

getlen <-
function(data, coords, loc.id, direction, zero.allowed = FALSE) {
  # Empirical estimation of lengths (for embeded data)
  #
  #         data vector of data
  #       coords matrix of coordinates
  #       loc.id location Id (which_lines output)
  #    direction vector (or versor) of choosen direction
  # zero.allowed logical, it allows zero stratum lengths

  if (!is.matrix(coords)) coords <- as.matrix(coords)
  storage.mode(coords) <- "double"
  nc <- dim(coords)[2]
  if (length(direction) != nc) stop("wrong length of direction vector")
  if (!is.factor(data)) data <- as.factor(data)
  nk <- nlevels(data)
  n <- length(data)
  if (n != dim(coords)[1]) stop("the number of data is not equal to the number of coordinates")
  if (n != length(loc.id)) stop("length of \"loc.id\" must be equal to the data length")
  storage.mode(loc.id) <- "integer"

  ord <- order(abs(direction), decreasing = TRUE)
  ord <- cbind(loc.id, coords[, ord])
  ord <- lapply(apply(ord, 2, list), unlist)
  ord <- do.call("order", ord)
  data <- data[ord]
  loc.id <- loc.id[ord]
  coords <- coords[ord, ]
  lens <- .C('cEmbedLen', n = as.integer(n), nc = as.integer(nc),
             coords = as.double(coords), locId = as.integer(loc.id),
             data = as.integer(data), cemoc = as.integer(vector("integer", n)),
             maxcens = as.double(vector("numeric", n)), tlen = as.double(vector("numeric", n)),
             PACKAGE = "spMC")[c(1, 6:8)]
  mycenslen <- lens$maxcens[1:lens$n]
  lens$maxcens <- NULL
  lens$categories <- as.factor(levels(data)[lens$cemoc[1:lens$n]])
  lens$length <- lens$tlen[1:lens$n]
  lens$maxcens <- mycenslen
  if (!zero.allowed) {
    idx <- lens$length != 0
    lens$categories <- lens$categories[idx]
    lens$length <- lens$length[idx]
    lens$maxcens <- lens$maxcens[idx]
  }
#   else {
#     lens$length <- lens$length + lens$maxcens
#   }
  lens$direction <- direction
  lens$zeros <- zero.allowed
  lens$cemoc <- NULL
  lens$tlen <- NULL
  lens$n <- NULL
  class(lens) <- "lengths"
  return(lens)
}

persp.multi_tpfit <-
function(x, mpoints, which.dire, max.dist, main, mar, ask = TRUE, col = "white", ...) {
  # 3D-Plot transition probabilities matrices 2D
  # through ellispoidal interpolation
  #
  #          x multi_tpfit object
  #    mpoints number of points per axes
  # which.dire two choosen 1D directions
  #   max.dist vector of maximum distances
  #       main title string
  #        mar vector to pass to par()  
  #        ask boolean to pass to par()
  #        col vector of colors ordered from 1 to 0
  #        ... other args to pass to persp()

  if(!is.multi_tpfit(x)) stop("argument \"x\" must be a 'multi_tpfit' object.")

  nc <- length(x$coefficients)
  nk <- dim(x$coefficients[[1]]$coefficients)[1]

  if (missing(main) || !is.character(main)) main <- "Multidimensional transiogram"
  if (missing(mpoints)) stop("\"mpoints\" is missing")
  if (length(mpoints) != 1) mpoints <- mpoints[1]
  all <- FALSE
  if (missing(which.dire)) all <- TRUE
  if (missing(max.dist)) max.dist <- 1
  if (length(max.dist) == 1) max.dist <- rep(max.dist, nc)
  if (length(max.dist) != nc) 
    stop("\"max.dist\" must be a scalar or vector with the same dimension of coordinates")
  max.dist <- abs(max.dist)

  rawLags <- sapply(max.dist, function(h)
    seq(-h, h, length = mpoints)
  )

  which.dire <- if (all) combn(1:nc, 2) else matrix(which.dire)
  nimg <- dim(which.dire)
  if (nimg[1] != 2) stop("wrong length of \"which.dire\"")

  ly <- matrix(c(rep(1, nk), nk^2+(1:nk)+2, 2:(nk^2+1), rep(0, nk), rep(nk^2+2, nk)), ncol = nk, byrow = TRUE)
  yl <- c(rep(0, nk + 4))
  yl1 <- c(rep(0, 2), (nk+1)*nk+2+(1:nk), rep(0, 2))
  ly <- cbind(yl, yl1, ly, yl, yl)
  widths <- c(rep(4 - 0.5 * nk, 2), rep(30/nk, nk), rep(4 - 0.5 * nk, 2)) / 4
  heights <- c(0.75, 1/3.5, rep(7.5/nk, nk), 2/3.5, 1)
  ly <- layout(ly, widths = widths, heights = heights, respect = TRUE)

  nomi <- names(x$prop)
  if (missing(mar) || !is.numeric(mar)) {
    mar <- sum(c(0, 1, 0, -0.5, -0.2, rep(0, 4), 0.2, rep(c(-0.1, rep(0, 3)), 2), 0)[1:nk])
    mar <- rep(mar, 4)
  }
  else {
    if (length(mar) < 4) {
      mar <- rep(mar[1], 4)
    }
    else {
      mar <- mar[1:4]
    }
  }

  for (i in 1:nimg[2]) {
    lagsMat <- as.list(rep(0, nc))
    lagsMat[[which.dire[1, i]]] <- rawLags[, which.dire[1, i]]
    lagsMat[[which.dire[2, i]]] <- rawLags[, which.dire[2, i]]
    lagsMat <- as.matrix(expand.grid(lagsMat))
    Tprobs <- predict(x, lagsMat)
    if (ask && all && (nimg[2] > 1)) {
      devAskNewPage(TRUE)
      on.exit(devAskNewPage(FALSE))
    }

    par(mar = c(0.3, 0.1, 0.3, 0.1))
    plot.new()
    title <- paste(main, " (", x$coordsnames[which.dire[1, i]], ", ", x$coordsnames[which.dire[2, i]], ")", sep = "")
    text(0.5, 0.5, labels = title, cex = 2)

    par(mar = mar)
    for (j in 1:nk) {
      for (k in 1:nk) {
        zzz <- t(matrix(rev(Tprobs$Tmat[j, k, ]), mpoints, mpoints))
        colid <- 1
        if (length(col) > 1) {
          colth <- seq(1 / length(col), 1, length.out = length(col))
          colid <- sapply(zzz, function(xx) sum(xx < colth))
          dim(colid) <- dim(zzz)
          colid <- colid[-1, -1]
          zlim <- range(zzz, na.rm = TRUE)
        }
        else {
          zlim <- 0:1
        }

        persp(rawLags[, which.dire[1, i]], rawLags[, which.dire[2, i]],
              zzz, col = rev(col)[colid], zlab = "", zlim = zlim,
              xlab = x$coordsnames[which.dire[1, i]], 
              ylab = x$coordsnames[which.dire[2, i]], ...) #sub = paste(nomi[j], "to", nomi[k])

#        box()
#        if (k == 1) axis(2)
#        if (k == nk) axis(4, 0, labels = nomi[j], tick = FALSE, font = 3)
#        if (j == nk) axis(1)
#        if (j == 1) axis(3, 0, labels = nomi[k], tick = FALSE, font = 3)
      }
    }

    par(mar = c(2.2, 0.1, 1.2, 0.1))
    if (length(col) > 1) {
      image(matrix(colth, ncol = 1), col = col, main="Legend", axes = FALSE)
      box()
      axis(1)
    }
    else {
      plot.new()
    }
    par(mar = c(0.1, 0.1, 0.1, 0.1))
    for (j in c(0, 90)) {
      for (lbls in nomi) {
        plot.new()
        text(0.5, 0.5, labels = lbls, srt = j, font = 3)
      }
    }
  }

}

density.lengths <-
function (x, ..., log = FALSE, zeros.rm = TRUE) {
  zrs <- x$zeros
  newlen <- x$length + 0
  if (zeros.rm & x$zeros) {
    newlen <- x$length + x$maxcens
    zrs <- FALSE
  }
  res <- tapply(newlen, x$categories, function (Lengths) {
                xx <- log(Lengths + .Machine$double.eps * zrs)
                from <- min(xx)
                to <- max(xx)
                res <- density(xx, ..., from = from, to = to)
                if (!log) {
                  res$x <- (exp(res$x) - .Machine$double.eps * zrs)
                  res$y <- res$y / res$x
                }
                return(res)})
  res$direction <- x$direction
  res$log <- log
  class(res) <- "density.lengths"
  return(res)
}

print.tpfit <-
function(x, ...) {
  cat("Estimated transition rates:\n\n")
  print(unclass(x$coefficients), ...)
  cat("\n")
  if (!is.null(x$prop)) {
    cat("Estimated proportions:\n\n")
    proportions <- as.vector(x$prop)
    names(proportions) <- names(x$prop)
    print(proportions, ...)
    cat("\n")
  }
  invisible(x)
}

setCores <-
function(n) {
  # Set number of CPU cores which will be used by the package
  #
  #     n number of CPU cores

  if (!missing(n)) {
    if (is.numeric(n)) {
      n <- as.integer(ceiling(n))
      n <- .C('setNumSlaves', n = as.integer(n), PACKAGE = "spMC")$n
    }
  }
  n <- 0L
  crTot <- 0L
  n <- .C('getNumSlaves', n = as.integer(n), PACKAGE = "spMC")$n
  if (n == 1L) {
    if (.Call("isOmp", PACKAGE = "spMC")) packageStartupMessage("Parallel computation will not perform. CPU cores in use: 1.")
  }
  else if (n > 1L){
    crTot <- .C('getNumCores', n = as.integer(crTot), PACKAGE = "spMC")$n
    packageStartupMessage("Parallel computation will perform.")
    packageStartupMessage("  Total CPU cores available: ", crTot, ".", sep = "")
    packageStartupMessage("  CPU cores in use: ", n, ".", sep = "")
  }
  invisible(n)
}

mlen <-
function(data, coords, loc.id, direction, mle = "avg") {
  # Empirical estimation mean-lengths (for embeded data)
  #
  #      data vector of data or 
  #    coords matrix of coordinates
  #    loc.id location Id (which_lines output)
  # direction vector (orres versor) of choosen direction
  #       mle string of characters, 
  #           if "mlk" the MLEs will be returned (log-normal distro assumed)
  #           it can be logical for backward compatibility reasons

  mle <- mle[1L]
  if (is.logical(mle)) {
    mle <- ifelse(mle, "mlk", "avg") 
  }
  else {
    if (is.character(mle)) {
      if (!mle %in% c("avg", "mlk", "trm", "mdn")) mle <- "avg"      
    }
    else {
      mle <- "avg"
    }
  }
  # Mean-Length Estimation via method of moments (averaging)
  if (mle == "avg") {
    gl <- getlen(data, coords, loc.id, direction, zero.allowed = TRUE)
    meanlen <- tapply(gl$length + gl$maxcens, gl$categories, mean)
  }
  # Mean-Length Estimation via maximum likelihood (log-normal distribution)
  if (mle == "mlk") {
    gl <- getlen(data, coords, loc.id, direction, zero.allowed = TRUE)
    nk <- nlevels(data)
    if (length(data) < nk) stop("there are not enough data to estimate the parameters")
    param <- vector("numeric", 2 * nk)
    gl$categories <- as.integer(gl$categories)

    NegLik <- function(param) {
      pus <- plnorm(gl$length + gl$maxcens, meanlog = param[gl$categories],
                    sdlog = exp(param[gl$categories + nk]))
      pls <- plnorm(gl$length, meanlog = param[gl$categories],
                    sdlog = exp(param[gl$categories + nk]))
      return(- sum(log(abs(pus - pls) + .Machine$double.neg.eps)))
    }

    res <- nlminb(param, NegLik, lower = -Inf, upper = Inf)
    message("Optimization message: ", res$message, sep = "")
    meanlen <- exp(res$par[1:nk] + 0.5 * exp(2 * res$par[(nk + 1):(2 * nk)]))
  }
# Mean-Length Estimation via trimmed averaging
  if (mle == "trm") {
    gl <- getlen(data, coords, loc.id, direction, zero.allowed = FALSE)
    meanlen <- tapply(gl$length, gl$categories, mean)
  }
# Mean-Length Estimation via trimmed median calculation
  if (mle == "mdn") {
    gl <- getlen(data, coords, loc.id, direction, zero.allowed = TRUE)
    meanlen <- tapply(gl$length + gl$maxcens, gl$categories, median)
  }
  iiff <- is.finite(meanlen)
  zzzz <- meanlen[iiff] <= 0
  if (!all(iiff) || any(zzzz)) {
    stdlen <- apply(coords, 2, function(x) mean(diff(sort(unique(x)))))
    stdlen <- sqrt(sum(abs(direction) / sqrt(sum(direction^2)) * stdlen^2))
    meanlen[!iiff] <- stdlen
    meanlen[iiff][zzzz] <- stdlen
  }
  return(meanlen)
}

print.transiogram <-
function(x, ...) {
  mylen <- length(x$lags)
  for(i in 1:mylen) {
    cat(x$type, "transition probabilities at lag:", x$lags[i], "\n\n")
    print(x$Tmat[,,i], ...)
    if(i != mylen) cat("\n")
  }
  invisible(x)
}

is.multi_transiogram <-
function(object) {
  if(!is(object, "multi_transiogram")) return(FALSE)
  if(!prod(c("lags", "type", "Tmat") %in% names(object))) return(FALSE)
  if(length(names(object)) != 3) return(FALSE)
  if(!is.array(object$Tmat)) return(FALSE)
  if(!is.numeric(object$lags)) return(FALSE)
  if(!is.character(object$type)) return(FALSE)
  if(object$type != "Empirical" && object$type != "Theoretical") return(FALSE)
  return(TRUE)
}

hist.lengths <-
function (x, ..., log = FALSE, zeros.rm = TRUE) {
  newlen <- x$length + 0
  if (zeros.rm & x$zeros) {
    newlen <- x$length + x$maxcens
  }
  args <- list(...)
  breaks <- "Sturges"
  if (!is.null(args$breaks)) breaks <- args$breaks
  include.lowest <- TRUE
  if (!is.null(args$include.lowest)) include.lowest <- args$include.lowest
  right <- TRUE
  if (!is.null(args$right)) right <- args$right
  res <- tapply(newlen, x$categories, function(Lengths) {
           if (log) {
             LogLengths <- log(Lengths)
             hist(LogLengths, breaks = breaks, include.lowest = include.lowest,
                  right = right, plot = FALSE)
           }
           else {
             hist(Lengths, breaks = breaks, include.lowest = include.lowest,
                  right = right, plot = FALSE)
           }
         })
  res$direction <- x$direction
  res$log <- log
  class(res) <- "hist.lengths"
  plot <- TRUE
  if (!is.null(args$plot)) plot <- args$plot
  if (plot) {
    plot(res, ...)
    return(invisible(res))
  }
  if (!plot) return(res)
}

predict.multi_tpfit <-
function(object, lags, byrow=TRUE, ...) {
  # Transition probabilities prediction for spatial Markov Chain in nD
  #
  #    lags vector or matrix of lags
  #  object list with a matrix of estimated transition rates

  res <- list()
  class(res) <- "multi_transiogram"
  res$type <- "Theoretical"

  nc <- length(object$coefficients)
  if (is.vector(lags)) {
    if (nc != length(lags)) stop ("wrong the length of \"lags\"")
    lags <- matrix(lags, nrow = nc)
  }
  else {
    if (!is.matrix(lags)) stop ("\"lags\" must be a matrix or a vector")
    lags <- if (byrow) { t(lags) } else { lags }
    if (dim(lags)[1] != nc) stop ("wrong number of ", ifelse(byrow, "columns", "rows"))
  }
  storage.mode(lags) <- "double"

  nk <- length(object$prop)
  nr <- dim(lags)[2]

  coefficients <- unlist(object$coefficients)
  res$Tmat <- array(0, dim = c(nk, nk, nr))

  if (!is.null(object$rotation)) {
    dire.mat <- diag(, nc)
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(object$rotation), 
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- t(matrix(dire.mat, nc, nc))
    rotlags <- .C('fastMatProd', nr = as.integer(nc), ni = as.integer(nc),
                  mat1 = as.double(dire.mat), nc = as.integer(nr), mat2 = as.double(lags),
                  res = as.double(vector("numeric", prod(dim(lags)))),
                  PACKAGE = "spMC")$res
    res$Tmat <- .C('predMULTI', coefficients = as.double(coefficients),
                   prop = as.double(object$prop), lags = as.double(rotlags),
                   nk = as.integer(nk), nc = as.integer(nc), nr = as.integer(nr),
                   mypred = as.double(res$Tmat), PACKAGE = "spMC")$mypred
  }
  else {
    res$Tmat <- .C('predMULTI', coefficients = as.double(coefficients),
                   prop = as.double(object$prop), lags = as.double(lags),
                   nk = as.integer(nk), nc = as.integer(nc), nr = as.integer(nr),
                   mypred = as.double(res$Tmat), PACKAGE = "spMC")$mypred
  }

  res$Tmat <- array(res$Tmat, dim = c(nk, nk, nr))
  colnames(res$Tmat) <- rownames(res$Tmat) <- names(object$prop)
  res$lags <- t(lags)
  return(res)
}

is.pemt <-
function(object) {
  if(!is(object, "pemt")) return(FALSE)
  len <- length(object)
  nomi <- sapply(object, names)
  if(!all(unlist(sapply(nomi[1:(len - 1)], "%in%", c("Tprobs", "Eprobs", "X", "Y"))))) return(FALSE)
  if(!all(nomi[[len]] %in% c("nk", "nomi", "coordsnames", "mpoints", "which.dire"))) return(FALSE)
  if (!all(sapply(object[1:(len - 1)], function(xx) is.multi_transiogram(xx$Tprobs) | is.null(xx$Tprobs)))) return(FALSE)
  return(TRUE)
}

tpfit_me <-
function(data, coords, direction, tolerance = pi/8, max.it = 9000, mle = "avg") {
  # Estimation for matrix of transition rates 
  #    ( Maximum Entropy Method )
  #
  #       data vector of data
  #     coords coordinates matrix
  #  direction vector (or versor) of choosen direction
  #     max.it maximum number of iterations for the optimization
  #  tolerance angle tolerance (in radians)
  #        mle argument to pass to the function tpfit

  if (!is.matrix(coords)) coords <- as.matrix(coords)
  n <- dim(coords)[1]
  nc <- dim(coords)[2]
  if (length(direction) != nc) stop("wrong length of direction vector")
  if (!is.factor(data)) data <- as.factor(data)
  nl <- nlevels(data)
  storage.mode(max.it) <- "integer"
  if (n < (nl^2 + nl)) stop("there are not enough data to estimate the parameters")

  proportion <- table(data)
  proportion <- proportion / sum(proportion)

  loc.id <- which_lines(coords, direction, tolerance)
  ml <- mlen(data, coords, loc.id, direction, mle)

  s <- c(proportion) / c(ml)
  fnew <- vector("numeric", nl)
  fnew <- .C('cEmbFrq', s = as.double(s), nk = as.integer(nl), mt = as.integer(max.it),
             eps = as.double(.Machine$double.eps), f = as.double(fnew),
             PACKAGE = "spMC")$f

  Fmat <- outer(fnew, fnew)
  diag(Fmat) <- 0
  Rmat <- diag(1 / (ml * apply(Fmat, 2, sum))) %*%  Fmat
  diag(Rmat) <- -apply(Rmat, 1, sum)

  res <- list()
  res$coefficients <- Rmat
  res$prop <- as.double(proportion)
  names(res$prop) <- levels(data)
  colnames(res$coefficients) <- names(res$prop)
  rownames(res$coefficients) <- names(res$prop)
  res$tolerance <- as.double(tolerance)

  class(res) <- "tpfit"
  return(res)
}

plot.hist.lengths <-
function (x, ...) {
  args <- list(...)
  nk <- length(x) - 2
  nomi <- names(x)[1:nk]
  mr <- ceiling(sqrt(nk))
  mc <- floor(mr - nk / mr)
  ly <- matrix(c(rep(1, mr), rep(0, mr), 2:(mr^2+1)), ncol = mr, byrow = TRUE)
  yl <- c(rep(0, mr + 2))
  ly <- cbind(yl, ly, yl)[, -(2+mr+1-mc)]
  widths <- c(rep(2 - 0.5 * mr, 1), rep(30/mr, mr), rep(4 - 0.5 * mr, 1)) / 4
  heights <- c(0.75, 1/3.5, rep(7.5/mr, mr-mc))
  ly <- layout(ly, widths = widths, heights = heights, respect = TRUE)
  mar <- sum(c(0, 1, 0, -0.5, -0.2, rep(0, 4), 0.2, rep(c(-0.1, rep(0, 3)), 2), 0)[1:mr])
  mar <- rep(mar, 4)
  par(mar = mar)
  plot.new()
  if (!is.null(args$main)) { title <- args$main } else {
    title <- "Histograms of stratum "
    if (x$log) title <- paste(title, "log-", sep = "")
    title <- paste(title, "lengths - Direction (", 
                   round(x$direction[1], 2), sep = "")
    if (length(x$direction) > 1) {
      for (i in 2:length(x$direction))
        title <- paste(title, round(x$direction[i], 2), sep = ", ")
    }
    title <- paste(title, ")", sep = "")
  }
  text(0.5, 0.5, labels = title, cex = 2)
  warn <- options("warn")$warn
  options("warn" = -1)
  for (i in 1:nk) {
    par(mar = c(5, 4, 3, 1))
    plot(x[[i]], ..., main = nomi[i])
  }
  options("warn" = warn)
}

print.density.lengths <-
function (x, digits = NULL, ...) {
  nk <- length(x) - 2
  nomi <- names(x)
  for (i in 1:nk) {
    cat("\n\tCategory ", nomi[i], "\n", sep = "")
    cat("\nData: Lengths", " (", x[[i]]$n, " obs.)", "\nLog-Bandwidth 'bw' = ",
        formatC(x[[i]]$bw, digits = digits), "\n\n", sep = "")
    print(summary(as.data.frame(x[[i]][c("x", "y")])), digits = digits, ...)
  }
  invisible(x)
}

pkgname <- "spMC"
source(file.path(R.home("share"), "R", "examples-header.R"))
options(warn = 1)
library('spMC')
set.seed(0)

assign(".oldSearch", search(), pos = 'CheckExEnv')
cleanEx()
nameEx("All-spMC")
flush(stderr()); flush(stdout())

### Name: setCores
### Title: Set the number of CPU cores for HPC
### Aliases: setCores
### Keywords: programming

### ** Examples

#Set 2 CPU cores for parallel computation
setCores(2)

### Name: ACM
### Title: ACM Data
### Aliases: ACM
### Keywords: datasets

### ** Examples

data(ACM)
str(ACM)
summary(ACM)

### Name: boxplot.lengths
### Title: Stratum Lengths Boxplot
### Aliases: boxplot.lengths
### Keywords: spatial distribution hplot

### ** Examples

direction <- c(0,0,1)

# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)

# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Make the boxplot of the object gl
par(mfrow = c(1, 1))
boxplot(gl)
graphics::par(get("par.postscript", pos = 'CheckExEnv'))

### Name: sim_ck
### Title: Conditional Simulation Based on Indicator Cokriging
### Aliases: sim_ck
### Keywords: spatial distribution

### ** Examples

data(ACM)
# Estimate transition rates matrices and 
# proportions for the categorical variable MAT5
x <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Generate the simulation grid
mygrid <- list()
mygrid$X <- seq(min(ACM$X), max(ACM$X), length = 3)
mygrid$Y <- seq(min(ACM$Y), max(ACM$Y), length = 3)
mygrid$Z <- -180 * 0:2 - 1
mygrid <- as.matrix(expand.grid(mygrid$X, mygrid$Y, mygrid$Z))

# Simulate the random field through
# Simple Indicator Cokriging algorithm and
myANSimP <- sim_ck(x, ACM$MAT5, ACM[, 1:3], mygrid)
myANSimE <- sim_ck(x, ACM$MAT5, ACM[, 1:3], mygrid, entropy = TRUE)

# Simulate the random field through
# Ordinary Indicator Cokriging algorithm and
myGASimS <- sim_ck(x, ACM$MAT5, ACM[, 1:3], mygrid, ordinary = TRUE)
myGASimE <- sim_ck(x, ACM$MAT5, ACM[, 1:3], mygrid, ordinary = TRUE, entropy = TRUE)

### Name: density.lengths
### Title: Empirical Densities Estimation of Stratum Lengths
### Aliases: density.lengths
### Keywords: spatial distribution

### ** Examples

# Compute the empirical densities of stratum lengths
dgl <- density(gl)

### Name: embed_MC
### Tested in multi_tpfit() during the boxplot.lengths() example

### Name: getlen
### Tested during the boxplot.lengths() example

### Name: hist.lengths
### Title: Histograms of Stratum Lengths for Each Observed Category
### Aliases: hist.lengths
### Keywords: spatial distribution hplot

### ** Examples

# Plot the histograms
hist(gl)

### Name: sim_ik
### Title: Conditional Simulation Based on Indicator Kriging
### Aliases: sim_ik
### Keywords: spatial distribution

### ** Examples

# Simulate the random field through
# Simple Indicator Kriging algorithm and
# optimize by Simulated Annealing
myANSimE <- sim_ik(x, ACM$MAT5, ACM[, 1:3], mygrid, ordinary = FALSE, entropy = TRUE)
myANSimP <- sim_ik(x, ACM$MAT5, ACM[, 1:3], mygrid, ordinary = FALSE)
myANSimF <- quench(x, ACM$MAT5, ACM[, 1:3], myANSimP, optype = "fullprobs", max.it = 2)
myANSimP <- quench(x, ACM$MAT5, ACM[, 1:3], myANSimP, optype = "param", max.it = 2)

# Simulate the random field through
# Ordinary Indicator Kriging algorithm and
# optimize by Genetic Algorithm
myGASimS <- sim_ik(x, ACM$MAT5, ACM[, 1:3], mygrid)
myGASimE <- sim_ik(x, ACM$MAT5, ACM[, 1:3], mygrid, entropy = TRUE)
myGASimS <- quench(x, ACM$MAT5, ACM[, 1:3], myGASimS, GA = TRUE, optype = "semiprobs", max.it = 2)
myGASimC <- quench(x, ACM$MAT5, ACM[, 1:3], myGASimS, GA = TRUE, optype = "coordprobs", max.it = 2)

### Name: tpfit_ils
### It will be tested during the multi_tpfit_ils() example

### Name: image.multi_tpfit
### Title: Images with Multidimensional Transiograms
### Aliases: image.multi_tpfit
### Keywords: spatial distribution hplot

### ** Examples

# Set short names for categories 3 and 4
names(x$prop)[3:4] <- c("Clay and Sand", "Gravel and Sand")

# Plot 2-D theoretical sections of
# a multidimensional transiogram
image(x, 3, max.dist=c(20,10,5), which.dire=2:3,
      mar = .7, col=rev(heat.colors(500)),
      breaks=0:500/500, nlevels = 5)

# 3D-Plot for a 2-D theoretical sections of
# a multidimensional transiogram
persp(x, 3, max.dist=c(20,10,5), which.dire=2:3,
      mar = .7, col=rev(heat.colors(500)))

### Name: image.pemt (is.pemt)
### Title: Images with Pseudo-empirical Multidimensional Transiograms
### Aliases: imgMultiTransiogram
### Keywords: spatial distribution hplot

### ** Examples

# Compute a 2-D section of a pseudo-empirical
# multidimensional transiogram
psEmpTr <- pemt(ACM$MAT3, ACM[, 1:3], 2,
                max.dist = c(20, 10, 5), 
                which.dire=c(1, 3), 
                mle = TRUE)

# Contour plots of 2-D pseudo-empirical 
# sections of multidimensional transiograms
contour(psEmpTr, mar = .7)

# Plot 2-D pseudo-empirical sections of
# a multidimensional transiogram
image(psEmpTr, col = rev(heat.colors(500)), 
      breaks = 0:500 / 500, mar = .7)

# 3D-Plot for a 2-D pseudo-empirical sections of
# a multidimensional transiogram
persp(psEmpTr, col = rainbow(500), mar = .7,
      theta = 15, phi = 45)

# Test the object psEmpTr
is.pemt(psEmpTr)

### Name: is.lengths
### Title: Object test for lengths class
### Aliases: is.lengths
### Keywords: spatial attribute

### ** Examples

# Test the object gl
is.lengths(gl)

### Name: is.multi_tpfit
### Title: Object test for multi_tpfit class
### Aliases: is.multi_tpfit
### Keywords: spatial attribute

### ** Examples

# Test the object x
is.multi_tpfit(x)

### Name: is.multi_transiogram
### Title: Object test for multi_transiogram class
### Aliases: is.multi_transiogram
### Keywords: spatial attribute

### ** Examples

# Generate the matrix of 
# multidimensional lags
lags <- expand.grid(X=-1:1, Y=-1:1, Z=-1:1)
lags <- as.matrix(lags)

# Compute transition probabilities 
# from the multidimensional MC model
TrPr <- predict(x, lags)

# Test the object TrPr
is.multi_transiogram(TrPr)

### Name: is.tpfit
### Title: Object test for tpfit class
### Aliases: is.tpfit
### Keywords: spatial attribute

### ** Examples

# Estimate the parameters of a 
# one-dimensional MC model
MoPa <- tpfit(ACM$PERM, ACM[, 1:3], c(0, 0, 1))

# Test the object MoPa
is.tpfit(MoPa)

### Name: is.transiogram
### Title: Object test for transiogram class
### Aliases: is.transiogram
### Keywords: spatial attribute

### ** Examples

# Compute theoretical transition probabilities 
# from the one-dimensional MC model
TTPr <- predict(MoPa, lags = 0:2/2)

# Compute empirical transition probabilities 
ETPr <- transiogram(ACM$MAT5, ACM[, 1:3], c(0, 0, 1), 200, 20, reverse = TRUE)

# Test the objects TTPr and ETPr
is.transiogram(TTPr)
is.transiogram(ETPr)

### Name: sim_mcs
### Title: Multinomial Categorical Simulation
### Aliases: sim_mcs
### Keywords: spatial distribution

### ** Examples

# Simulate the random field
myMCSim <- sim_mcs(x, ACM$MAT5, ACM[, 1:3], mygrid)
myMCSiE <- sim_mcs(x, ACM$MAT5, ACM[, 1:3], mygrid, entropy = TRUE)

### Name: metpfit
### It will be tested during the multi_tpfit_me() example

### Name: mixplot
### Title: Plot of Multiple One-dimensional Transiograms
### Aliases: mixplot
### Keywords: spatial distribution hplot

### ** Examples

# Estimate empirical transition 
# probabilities by points
ETr <- transiogram(ACM$MAT3, ACM[, 1:3], c(0, 0, 1), 100)

# Estimate the transition rate matrix
RTm <- tpfit(ACM$MAT3, ACM[, 1:3], c(0, 0, 1))

# Compute transition probabilities 
# from the one-dimensional MC model
TPr <- predict(RTm, lags = ETr$lags)

# Plot empirical vs. theoretical transition probabilities
mixplot(list(ETr, TPr), type = c("p", "l"), pch = "+", col = c(3, 1))

### Name: mlen
### Tested in multi_tpfit() during the boxplot.lengths() example

### Name: multi_tpfit_ils
### Title: Iterated Least Squares Method for Multidimensional Model
###   Parameters Estimation
### Aliases: multi_tpfit_ils
### Keywords: spatial distribution models

### ** Examples

# Estimate the parameters of a 
# multidimensional MC model
multi_tpfit_ils(ACM$MAT3, ACM[, 1:3], 200)

### Name: multi_tpfit_me
### Title: Maximum Entropy Method for Multidimensional Model Parameters
###   Estimation
### Aliases: multi_tpfit_me
### Keywords: spatial distribution models

### ** Examples

# Estimate transition rates matrices and
# proportions for the categorical variable MAT3
multi_tpfit_me(ACM$MAT3, ACM[, 1:3], mle = "mdn")

### Name: multi_tpfit
### Tested during the sim_ck() example

### Name: sim_path
### Title: Conditional Simulation Based on Path Algorithms
### Aliases: sim_path
### Keywords: spatial distribution

### ** Examples

# Simulate the random field through
# the fixed path algorithm
myFixPathSim <- sim_path(x, ACM$MAT5, ACM[, 1:3], mygrid,
                         radius = 50, fixed = TRUE)
myFixPathSiE <- sim_path(x, ACM$MAT5, ACM[, 1:3], mygrid,
                         radius = 50, fixed = TRUE, entropy = TRUE)

# Simulate the random field through
# the random path algorithm
myRndPathSim <- sim_path(x, ACM$MAT5, ACM[, 1:3], mygrid, radius = 50)
myRndPathSiE <- sim_path(x, ACM$MAT5, ACM[, 1:3], mygrid, radius = 50, entropy = TRUE)

### Name: plot.density.lengths
### Title: Plot Empirical Densities Estimates of Stratum Lengths
### Aliases: plot.density.lengths
### Keywords: spatial distribution hplot

### ** Examples

# Plot the empirical densities of stratum log-lengths
plot(dgl)

### Name: plot.hist.lengths
### Title: Plot Histograms of Stratum Lengths
### Aliases: plot.hist.lengths
### Keywords: spatial distribution hplot

### ** Examples

# Compute the histograms
hgl <- hist(gl, plot = FALSE)

# Plot the histograms
plot(hgl, col = "#efffef")

### Name: plot.lengths
### Title: Plot Stratum Lengths
### Aliases: plot.lengths
### Keywords: spatial distribution hplot

### ** Examples

# Plot the object gl
par(mfrow = c(1,1))
plot(gl)
graphics::par(get("par.postscript", pos = 'CheckExEnv'))

### Name: plot.transiogram
### Title: Plot One-dimensional Transiograms
### Aliases: plot.transiogram
### Keywords: spatial distribution hplot

### ** Examples

# Plot empirical transition probabilities with confidence interval
plot(ETr, type = "l", ci = .95)

# Plot theoretical transition probabilities
plot(TPr, type = "l")

### Name: predict.multi_tpfit
### Tested during the is.multi_transiogram() example

### Name: predict.tpfit
### Tested during the is.transiogram() example

### Name: print.density.lengths
### Title: Printing Empirical Densities Estimates of Stratum Lengths
### Aliases: print.density.lengths
### Keywords: spatial distribution

### ** Examples

# Print the empirical densities of stratum lengths
print(dgl)

### Name: print.lengths
### Title: Printing Stratum Lengths for Each Observed Category
### Aliases: print.lengths
### Keywords: spatial

### ** Examples

# Print stratum lengths
print(gl)

### Name: print.multi_tpfit
### Title: Printing Model Parameters for Multidimensional Continuos Lag
###   Spatial MC
### Aliases: print.multi_tpfit
### Keywords: spatial

### ** Examples

# Print results
print(x)

### Name: print.multi_transiogram
### Title: Printing Theoretical Multidimensional Transiograms
### Aliases: print.multi_transiogram
### Keywords: spatial

### ** Examples

# Print results
print(TrPr)

### Name: print.summary.lengths
### Title: Printing Stratum Lengths Summary for Each Observed Category
### Aliases: print.summary.lengths
### Keywords: spatial distribution

### ** Examples

# Summarize the stratum lengths
sgl <- summary(gl)

# Print the summary of stratum lengths
print(sgl)

### Name: print.tpfit
### Title: Printing Model Parameters for One-dimensional Continuos Lag
###   Spatial MC
### Aliases: print.tpfit
### Keywords: spatial

### ** Examples

# Print results
 
### Name: print.transiogram
### Title: Printing Theoretical or Empirical One-dimensional Transiograms
### Aliases: print.transiogram
### Keywords: spatial

### ** Examples

# Print results
print(TTPr)
print(ETPr)

rownames(ETPr$Tmat) <- c("Clay", "Gravel", "Sand and Clay", "Sand and Gravel", "Sand")
colnames(ETPr$Tmat) <- rownames(ETPr$Tmat)
plot(ETPr, type = "l")


### Name: summary.lengths
### Tested during the print.summary.lengths() example

### Name: tpfit
### Tested in multi_tpfit() during the boxplot.lengths() example

### Name: transiogram
### Tested during the is.transiogram() example

### Name: which_lines
### Tested during the boxplot.lengths() example

### * <FOOTER>
###
cat("Time elapsed: ", proc.time() - get("ptime", pos = 'CheckExEnv'),"\n")
grDevices::dev.off()
###
### Local variables: ***
### mode: outline-minor ***
### outline-regexp: "\\(> \\)?### [*]+" ***
### End: ***
quit('no')

tpfit <-
function(data, coords, direction, method = "ml", tolerance = pi/8, max.it = 9000, mle = "avg", ...) {
  # Estimation for matrix of transition rates
  #
  #       data vector of data
  #     coords coordinates matrix
  #  direction vector (or versor) of choosen direction
  #     method estimation method c("ml", "ils", "me")
  #  tolerance angle tolerance (in radians)
  #     max.it maximum number of iterations for the optimization (used only for the 'me' method)
  #        mle argument to pass to the function mlen (not used for the 'ils' method)
  #        ... further arguments to pass to tpfit_ils function, such as:
  #    #     * max.dist maximum distance for counting
  #    #     *  mpoints number of lags
  #    #     *        q constant greater than one controlling the growth of rho
  #    #     *     echo logical value to print the optimization output
  #    #     *      ... further arguments to pass to nlminb function
  #    #     *    tpfit tpfit object for a further optimization

  if (method == "ils") return(tpfit_ils(data = data, coords = coords, direction = direction, tolerance = tolerance, ...))
  if (method == "me") return(tpfit_me(data, coords, direction, tolerance, max.it, mle))
  if (method != "ml") warning("Estimation method not recognized. Mean length method (\"ml\") set by default.")

  return(tpfit_ml(data, coords, direction, tolerance, mle))
}

"sim" <- 
function(x, data, coords, grid, method = "ik", ..., entropy = FALSE) {
  # Generation of conditional simulation based on user specified method
  #
  #         x a multi.tpfit object
  #      data vector of data
  #    coords coordinates matrix
  #      grid simulation points
  #    method method to perform prediction and simulation c("ik", "ck", "path", "mcs")
  #       ... further option to pass to the function sim_*
  #   entropy logical value to compute uncertainties

  # Further arguments for Indicator Kriging (ik) and coKriging (ck)
  #      knn number of k-nearest neighbours
  # ordinary boolean (if TRUE ordinary Kriging is applied rather than simple Kriging)
  #       GA boolean (if TRUE genetic algorithm is applied rather than simulated annealing)
  #   optype character with the objective function to minimize after the simulation
  #   max.it maximum number of iteration for the optimization method

  # Further arguments for Fixed and Random Path methods (path)
  # radius radius to find neighbour points
  #  fixed boolean for random or fixed path algorithm

  # Further arguments for Multinomial Categorical Simulation (mcs)
  #    knn number of k-nearest neighbours (if NULL all data are neighbours)
  # radius radius to find neighbour points

  if (method == "ck") return(sim_ck(x, data, coords, grid, ...))
  if (method == "path") return(sim_path(x, data, coords, grid, ...))
  if (method == "mcs") return(sim_mcs(x, data, coords, grid, ...))
  if (method != "ik") warning("Simulation method not recognized. Indicator Kriging method (\"ik\") set by default.")
  return(sim_ik(x, data, coords, grid, ..., entropy = entropy))
}

persp.pemt <-
function(x, main, mar, ask = TRUE, col = "white", ...) {

  # 3D-Plot transition probabilities matrices 2D
  # through no ellispoidal interpolation
  #
  #          x object return by the function pemt()
  #       main title string
  #        mar vector to pass to par()  
  #        ask boolean to pass to par()
  #        col vector of colors ordered from 1 to 0
  #        ... other args to pass to image()

  ix <- length(x)
  nk <- x[[ix]]$nk
  mpoints <- x[[ix]]$mpoints
  coordsnames <- x[[ix]]$coordsnames
  nomi <- x[[ix]]$nomi

  if (missing(main) || !is.character(main)) main <- "Multidirectional transiogram"
  which.dire <- x[[ix]]$which.dire
  nimg <- dim(which.dire)

  ly <- matrix(c(rep(1, nk), nk^2+(1:nk)+2, 2:(nk^2+1), rep(0, nk), rep(nk^2+2, nk)), ncol = nk, byrow = TRUE)
  yl <- c(rep(0, nk + 4))
  yl1 <- c(rep(0, 2), (nk+1)*nk+2+(1:nk), rep(0, 2))
  ly <- cbind(yl, yl1, ly, yl, yl)
  widths <- c(rep(4 - 0.5 * nk, 2), rep(30/nk, nk), rep(4 - 0.5 * nk, 2)) / 4
  heights <- c(0.75, 1/3.5, rep(7.5/nk, nk), 2/3.5, 1)
  ly <- layout(ly, widths = widths, heights = heights, respect = TRUE)
  
  if (missing(mar) || !is.numeric(mar)) {
    mar <- sum(c(0, 1, 0, -0.5, -0.2, rep(0, 4), 0.2, rep(c(-0.1, rep(0, 3)), 2), 0)[1:nk])
    mar <- rep(mar, 4)
  }
  else {
    if (length(mar) < 4) {
      mar <- rep(mar[1], 4)
    }
    else {
      mar <- mar[1:4]
    }
  }

  oldcontour <- contour
  storage.mode(which.dire) <- "integer"

  for (i in 1:nimg[2]) {
    if (ask && (nimg[2] > 1)) {
      devAskNewPage(TRUE)
      on.exit(devAskNewPage(FALSE))
    }

    par(mar = c(0.3, 0.1, 0.3, 0.1))
    plot.new()
    title <- paste(main, " (", coordsnames[which.dire[1, i]], ", ", coordsnames[which.dire[2, i]], ")", sep = "")
    text(0.5, 0.5, labels = title, cex = 2)

    par(mar = mar)
    for (j in 1:nk) {
      for (k in 1:nk) {
        zzz <- t(matrix(rev(x[[i]]$Eprobs[j, k, ]), mpoints, mpoints))
        colid <- 1
        if (length(col) > 1) {
          colth <- seq(1 / length(col), 1, length.out = length(col))
          colid <- sapply(zzz, function(xx) sum(xx < colth))
          dim(colid) <- dim(zzz)
          colid <- colid[-1, -1]
          zlim <- range(zzz, na.rm = TRUE)
        }
        else {
          zlim <- 0:1
        }
        persp(x[[i]]$X, x[[i]]$Y, zzz, 
              col = rev(col)[colid], zlab = "", zlim = zlim,
              xlab = coordsnames[which.dire[1, i]], 
              ylab = coordsnames[which.dire[2, i]], ...) #sub = paste(nomi[j], "to", nomi[k])
      }
    }

    par(mar = c(2.2, 0.1, 1.2, 0.1))
    if (length(col) > 1) {
      image(matrix(colth, ncol = 1), col = col, main="Legend", axes = FALSE)
      box()
      axis(1)
    }
    else {
      plot.new()
    }
    par(mar = c(0.1, 0.1, 0.1, 0.1))
    for (j in c(0, 90)) {
      for (lbls in nomi) {
        plot.new()
        text(0.5, 0.5, labels = lbls, srt = j, font = 3)
      }
    }
  }

}

multi_tpfit_ml <-
function(data, coords, tolerance = pi/8, rotation = NULL, mle = "avg") {
  # Estimation for matrixes of transition rates
  #
  #       data vector of data
  #     coords coordinates matrix
  #  tolerance angle for tolerance (in radians)
  #   rotation vector of rotation angles (in radians)
  #        mle argument to pass to the function tpfit

  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  n <- dim(coords)[1]
  nc <- dim(coords)[2]
  nk <- nlevels(data)
  if (n < (nk + nk^2 * nc)) stop("there are not enough data to estimate the parameters")
  dire.mat <- diag(, nc)
  if (!is.null(rotation)) {
    if (length(rotation) != nc - 1) stop("wrong length of rotation vector; the right length is ", nc - 1)
    storage.mode(rotation) <- "double"
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(rotation),
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- t(matrix(dire.mat, nc, nc))
  }

  res <- list()
  res$coordsnames <- colnames(coords)
  if (is.null(res$coordsnames)) {
    res$coordsnames <- paste("X", 1:nc, sep = "")
  }
  res$coefficients <- apply(dire.mat, 1, function(d) {
    md.coef <- list()
    md.coef$coefficients <- tpfit_ml(data, coords, d, tolerance, mle)$coefficients
    class(md.coef) <- "tpfit"
    return(md.coef)
  })
  
  res$prop <- table(data)
  res$prop <- res$prop / sum(res$prop)

  res$tolerance <- as.double(tolerance)
  res$rotation <- rotation

  class(res) <- "multi_tpfit"
  return(res)
}

pemt <-
function(data, coords, mpoints, which.dire, max.dist, tolerance = pi/8,
         rotation = NULL, mle = "avg") {
  # Compute transition probabilities matrices 2D
  # through no ellispoidal interpolation
  #
  #       data vector of data
  #     coords coordinates matrix
  #    mpoints number of points per axes
  # which.dire two choosen 1D directions
  #   max.dist vector of maximum distances
  #  tolerance angle tolerance (in radians)
  #   rotation vector of rotation angles (in radians) to pass to multi_tpfit
  #        mle argument to pass to the function tpfit

  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  coordsnames <- colnames(coords)
  n <- dim(coords)[1]
  nc <- dim(coords)[2]
  nk <- nlevels(data)

  if (missing(mpoints)) stop("\"mpoints\" is missing")
  if (length(mpoints) != 1) mpoints <- mpoints[1]
  all <- FALSE
  if (missing(which.dire)) all <- TRUE
  if (missing(max.dist)) max.dist <- 1
  if (length(max.dist) == 1) max.dist <- rep(max.dist, nc)
  if (length(max.dist) != nc) 
    stop("\"max.dist\" must be a scalar or vector with the same dimension of coordinates")
  max.dist <- abs(max.dist)

  rawLags <- sapply(max.dist, function(h)
    seq(-h, h, length = mpoints)
  )
  prop <- table(data)
  prop <- prop / sum(prop)

  which.dire <- if (all) combn(1:nc, 2) else matrix(which.dire)
  nimg <- dim(which.dire)
  if (nimg[1] != 2) stop("wrong length of \"which.dire\"")
  if (!is.null(rotation)) {
    if (length(rotation) != nc - 1) stop("wrong length of rotation vector; the right length is ", nc - 1)
  }

  oldcontour <- TRUE
  storage.mode(which.dire) <- "integer"

  imgArgs <- list()
  length(imgArgs) <- nimg[2]
  for (i in 1:nimg[2]) {
    args <- list()
    lagsMat <- as.list(rep(0, nc))
    lagsMat[[which.dire[1, i]]] <- rawLags[, which.dire[1, i]]
    lagsMat[[which.dire[2, i]]] <- rawLags[, which.dire[2, i]]
    lagsMat <- as.matrix(expand.grid(lagsMat))
    nl <- dim(lagsMat)[1]
    
    contour <- oldcontour
    if (contour) {
      x <- multi_tpfit_ml(data, coords, tolerance, rotation)
      if (all(is.finite(unlist(x$coefficients)))) {
        Tprobs <- predict(x, lagsMat)
      }
      else {
        contour <- FALSE
        Tprobs <- NULL
      }
    }

    lagsMat <- t(lagsMat)
    same.dire <- vector("integer", nl)
    same.dire <- .C('wd', lags = as.double(lagsMat), nc = as.integer(nc),
                    nr = as.integer(nl), res = as.integer(same.dire),
                    PACKAGE = "spMC")$res
    wsd <- !duplicated(same.dire)
    coefs <- apply(lagsMat[, same.dire[wsd]], 2,
                   function(d) {
                     res <- tpfit_ml(data, coords, d, tolerance, mle)$coefficients
                     if(prod(is.finite(res)) == 0) res <- matrix(NaN, nk, nk)
                     return(res)
                   })
    storage.mode(wsd) <- "integer"
    nmat <- sum(wsd)
    coefs <- array(unlist(coefs), dim = c(nk, nk, nmat))
    wsd <- as.integer(as.factor(same.dire))
    Eprobs <- array(0, dim = c(nk, nk, nl))
    Eprobs <- .C('predPSEUDO', coefs = as.double(coefs), prop = as.double(prop),
                 lags = as.double(lagsMat), nk = as.integer(nk), nc = as.integer(nc),
                 nr = as.integer(nl), nmat = as.integer(nmat), wsd = as.integer(wsd),
                 whichd = as.integer(which.dire[2, i]), mypred = as.double(Eprobs),
                 NAOK = TRUE, PACKAGE = "spMC")$mypred
    Eprobs <- array(Eprobs, dim = c(nk, nk, nl))

    args$Tprobs <- Tprobs
    args$Eprobs <- Eprobs
    args$X <- rawLags[, which.dire[1, i]]
    args$Y <- rawLags[, which.dire[2, i]]
    imgArgs[[i]] <- args
  }
  imgArgs[[i + 1]] <- list(nk = nk, nomi = levels(data), coordsnames = colnames(coords),
                           mpoints = mpoints, which.dire = which.dire)
  class(imgArgs) <- "pemt"
  return(imgArgs)
}

"sim_ik" <- 
function(x, data, coords, grid, knn = 12, ordinary = TRUE, entropy = FALSE) {
  # Generation of conditional simulation based on Kriging
  #
  #        x a multi_tpfit object
  #     data vector of data
  #   coords coordinates matrix
  #     grid simulation points
  #      knn number of k-nearest neighbours
  # ordinary boolean (if TRUE ordinary Kriging is applied rather than simple Kriging)
  #       GA boolean (if TRUE genetic algorithm is applied rather than simulated annealing)
  #   optype character with the objective function to minimize after the simulation
  #   max.it maximum number of iteration for the optimization method
  #  entropy logical value to compute uncertainties

  ordinary <- as.logical(ordinary)
  if(!is.multi_tpfit(x)) stop("argument \"x\" must be a 'multi_tpfit' object.")

  if (missing(grid)) stop("simulation grid is missing.")
  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  if (!is.matrix(grid)) grid <- as.matrix(grid)
  nc <- dim(coords)[2]
  nr <- dim(coords)[1]
  if (is.null(knn)) {knn <- nr} else {knn <- as.integer(knn)}
  if (length(data) != nr) stop("the number of data is not equal to the number of coordinates")
  if (nc != dim(grid)[2]) stop("coordinates and simulation grid must have the same number of columns")
  if (nr < knn) knn <- nr
  nrs <- dim(grid)[1]
  nk <- nlevels(data)
  levLabels <- levels(data)
  data <- as.integer(data)
  storage.mode(coords) <- "double"
  storage.mode(grid) <- "double"
#   if (length(optype) > 1) optype <- optype[1]

  dire.mat <- diag(, nc)
  new.coords <- coords
  new.grid <- grid
  if (!is.null(x$rotation)) {
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(x$rotation), 
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- matrix(dire.mat, nc, nc)
    new.coords <- matrix(.C('fastMatProd', nr = as.integer(nr), ni = as.integer(nc),
                          mat1 = as.double(coords), nc = as.integer(nc),
                          mat2 = as.double(dire.mat), res = as.double(new.coords),
                          PACKAGE = "spMC")$res, nrow = nr, ncol = nc)
    new.grid <- matrix(.C('fastMatProd', nr = as.integer(nrs), ni = as.integer(nc),
                          mat1 = as.double(grid), nc = as.integer(nc),
                          mat2 = as.double(dire.mat), res = as.double(new.grid),
                          PACKAGE = "spMC")$res, nrow = nrs, ncol = nc)
  }

  # FINDING THE k-NEAREST NEIGHBOURS #
  indices <- matrix(0L, nrow = knn, ncol = nrs)
  indices <- matrix(.C('knear', nc = as.integer(nc), nr = as.integer(nr),
                       coords = as.double(new.coords), nrs = as.integer(nrs),
                       grid = as.double(new.grid), knn = as.integer(knn),
                       indices = as.integer(indices), PACKAGE = "spMC")$indices,
                    nrow = knn, ncol = nrs)

  # SORTING SIMULATION GRID #
  path <- do.call("order", as.data.frame(t(indices)))
  indices <- indices[, path]
  grid <- grid[path, ]
  new.grid <- new.grid[path, ]
  groups <- !duplicated(t(indices))
  groups <- cumsum(groups)

  # KRIGING PROCEDURE #
  probs <- matrix(0, nrow = nrs, ncol = nk)
  probs <- matrix(.C('getIKPrbs', ordinary = as.integer(ordinary),
                     indices = as.integer(indices), groups = as.integer(groups), 
                     knn = as.integer(knn), nc = as.integer(nc), nr = as.integer(nr),
                     nrs = as.integer(nrs), data = as.integer(data),
                     coords = as.double(new.coords), grid = as.double(new.grid),
                     nk = as.integer(nk), coef = as.double(unlist(x$coefficients)),
                     prop = as.double(x$prop), probs = as.double(probs),
                     PACKAGE = "spMC")$probs,
                  nrow = nrs, ncol = nk)

  # PREDICTION AND SIMULATION PROCEDURE #
  pred <- apply(probs, 1, which.max)
  initSim <- vector("integer", nrs)
  initSim <- .C('tsimCate', nk = as.integer(nk), n = as.integer(nrs), prhat = as.double(probs),
     initSim = as.integer(initSim), PACKAGE = "spMC")$initSim

  tmpfct <- 1:nk
  tmpfct <- factor(tmpfct, labels = levLabels)
  old <- tmpfct[initSim]
  pred <- tmpfct[pred]
  
  # COMPUTATION OF THE ENTROPY
  if (entropy) {
    entr <- .C("entropy", n = dim(probs), probs = as.double(probs),
               entr = double(2 * nrs), PACKAGE = "spMC")$entr
    res <- data.frame(grid, old, pred, probs, matrix(entr, nrs, 2L))
    names(res) <- c(colnames(coords), "Simulation", "Prediction", levLabels, 
                    "Entropy", "Std.Entropy")
  } else {
    res <- data.frame(grid, old, pred, probs)
    names(res) <- c(colnames(coords), "Simulation", "Prediction", levLabels)
  }
  res[path, ] <- res
  attr(res, "type") <- paste(ifelse(ordinary, "Ordinary", "Simple"), 
                             "Indicator Kriging Simulation")
  attr(res, "entropy") <- entropy
  attr(res, "packageVersion") <- paste(packageVersion("spMC"))
  class(res) <- c("data.frame", "spsim")
  return(res)
}

print.lengths <-
function(x, ...) {
  cat("Direction (")
  cat(x$direction, sep = ", ")
  cat(")\n")
  lvl <- levels(x$categories)
  last <- rev(lvl)[1]
  for (i in lvl) {  
    cat("Stratum lengths of category \"", i, "\"\n", sep = "")
    if (x$zeros) {
      idx <- (i == x$categories)
      print(x$length[idx] + x$maxcens[idx], ...)
    }
    else {
      print(x$length[i == x$categories], ...)
    }
    if (i != last) cat("\n")
  }
  invisible(x)
}

predict.tpfit <-
function(object, lags, ...) {
  # Transition probabilities prediction for spatial Markov Chain in 1D
  #
  #    lags vector of lags
  #  object list with a matrix of estimated transition rates

  storage.mode(lags) <- "double"
  mydim <- c(dim(object$coefficients), length(lags))
  mypred <- array(0, dim = mydim)
  mypred <- .C('predTPFIT', coefficients = as.double(object$coefficients), 
               prop = as.double(object$prop), lags = as.double(lags), 
               mydim = as.integer(mydim), mypred = as.double(mypred), 
               PACKAGE = "spMC")$mypred

  res <- list()
  res$Tmat <- array(unlist(mypred), dim = mydim)
  colnames(res$Tmat) <- rownames(res$Tmat) <- names(object$prop)
  res$lags <- lags
  res$type <- "Theoretical"
  class(res) <- "transiogram"
  return(res)
}

tpfit_ml <-
function(data, coords, direction, tolerance = pi/8, mle = "avg") {
  # Estimation for matrix of transition rates
  #          ( Mean Length Method )
  #
  #       data vector of data
  #     coords coordinates matrix
  #  direction vector (or versor) of choosen direction
  #  tolerance angle tolerance (in radians)
  #        mle argument to pass to the function tpfit

  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  n <- dim(coords)[1]
  nc <- dim(coords)[2]
  if (length(direction) != nc) stop("wrong length of direction vector")
  nl <- nlevels(data)
  if (n < (nl^2 + nl)) stop("there are not enough data to estimate the parameters")

  loc.id <- which_lines(coords, direction, tolerance)
  ml <- mlen(data, coords, loc.id, direction, mle)
  res <- list()
  res$coefficients <- embed_MC(data, coords, loc.id, direction)
  diag(res$coefficients) <- -1
  res$coefficients <- diag(1 / ml) %*% res$coefficients
  res$prop <- table(data)
  res$prop <- as.double(res$prop / sum(res$prop))
  names(res$prop) <- levels(data)
  colnames(res$coefficients) <- names(res$prop)
  rownames(res$coefficients) <- names(res$prop)
  res$tolerance <- as.double(tolerance)
  
  class(res) <- "tpfit"
  return(res)
}

is.multi_tpfit <-
function(object) {
  if(!is(object, "multi_tpfit")) return(FALSE)
  if(!prod(c("coordsnames", "coefficients", "prop", "tolerance") %in% names(object))) return(FALSE)
  if(length(names(object)) != 5 - is.null(object$rotation)) return(FALSE)
  if(!is.list(object$coefficients)) return(FALSE)
  if(!prod(sapply(object$coefficients, is.list))) return(FALSE)
  if(!prod(sapply(object$coefficients, names) == "coefficients")) return(FALSE)  
  if(!prod(sapply(object$coefficients, function(xx) is.matrix(xx$coefficients))))  return(FALSE)
  if(!is.numeric(object$prop)) return(FALSE)
  if(!is.numeric(object$tolerance)) return(FALSE)
  if(!is.null(object$rotation)) {
    if(!is.numeric(object$rotation)) return(FALSE)
    if(length(object$rotation) != length(object$coefficients) - 1) return(FALSE)
  }
  return(TRUE)
}

summary.lengths <-
function (object, ..., zeros.rm = TRUE) {
  newlen <- object$length + 0
  if (zeros.rm & object$zeros) {
    newlen <- object$length + object$maxcens
  }
  res <- tapply(newlen, object$categories, function(p) summary(p, ...))
  class(res) <- "summary.lengths"
  return(res)
}

is.transiogram <-
function(object) {
  if(!is(object, "transiogram")) return(FALSE)
  if(!prod(c("Tmat", "lags", "type") %in% names(object))) return(FALSE)
  if(!length(names(object)) %in% c(3, 4)) return(FALSE)
  if(!is.array(object$Tmat)) return(FALSE)
  if(diff(dim(object$Tmat)[1:2]) != 0) return(FALSE)
  if(!is.null(object$LOSE)) {
    if(!is.array(object$LOSE)) return(FALSE)
    if(diff(dim(object$LOSE)[1:2]) != 0) return(FALSE)
  }
  if(!is.numeric(object$lags)) return(FALSE)
  if(!is.character(object$type)) return(FALSE)
  if(object$type != "Empirical" && object$type != "Theoretical") return(FALSE)
  return(TRUE)
}

multi_tpfit_ils <-
function(data, coords, max.dist = Inf, mpoints = 20, tolerance = pi/8, rotation = NULL, q = 10, echo = FALSE, ..., mtpfit) {
  # Estimation for matrixes of transition rates
  #    ( Iterated Least Square Method )
  #
  #       data vector of data
  #     coords coordinates matrix
  #   max.dist maximum distance for counting (expressed for each direction)
  #    mpoints number of lags (expressed for each direction)
  #  tolerance angle for tolerance (in radians, expressed for each direction)
  #   rotation vector of rotation angles (in radians)
  #          q constant greater than one controlling the growth of rho
  #       echo logical value to print the optimization output
  #        ... further arguments to pass to nlminb function
  #     mtpfit multi_tpfit object for a further optimization

  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  n <- dim(coords)[1]
  nc <- dim(coords)[2]
  nk <- nlevels(data)
  if (n < (nk + nk^2 * nc)) stop("there are not enough data to estimate the parameters")
  dire.mat <- diag(, nc)
  if (!is.null(rotation)) {
    if (length(rotation) != nc - 1) stop("wrong length of rotation vector; the right length is ", nc - 1)
    storage.mode(rotation) <- "double"
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(rotation),
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- t(matrix(dire.mat, nc, nc))
  }
  if(length(max.dist) < nc) max.dist <- rep(max.dist[1], nc)
  if(length(mpoints) < nc) mpoints <- rep(mpoints[1], nc)
  if(length(tolerance) < nc) tolerance <- rep(tolerance[1], nc)

  res <- list()
  res$coordsnames <- colnames(coords)
  if (is.null(res$coordsnames)) {
    res$coordsnames <- paste("X", 1:nc, sep = "")
  }
  res$coefficients <- list()
  for (i in 1:nc) {
    if (echo) {
      cat("Direction (", sep = "")
      cat(dire.mat[i, ], sep = ", ")
      cat(")\n", sep = "")
    }
    res$coefficients[[i]] <- list()
    if (missing(mtpfit)) {
      res$coefficients[[i]]$coefficients <- tpfit_ils(data, coords, dire.mat[i, ], max.dist[i], 
                                            mpoints[i], tolerance[i], q = q, echo, ...)$coefficients
    }
    else {
      res$coefficients[[i]]$coefficients <- tpfit_ils(data, coords, dire.mat[i, ], max.dist[i], 
          mpoints[i], tolerance[i], q = q, echo, ..., tpfit = mtpfit$coefficients[[i]])$coefficients
    }
    class(res$coefficients[[i]]) <- "tpfit"
    if (echo && i != nc) cat("\n")
  }
  
  res$prop <- table(data)
  res$prop <- res$prop / sum(res$prop)

  res$tolerance <- as.double(tolerance)
  res$rotation <- rotation

  class(res) <- "multi_tpfit"
  return(res)
}

is.lengths <-
function (object) {
  if (!is(object, "lengths")) return(FALSE)
  if (length(object) != 5) return(FALSE)
  if (!prod(c("categories", "direction", "maxcens", "length", "zeros") %in% names(object))) return(FALSE)
  if (!is.factor(object$categories)) return(FALSE)
  if (!is.numeric(object$direction)) return(FALSE)
  if (!is.numeric(object$maxcens)) return(FALSE)
  if (!is.numeric(object$length)) return(FALSE)
  if (!is.logical(object$zeros)) return(FALSE)
  return(TRUE)
}

contour.pemt <-
function(x, nlevels = 10, col = c("black", "blue"), main, mar, ask = TRUE, ...) {
  # Contour plot transition probabilities matrices 2D
  # through no ellispoidal interpolation
  #
  #          x object return by the function pemt()
  #    nlevels number of levels to pass to contour()
  #        col vector of colors for two transiograms
  #       main title string
  #        mar vector to pass to par()  
  #        ask boolean to pass to par()
  #        ... other args to pass to contour()

  if (length(col) < 2L) col <- rep(col, each = 2L) 
  ix <- length(x)
  nk <- x[[ix]]$nk
  mpoints <- x[[ix]]$mpoints
  coordsnames <- x[[ix]]$coordsnames

  if (missing(main) || !is.character(main)) main <- "Multidirectional transiogram"
  which.dire <- x[[ix]]$which.dire
  nimg <- dim(which.dire)

  ly <- matrix(c(rep(1, nk), rep(0, nk), 2:(nk^2+1), rep(0, nk), rep(nk^2+2, nk)), ncol = nk, byrow = TRUE)
  yl <- c(rep(0, nk + 4))
  ly <- cbind(yl, yl, ly, yl, yl)
  ly[nk + 4, ] <- nk^2 + 2
  widths <- c(rep(4 - 0.5 * nk, 2), rep(30/nk, nk), rep(4 - 0.5 * nk, 2)) / 4
  heights <- c(0.75, 1/3.5, rep(7.5/nk, nk), 2/3.5, 1)
  ly <- layout(ly, widths = widths, heights = heights, respect = TRUE)
  
  nomi <- x[[ix]]$nomi
  if (missing(mar) || !is.numeric(mar)) {
    mar <- sum(c(0, 1, 0, -0.5, -0.2, rep(0, 4), 0.2, rep(c(-0.1, rep(0, 3)), 2), 0)[1:nk])
    mar <- rep(mar, 4)
  }
  else {
    if (length(mar) < 4) {
      mar <- rep(mar[1], 4)
    }
    else {
      mar <- mar[1:4]
    }
  }

  oldcontour <- contour
  storage.mode(which.dire) <- "integer"

  for (i in 1:nimg[2]) {
    if (ask && (nimg[2] > 1)) {
      devAskNewPage(TRUE)
      on.exit(devAskNewPage(FALSE))
    }
    else {
      devAskNewPage(FALSE)
      on.exit(devAskNewPage(FALSE))
    }

    par(mar = c(0.3, 0.1, 0.3, 0.1))
    plot.new()
    title <- paste(main, " (", coordsnames[which.dire[1, i]], ", ", 
                   coordsnames[which.dire[2, i]], ")", sep = "")
    text(0.5, 0.5, labels = title, cex = 2)

    par(mar = mar)
    for (j in 1:nk) {
      for (k in 1:nk) {
        contour(x[[i]]$X, x[[i]]$Y,
                t(matrix(rev(x[[i]]$Eprobs[j, k, ]), mpoints, mpoints)),
                nlevels = nlevels, add = FALSE, col = col[1L],
                xlab = paste("Coord", which.dire[1, i]),
                ylab = paste("Coord", which.dire[2, i]), ..., axes = FALSE)
        box()
        if (k == 1) axis(2)
        if (k == nk) axis(4, 0, labels = nomi[j], tick = FALSE, font = 3)
        if (j == nk) axis(1)
        if (j == 1) axis(3, 0, labels = nomi[k], tick = FALSE, font = 3)
        if (is.null(x[[i]]$Tprobs)) {
          message("Contour values missing or not computable")
        }
        else {
            contour(x[[i]]$X, x[[i]]$Y,
                    t(matrix(rev(x[[i]]$Tprobs$Tmat[j, k, ]), mpoints, mpoints)),
                    nlevels, add = TRUE, col = col[2L], ...)
        }
      }
    }

    par(mar = c(2.2, 0.1, 1.2, 0.1))
    plot.new()
    legend("center", bty = "n", legend = c("Multidirectional transiogram", 
           "Theroretical transiogram"), col = col, horiz = TRUE, lwd = 1, cex = 1.5)
  }

}

sim_path <-
function(x, data, coords, grid, radius, fixed=FALSE, entropy = FALSE) {
  # Generation of conditional simulation based on path
  #
  #       x a multi_tpfit object
  #    data vector of data
  #  coords coordinates matrix
  #    grid simulation points
  #  radius radius to find neighbour points
  #   fixed boolean for random or fixed path algorithm
  # entropy logical value to compute uncertainties


  if(!is.multi_tpfit(x)) stop("argument \"x\" must be a 'multi_tpfit' object.")

  if (missing(grid)) stop("simulation grid is missing.")
  if (missing(radius)) stop("searching radius is missing.")
  storage.mode(radius) <- "double"
  if (radius <= 0) stop("searching radius must be positive.")
  if (!is.factor(data)) data <- as.factor(data)
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  if (!is.matrix(grid)) grid <- as.matrix(grid)
  nc <- dim(coords)[2]
  nr.orig <- dim(coords)[1]
  if (length(data) != nr.orig) stop("the number of data is not equal to the number of coordinates.")
  if (nc != dim(grid)[2]) stop("coordinates and simulation grid must have the same number of columns.")
  nk <- nlevels(data)
  levelLab <- levels(data)
  nrs <- dim(grid)[1] #total number of simulation
  storage.mode(coords) <- "double"
  storage.mode(grid) <- "double"

  dire.mat <- diag(, nc)
  new.coords <- coords
  new.grid <- grid
  if (!is.null(x$rotation)) {
    dire.mat <- .C('rotaxes', nc = as.integer(nc), ang = as.double(x$rotation), 
                   res = as.double(dire.mat), PACKAGE = "spMC")$res
    dire.mat <- matrix(dire.mat, nc, nc)
    new.coords <- matrix(.C('fastMatProd', nr = as.integer(nr.orig), ni = as.integer(nc),
                          mat1 = as.double(coords), nc = as.integer(nc),
                          mat2 = as.double(dire.mat), res = as.double(new.coords),
                          PACKAGE = "spMC")$res, nrow = nr.orig, ncol = nc)
    new.grid <- matrix(.C('fastMatProd', nr = as.integer(nrs), ni = as.integer(nc),
                          mat1 = as.double(grid), nc = as.integer(nc),
                          mat2 = as.double(dire.mat), res = as.double(new.grid),
                          PACKAGE = "spMC")$res, nrow = nrs, ncol = nc)
  }

  # GENERATING THE PATH TO FOLLOW
  if (fixed) {
    # Fixed Path MC Algorithm
    ord <- do.call("order", as.data.frame(grid[, nc:1]))
    path <- as.integer(as.factor(grid[, nc]))
    path <- unlist(sapply(1:max(path), function(i) if(i%%2) ord[i == path] else rev(ord[i==path])))
  }
  else {
    # Random Path MC Algorithm
    path <- sample(1:nrs)
  }
  storage.mode(path) <- "integer"

  data <- as.integer(data)
  prhat <- matrix(0, nrow = nrs, ncol = nk)
  pred <- vector("integer", nrs)

  res <- .C('pathAlg', nrs = as.integer(nrs), nrorig = as.integer(nr.orig),
            nc = as.integer(nc), coords = as.double(new.coords), gird = as.double(new.grid),
            path = as.integer(path), radius = as.double(radius), nk = as.integer(nk),
            data = as.integer(data), coefs = as.double(unlist(x$coefficients)),
            prop = as.double(x$prop), prhat = as.double(prhat), pred = as.integer(pred),
            PACKAGE = "spMC")[12:13]

  prhat <- matrix(res$prhat, nrow = nrs, ncol = nk)

  simu <- vector("integer", nrs)
  simu <- .C('tsimCate', nk = as.integer(nk), n = as.integer(nrs), prhat = as.double(prhat), 
            initSim = as.integer(simu), PACKAGE = "spMC")$initSim

  tmpfct <- 1:nk
  tmpfct <- factor(tmpfct, labels = levelLab)
  simu <- tmpfct[simu]
  pred <- tmpfct[res$pred]
  rownames(grid) <- NULL 
  rownames(pred) <- NULL
  rownames(simu) <- NULL
  rownames(prhat) <- NULL
  # COMPUTATION OF THE ENTROPY
  if (entropy) {
    entr <- .C("entropy", n = dim(prhat), probs = as.double(prhat),
               entr = double(2 * nrs), PACKAGE = "spMC")$entr
    res <- data.frame(grid, simu, pred, prhat, matrix(entr, nrs, 2L))
    names(res) <- c(colnames(coords), "Simulation", "Prediction", levelLab, 
                    "Entropy", "Std.Entropy")
  } else {
    res <- data.frame(grid, simu, pred, prhat)
    names(res) <- c(colnames(coords), "Simulation", "Prediction", levelLab)
  }
  tipo <- if (fixed) {"Fixed"} else {"Random"}
  attr(res, "type") <- paste(tipo, "Path Simulation")
  attr(res, "entropy") <- entropy
  attr(res, "packageVersion") <- paste(packageVersion("spMC"))
  class(res) <- c("data.frame", "spsim")
  return(res)
}

plot.density.lengths <-
function (x, main = NULL, xlab = NULL, ylab = "Density", type = "l", zero.line = TRUE, ...) {
    nk <- length(x) - 2
    if (is.null(main)) {
      main <- "Empirical densities of "
      if (!x$log) main <- paste(main, "stratum ", sep = "")
      if (x$log) main <- paste(main, "log-", sep = "")
      main <- paste(main, "lengths - Direction (", 
                     round(x$direction[1], 2), sep = "")
      if (length(x$direction) > 1) {
        for (i in 2:length(x$direction))
          main <- paste(main, round(x$direction[i], 2), sep = ", ")
      }
      main <- paste(main, ")", sep = "")
    }
    if (!is.null(xlab)) {
      if(length(xlab) < nk) xlab <- rep(xlab[1], nk)
    }
    else {
      xlab <- c()
      for (i in 1:nk) 
        xlab[i] <- paste("N =", x[[i]]$n, "  Log-Bandwidth =", formatC(x[[i]]$bw))
    }
    nomi <- names(x)[1:nk]
    mr <- ceiling(sqrt(nk))
    mc <- floor(mr - nk / mr)
    ly <- matrix(c(rep(1, mr), rep(0, mr), 2:(mr^2+1)), ncol = mr, byrow = TRUE)
    yl <- c(rep(0, mr + 2))
    ly <- cbind(yl, ly, yl)[, -(2+mr+1-mc)]
    widths <- c(rep(2 - 0.5 * mr, 1), rep(30/mr, mr), rep(4 - 0.5 * mr, 1)) / 4
    heights <- c(0.75, 1/3.5, rep(7.5/mr, mr-mc))
    ly <- layout(ly, widths = widths, heights = heights, respect = TRUE)
    mar <- sum(c(0, 1, 0, -0.5, -0.2, rep(0, 4), 0.2, rep(c(-0.1, rep(0, 3)), 2), 0)[1:mr])
    mar <- rep(mar, 4)
    par(mar = mar)
    plot.new()
    text(0.5, 0.5, labels = main, cex = 2)
    for (i in 1:nk) {
      par(mar = c(5, 4, 3, 2))
      plot.default(x[[i]], main = nomi[i], xlab = xlab[i], ylab = ylab, type = type, ...)
      if (zero.line) abline(h = 0, lwd = 0.1, col = "gray")
    }
}

tpfit_ils <-
function(data, coords, direction, max.dist = Inf, mpoints = 20, tolerance = pi/8, q = 10, echo = FALSE, ..., tpfit) {
  # Estimation for matrix of transition rates 
  #    ( Iterated Least Square Method )
  #
  #       data vector of data
  #     coords coordinates matrix
  #  direction vector (or versor) of choosen direction
  #   max.dist maximum distance for counting
  #    mpoints number of lags
  #  tolerance angle tolerance (in radians)
  #          q constant greater than one controlling the growth of rho
  #       echo logical value to print the optimization output
  #        ... further arguments to pass to nlminb function
  #      tpfit tpfit object for a further optimization

  if (q <= 1) stop("q must be greater than one")
  if (!is.matrix(coords)) coords <- as.matrix(coords)
  n <- dim(coords)[1]
  nc <- dim(coords)[2]
  if (length(direction) != nc) stop("wrong length of direction vector")
  if (!is.factor(data)) data <- as.factor(data)
  nl <- nlevels(data)
  if (n < (nl^2 + nl)) stop("there are not enough data to estimate the parameters")

  EmpTrans <- transiogram(data, coords, direction, max.dist, mpoints, tolerance)
  proportion <- table(data)
  proportion <- proportion / sum(proportion)

  if (missing(tpfit)) {
    Rmat <- matrix(0, nl, nl)
  }
  else {
    Rmat <- tpfit$coefficients
  }
  Bmat <- upper.tri(Rmat) | lower.tri(Rmat)
  Bmat[nl, ] <- FALSE
  lower <- upper <- 0 * Rmat[Bmat]
  upper <- upper + Inf

  optFUN <- function(x, trans, propt, rho = 0) {
    x[is.na(x)] <- 0
    xx <- matrix(0, nl, nl)
    xx[Bmat] <- x
    diag(xx) <- -apply(xx, 1, sum)
    xx[nl,] <- -(propt %*% xx)
    xx[nl,] <- xx[nl,] / propt[nl]
    ll <- length(trans$lags)
    mydim <- c(nl, nl, ll)
    mypred <- array(0, dim = mydim)
    mypred <- .C('predTPFIT', coefficients = as.double(xx),
               prop = as.double(propt), lags = as.double(trans$lags), 
               mydim = as.integer(mydim), mypred = as.double(mypred), 
               PACKAGE = "spMC")$mypred
    sse <- .C('fastrss', n = as.integer(nl * nl * ll), mypred = as.double(mypred),
              Tmat = as.double(trans$Tmat), rss = as.double(0), NAOK = TRUE,
              PACKAGE = "spMC")$rss
    sse <- sse + rho * sum(xx[nl, -nl]^2 * (xx[nl, -nl] < 0), na.rm = TRUE)
    return(sse)
  }

  optmizerFUN <- function(rho, Rmat, Bmat, optFUN, trans, propt, lower, upper, echo, ...) {
    mypar <- as.vector(Rmat[Bmat])
    mypar[is.na(mypar)] <- 0
    res <- nlminb(mypar, optFUN, trans = EmpTrans, propt = c(proportion),
                  rho = rho, lower = as.vector(lower), upper = as.vector(upper),
                  control = list(...))
    if (echo) {
      cat("The algorithm stopped after ")
      cat(res$iterations)
      cat(" steps.\n")
      cat("Penalized sum of square errors: ")
      cat(res$objective)
      cat("\n\n")
    }
    return(res$par)
  }
  
  Rnv <- new.env()
  Rnv <- parent.env(Rnv)
  eps <- sqrt(.Machine$double.eps)
  res <- Rmat[Bmat]

  res <- .Call("bclm", q, eps, res, echo, quote(optmizerFUN(rho, Rmat, Bmat, optFUN, 
        EmpTrans, c(proportion),lower, upper, echo, ...)), Rnv, PACKAGE = "spMC")

  if (echo) cat("Convergence has been reached.\n")

  Rmat <- matrix(0, nl, nl)
  Rmat[Bmat] <- res
  diag(Rmat) <- -apply(Rmat, 1, sum)
  Rmat[nl,] <- -(c(proportion) %*% Rmat)
  Rmat[nl,] <- Rmat[nl,] / proportion[nl]

  res <- list()
  res$coefficients <- Rmat
  res$prop <- as.double(proportion)
  names(res$prop) <- levels(data)
  colnames(res$coefficients) <- names(res$prop)
  rownames(res$coefficients) <- names(res$prop)
  res$tolerance <- as.double(tolerance)
  
  class(res) <- "tpfit"
  return(res)
}

embed_MC <-
function(data, coords, loc.id, direction) {
  # Transition probabilities estimation for Embedded Markov Chain 
  #
  #      data vector of data
  #    coords matrix of coordinates
  #    loc.id location Id (which_lines output)
  # direction vector (or versor) of choosen direction

  if (!is.matrix(coords)) coords <- as.matrix(coords)
  storage.mode(coords) <- "double"
  nc <- dim(coords)[2]
  if (length(direction) != nc) stop("wrong length of direction vector")
  if (!is.factor(data)) data <- as.factor(data)
  nk <- nlevels(data)
  labels <- levels(data)
  n <- length(data)
  if (n < nk^2) stop("there are not enough data to estimate the parameters")
  if (n != dim(coords)[1]) stop("the number of data is not equal to the number of coordinates")
  if (n != length(loc.id)) stop("length of \"loc.id\" must be equal to the data length")
  loc.id <- as.integer(loc.id)
  
  ord <- order(abs(direction), decreasing = TRUE)
  ord <- cbind(loc.id, coords[, ord])
  ord <- lapply(apply(ord, 2, list), unlist)
  ord$decreasing <- TRUE
  ord <- do.call("order", ord)
  data <- data[ord]
  loc.id <- loc.id[ord]

  tcount <- vector("integer", nk^2)
  tcount <- .C('cEmbedTrans', n = as.integer(n), nk = as.integer(nk), 
               locId = as.integer(loc.id), data = as.integer(data), 
               tcount = as.integer(tcount), PACKAGE = "spMC")$tcount
  tprobs <- as.double(tcount)
  tprobs <- .C('embedTProbs', nk = as.integer(nk), tp = as.double(tprobs), 
               PACKAGE = "spMC")$tp
  tcount <- matrix(tcount, ncol = nk)
  tprobs <- matrix(tprobs, ncol = nk)
  diag(tcount) <- NA
  diag(tprobs) <- NA
  colnames(tcount) <- rownames(tcount) <- labels
  colnames(tprobs) <- rownames(tprobs) <- labels
  attr(tprobs, "Counts") <- tcount
  return(tprobs)
}

mixplot <-
function(x, main, legend = TRUE, ...) {
  # Plot transition probabilities matrixes 1D
  #
  #          x list of transiogram objects
  #       main title string
  #     legend logical for printing the legend
  #        ... other args to pass to plot()
  
  if (missing(main) || !is.character(main)) main <- "One-dimensional transiograms"
  if (is.transiogram(x)) x <- list(x)
  
  if (prod(sapply(x, is.transiogram)) == 0) stop("some elements of \"x\" are not transiogram objects")
  n <- sapply(x, function(n) dim(n$Tmat)[1])
  if (var(n) != 0) stop("transiogram objects must have the same number of categories")
  n <- n[1]
  nt <- length(x)

  ly <- matrix(c(rep(1, n), rep(0, n), 2:(n^2+1), rep(n^2+3, n), rep(n^2+4, n)), ncol = n, byrow = TRUE)
  yl0 <- c(rep(0, n + 4))
  yln <- c(rep(0, 2), rep(n^2 + 2, n), rep(0, 2))
  ly <- cbind(yln, yln, ly, yl0, yl0)
  widths <- c(3, 4/3.5, rep(30/n, n), 4/3.5, 3) / 4 
  heights <- c(0.75, 1/3.5, rep(7.5/n, n), 2.5/3.5, legend)
  ly <- layout(ly, widths = widths, heights = heights, respect = TRUE)
  
  par(mar=c(0.3, 0.1, 0.3, 0.1))
  plot.new()
  text(0.5, 0.5, main, cex = 2)
  nomi <- colnames(x[[1]]$Tmat)
  legends <- sapply(x, function(l) paste(l$type, "transiogram"))
  
  args <- list(...)
  if (!is.null(args$pch)) args$pch <- rep(args$pch, length.out = nt)
  if (!is.null(args$cex)) args$pt.cex <- rep(args$cex, length.out = nt)
  if (!is.null(args$lty)) args$lty <- rep(args$lty, length.out = nt)
  if (!is.null(args$lwd)) args$lwd <- rep(args$lwd, length.out = nt)
  orgs <- list()
  orgs$col <- par("col")
  orgs$lty <- rep(NA, length.out = nt)
  orgs$lwd <- rep(NA, length.out = nt)
  orgs$pch <- rep(NA, length.out = nt)
  orgs$pt.cex <- rep(NA, length.out = nt)
  if (!is.null(args$col)) orgs$col <- args$col
  orgs$col <- rep(orgs$col, length.out = nt)
  if (is.null(args$type)) {
    orgs$pch <- rep(1, length.out = nt)
    orgs$pt.cex <- rep(1, length.out = nt)
    orgs$type <- rep("p", length.out = nt)
  }
  else {
    orgs$type <- rep(args$type, length.out = nt)
    for (i in 1:nt) {
      if (orgs$type[i] == "p") {
        if (!is.null(args$pch)) orgs$pch[i] <- args$pch[i] else orgs$pch[i] <- 1
        if (!is.null(args$cex)) orgs$pt.cex[i] <- args$cex[i] else orgs$pt.cex[i] <- 1
      }
      if (orgs$type[i] %in% c("b", "c", "o")) {
        if (!is.null(args$pch)) orgs$pch[i] <- args$pch[i] else orgs$pch[i] <- 1
        if (!is.null(args$cex)) orgs$pt.cex[i] <- args$cex[i] else orgs$pt.cex[i] <- 1
        if (!is.null(args$lty)) orgs$lty[i] <- args$lty[i] else orgs$lty[i] <- 1
        if (!is.null(args$lwd)) orgs$lwd[i] <- args$lwd[i] else orgs$lwd[i] <- 1
      }
      if (orgs$type[i] %in% c("l", "h", "s", "S")) {
        if (!is.null(args$lty)) orgs$lty[i] <- args$lty[i] else orgs$lty[i] <- 1
        if (!is.null(args$lwd)) orgs$lwd[i] <- args$lwd[i] else orgs$lwd[i] <- 1
      }
    }
  }

  par(mar = 2 * (rep(1.25, 4) + c(1, 1, 0, 0)) / n)
  xlim <- range(as.vector(sapply(x, function(t) range(na.omit(t$lags)))))
  xpos <- mean(xlim)
  for(j in 1:n) {
    for(k in 1:n) {
      plot(xpos, .5, type = "n", ylab = "", xlab = "", xlim = xlim, ylim = 0:1, axes = FALSE)
      for (i in 1:nt) {
          myseq <- na.omit(cbind(x[[i]]$lags, x[[i]]$Tmat[j, k, ]))
        if (orgs$type[i] == "p") {
          points(myseq[, 1], myseq[, 2], type = "p", col = orgs$col[i],
                 cex = orgs$cex[i], pch = orgs$pch[i])      
        }
        if (orgs$type[i] %in% c("b", "c", "o")) {
          points(myseq[, 1], myseq[, 2], type = orgs$type[i],
               cex = orgs$cex[i], pch = orgs$pch[i], col = orgs$col[i],
               lty = orgs$lty[i], lwd = orgs$lwd[i])
        }
        if (orgs$type[i] %in% c("l", "s", "S", "h")) {
          points(myseq[, 1], myseq[, 2], type = orgs$type[i], 
                lty = orgs$lty[i], lwd = orgs$lwd[i], col = orgs$col[i])
        }
      }
      box()
      if (k == 1) axis(2)
      if (k == n) axis(4, .5, labels = nomi[j], tick = FALSE, font = 3)
      if (j == n) axis(1)
      if (j == 1) axis(3, xpos, labels = nomi[k], tick = FALSE, font = 3)
    }
  }
  par(mar = rep(.005, 4))
  plot.new()
  text(0.3, 0.5, "Transition probabilities", srt = 90, cex = 1.3)
  plot.new()
  text(0.5, 0.2, "Lags", cex = 1.3)

  if (legend) {
    par(mar=c(1.2, 0.1, 2.2, 0.1))
    plot.new()
    legend("center", legend = legends,
           lty = orgs$lty, lwd = orgs$lwd, pch = orgs$pch, 
           pt.cex = orgs$pt.cex, col = orgs$col, bty = "n",
           cex = 1.5, box.lwd = 0, box.lty = 0, horiz = TRUE)
  }
}

is.tpfit <-
function(object) {
  if(!is(object, "tpfit")) return(FALSE)
  if(!prod(c("coefficients", "prop", "tolerance") %in% names(object))) return(FALSE)
  if(length(names(object)) != 3) return(FALSE)
  if(!is.matrix(object$coefficients)) return(FALSE)
  if(!is.numeric(object$prop)) return(FALSE)
  if(!is.numeric(object$tolerance)) return(FALSE)
  return(TRUE)
}

\name{setCores}
\Rdversion{1.1}
\alias{setCores}

\title{Set the number of CPU cores for HPC}

\description{The function set the number of CPU cores for parallel computation by the use of OpenMP library (\url{https://www.openmp.org/}). If the package was not complied with the library OpenMP (>= 3.0), this function is disabled.}

\usage{setCores(n)}

\arguments{
  \item{n}{an integer value denoting the number of CPU cores to use; if it exceeds the total number of cores, all of them will be used. If missing, the number of CPU cores in use will be displayed.}
}

\details{
When the package is loaded, only one CPU core is used.
}

\value{The total number of CPU cores in use will be returned and a message will be displayed. If the package was not complied with the library OpenMP (>= 3.0), the value one will be returned.}

\references{SunTM ONE Studio 8 (2003) \emph{OpenMP API User's Guide}. Sun Microsystems Inc., Santa Clara, U.S.A.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\examples{\donttest{
#Display the number of CPU cores in use
setCores()

#Set 2 CPU cores for parallel computation
setCores(2)

#Set 1 CPU core for serial computation
setCores(1)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{programming}

\name{mlen}
\Rdversion{1.1}
\alias{mlen}

\title{Mean Length Estimation for Embedded Markov Chain}

\description{The function estimates the mean length for a \eqn{d}{d}-D spatial embedded Markov chain for a specified direction \eqn{\phi}{phi}.}

\usage{mlen(data, coords, loc.id, direction, mle = "avg")}

\arguments{
%%        data vector of data
%%      coords matrix of coordinates
%%      loc.id location Id (which_lines output)
%%   direction vector (or versor) of chosen direction
%%         mle string of characters, 
%%             if "mle" the MLEs will be returned (log-normal distro assumed)
%%             it can be logical for backward compatibility reasons

  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{loc.id}{a vector of \eqn{n}{n} values which indicates the directional line of each location. It is usually the output of the function \code{\link{which_lines}}.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{mle}{a character value. If \code{"trm"}, the trimmed arithmetic average will be used to calculate the mean lengths. If \code{"mdn"}, the trimmed median will be considered. If \code{"mlk"}, the maximum likelihood mean lengths will be computed. If \code{"avg"}, the arithmetic mean will be performed. For backward compatibility reasons, it can accept logical values, so that \code{TRUE} is equivalent to \code{"mlk"} and \code{FALSE} to \code{"avg"}.}
}

\details{
The mean length is the total length occupied by the \eqn{k}{k}-th category divided by the number of its embedded occurrences along lines in the direction \eqn{\phi}{phi}. More robust methods are implemented, such as the trimmed mean and the trimmed median.

If the stratum lengths are censored, the maximum likelihood approach is more appropriate than the arithmetic mean. In this case, the stratum lengths are assumed to be independent realizations from a log-normal random variable. The quantity to maximize is
\deqn{L(\mu_1, \ldots, \mu_K, \sigma_1, \ldots, \sigma_K) = \prod_{i = 1}^m \prod_{k = 1}^K \left[ \int_{l_i}^{l_i+u_i} \frac{1}{x \sigma_k \sqrt{2}} \exp \left\lbrace - \frac{(\log x - \mu_k)^2}{2 \sigma_k^2} \right\rbrace \right]^{z_{k, i}} \mbox{d}x,}{L(mu, sigma) = prod_(i=1)^m prod_(k=1)^K Pr(l_i < X < l_i + u_i)^(z_k),}
where \eqn{\boldsymbol{\mu} = (\mu_1, \ldots, \mu_K)^\top}{mu} and \eqn{\boldsymbol{\sigma} = (\sigma_1, \ldots, \sigma_K)^\top}{sigma} are vectors of parameters, \eqn{l_i}{l_i} is the observed stratum length, \eqn{u_i}{u_i} denotes the upper bound of the censor and \eqn{z_{k, i}}{z_k} denotes a dummy variable which assumes value 1 if and only if the \eqn{i}{i}-th stratum is referred to the \eqn{k}{k}-th category.
}

\value{A numeric vector containing the mean length for each observed category.}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{which_lines}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)

# Compute the appartaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)

# Estimate the mean lengths for each observed category
ml <- mlen(ACM$MAT5, ACM[, 1:3], loc.id, direction, mle = "avg")

# Equivalently
gl <- getlen(ACM$MAT5, ACM[, 1:3], loc.id, direction, zero.allowed = TRUE)
ml1 <- tapply(gl$length, gl$categories, mean)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{print.lengths}
\Rdversion{1.1}
\alias{print.lengths}

\title{Printing Stratum Lengths for Each Observed Category}

\description{The function prints stratum lengths given by \code{\link{getlen}}.}

\usage{\method{print}{lengths}(x, ...)}

\arguments{
  \item{x}{an object of the class \code{lengths}, typically with the output of the function \code{\link{getlen}}.}
  \item{\dots}{further arguments passed to or from other methods.}
}

\value{Stratum lengths grouped by category are printed on the screen or other output devices. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{getlen}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Print stratum lengths
print(gl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{tpfit_me}
\Rdversion{1.1}
\alias{tpfit_me}

\title{Maximum Entropy Method for One-dimensional Model Parameters Estimation}

\description{
The function estimates the model parameters of a 1-D continuous lag spatial Markov chain by the use of the maximum entropy method. Transition rates matrix along a user defined direction and proportions of categories are computed.
}

\usage{tpfit_me(data, coords, direction, tolerance = pi/8,
         max.it = 9000, mle = "avg")}

\arguments{
%%         data vector of data
%%       coords coordinates matrix
%%    direction vector (or versor) of chosen direction
%%    tolerance angle tolerance (in radians)
%%          mle logical value to pass to the function mlen
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It is \code{pi/8} by default.}
  \item{max.it}{a numerical value which denotes the maximum number of iterations to perform during the optimization phase. It is \code{9000} by default.}
  \item{mle}{a character value to pass to the function \code{\link{mlen}}. It is \code{"avg"} by default.}
}

\details{
A 1-D continuous-lag spatial Markov chain is probabilistic model which involves a transition rate matrix \eqn{R}{R} computed for the direction \eqn{\phi}{phi}. It defines the transition probability \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through the entry \eqn{t_{jk}}{t_(jk)} of the following matrix
\deqn{T = \mbox{expm} (h R),}{T = expm(h R),}
where \eqn{h}{h} is a positive lag value.

To calculate entries of the transition rate matrix, we need to maximize the entropy of the transition probabilities of embedded occurrences along a given direction \eqn{\phi}{phi}. The entropy is defined as
\deqn{e = - \sum_{k}^K \sum_{j \neq k}^K \tau_{jk, \phi} \log \tau_{jk, \phi},}{e = E[log tau_(jk, phi)],}
where \eqn{\tau_{jk, \phi}}{tau_(jk, phi)} are transition probabilities of embedded occurrences. It is maximized by the use of the iterative proportion fitting method.

When some entries of the matrix \eqn{R}{R} are not identifiable, it is suggested to vary the \code{tolerance} coefficient or to set the input argument \code{mle} to \code{"mlk"}.}

\value{
An object of the class \code{tpfit} is returned. The function \code{\link{print.tpfit}} is used to print the fitted model. The object is a list with the following components: 
  \item{coefficients}{the transition rates matrix computed for the user defined direction.}
  \item{prop}{a vector containing the proportions of each observed category.}
  \item{tolerance}{a numerical value which denotes the tolerance angle (in radians).}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{predict.tpfit}}, \code{\link{print.tpfit}}, \code{\link{multi_tpfit_me}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# one-dimensional MC model
tpfit_me(ACM$MAT5, ACM[, 1:3], c(0,0,1))
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{is.multi_transiogram}
\Rdversion{1.1}
\alias{is.multi_transiogram}

\title{Object test for multi_transiogram class}

\description{Function to test if an object is of the class \code{multi_transiogram}.}

\usage{is.multi_transiogram(object)}

\arguments{
\item{object}{object to be tested.}
}

\details{The function returns \code{TRUE} if and only if its argument is a \code{multi_transiogram} object.}

\value{A logical value.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{predict.multi_tpfit}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# multidimensional MC model
RTm <- multi_tpfit(ACM$MAT3, ACM[, 1:3])

# Generate the matrix of 
# multidimensional lags
lags <- expand.grid(X=-1:1, Y=-1:1, Z=-1:1)
lags <- as.matrix(lags)

# Compute transition probabilities 
# from the multidimensional MC model
TrPr <- predict(RTm, lags)

# Test the object TrPr
is.multi_transiogram(TrPr)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{attribute}

\name{transiogram}
\Rdversion{1.1}
\alias{transiogram}

\title{Empirical Transition Probabilities Estimation for 1-D MC}

\description{The function estimates transition probabilities matrices for a \eqn{1}{1}-D continuous lag spatial Markov chain.}

\usage{transiogram(data, coords, direction, max.dist = Inf, 
            mpoints = 20, tolerance = pi / 8, reverse = FALSE)}

\arguments{
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{max.dist}{a numerical value which defines the maximum lag value. It's \code{Inf} by default.}
  \item{mpoints}{a numerical value which defines the number of lag intervals.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It's \code{pi/8} by default.}
  \item{reverse}{a logical value. If \code{TRUE} the transition probabilities of the reversible chain are also computed. It's \code{FALSE} by default.}
}

\details{
Empirical probabilities are estimated by counting such pairs of observations which satisfy some properties, and by normalizing the result.

A generic pair of sample points \eqn{s_i}{s_i} and \eqn{s_j}{s_j}, where \eqn{i \neq j}{i != j}, must satisfy the following properties:
\itemize{
  \item \eqn{\Vert s_i - s_j \Vert \in [a, a+\frac{m}{n}],}{a < ||s_i - s_j|| < a + m / n,} where \eqn{a}{a} is a non negative real value, while \eqn{m}{m} denotes the maximum lag value (\code{max.dist}) and \eqn{n}{n} is the number of lag intervals (\code{mpoints}).
  \item the lag vector \eqn{h = s_i - s_j}{h = s_i - s_j} must have the same direction of the vector \eqn{\phi}{phi} (\code{direction}) with a certain angular \code{tolerance}.
}
}

\value{
An object of the class \code{transiogram} is returned. The function \code{\link{print.transiogram}} is used to print computed probabilities. The object is a list with the following components: 
  \item{Tmat}{a 3-D array containing the probabilities.}
  \item{LOSE}{a 3-D array containing the standard error calculated for the log odds of the transition probabilities.}
  \item{lags}{a vector containing one-dimensional lags.}
  \item{type}{a character string which specifies that computed probabilities are empirical.}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{predict.tpfit}}, \code{\link{predict.tpfit}}, \code{\link{plot.transiogram}}}

\examples{\donttest{
data(ACM)

# Estimate empirical transition 
# probabilities by points
transiogram(ACM$MAT3, ACM[, 1:3], c(0, 0, 1), 200, 5)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{summary.lengths}
\Rdversion{1.1}
\alias{summary.lengths}

\title{Summarizing Stratum Lengths}

\description{The function summarizes the stratum lengths for each observed category.}

\usage{\method{summary}{lengths}(object, ..., zeros.rm = TRUE)}

\arguments{
  \item{object}{an object of the class \code{lengths}, typically with the output of the function \code{\link{getlen}}.}
  \item{\dots}{further arguments passed to or from other methods.}
  \item{zeros.rm}{a logical values. If \code{FALSE}, summarizing statistics will be computed by including zero values. It is \code{TRUE} by default.}
}

\value{
An object of class \code{summary.lengths} containing the minimum, the first quartile, the median, the mean, the third quartile and the maximum of the stratum lengths for each observed category.
}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{getlen}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Summarize the stratum lengths
sgl <- summary(gl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{print.multi_transiogram}
\Rdversion{1.1}
\alias{print.multi_transiogram}

\title{Printing Theoretical Multidimensional Transiograms}

\description{
The function prints theoretical transition probabilities given by \code{\link{predict.multi_tpfit}}.
}
\usage{\method{print}{multi_transiogram}(x, ...)}

\arguments{
  \item{x}{an object of the class \code{multi_transiogram}, typically with the output of the function \code{\link{predict.multi_tpfit}}.}
  \item{\dots}{further arguments passed to or from other methods.}
}

\value{Transition probabilities are printed on the screen or other output devices. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{predict.multi_tpfit}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# multidimensional MC model
RTm <- multi_tpfit(ACM$MAT3, ACM[, 1:3])

# Generate the matrix of 
# multidimensional lags
lags <- expand.grid(X=-1:1, Y=-1:1, Z=-1:1)
lags <- as.matrix(lags)

# Compute transition probabilities 
# from the multidimensional MC model
TrPr <- predict(RTm, lags)

# Print results
print(TrPr)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{predict.multi_tpfit}
\Rdversion{1.1}
\alias{predict.multi_tpfit}

\title{Compute Theoretical Multidimensional Transiograms}

\description{
The function computes theoretical transition probabilities of a \eqn{d}{d}-D continuous-lag spatial Markov chain for a specified set of lags.
}

\usage{\method{predict}{multi_tpfit}(object, lags, byrow = TRUE, ...)}

\arguments{
  \item{object}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{lags}{a lag vector or matrix of \eqn{d}{d}-D lags.}
  \item{byrow}{a logical value; if \code{TRUE} (by default), each row of matrix argument \code{lags} will be considered as a lag vector.}
  \item{\dots}{further arguments passed from other methods.}
}

\details{
A \eqn{d}{d}-D continuous-lag spatial Markov chain is probabilistic model which is developed by interpolation of the transition rate matrices computed for the main directions. It defines the transition probability \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through the entry \eqn{t_{jk}}{t_(jk)} of the following matrix
\deqn{T = \mbox{expm} (\Vert h \Vert R),}{T = expm(||h|| R),}
where \eqn{h}{h} is the lag vector and the entries of \eqn{R}{R} are ellipsoidally interpolated.
}

\value{
An object of the class \code{multi_transiogram} is returned. The \code{\link{print.multi_transiogram}} function is used to print computed probabilities. The object is a list with the following components: 
  \item{Tmat}{a 3-D array containing the probabilities.}
  \item{lags}{a matrix containing the lag vectors.}
  \item{type}{a character string which specifies that computed probabilities are theoretical.}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{multi_tpfit}}, \code{\link{print.multi_tpfit}}, \code{\link{image.multi_tpfit}}, \code{\link{tpfit}}, \code{\link{transiogram}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# multidimensional MC model
RTm <- multi_tpfit(ACM$MAT3, ACM[, 1:3])

# Generate the matrix of 
# multidimensional lags
lags <- expand.grid(X=-1:1, Y=-1:1, Z=-1:1)
lags <- as.matrix(lags)

# Compute transition probabilities 
# from the multidimensional MC model
predict(RTm, lags)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{plot.hist.lengths}
\Rdversion{1.1}
\alias{plot.hist.lengths}

\title{Plot Histograms of Stratum Lengths}

\description{The function plots objects of class \code{hist.lengths}.}

\usage{\method{plot}{hist.lengths}(x, ...)}

\arguments{
  \item{x}{an object of the class \code{hist.lengths}, typically with the output of the function \code{\link{hist.lengths}}.}
  \item{\dots}{further plotting parameters.}
}

\value{An image is produced on the current graphics device. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{hist}}, \code{\link{hist.lengths}}, \code{\link{plot}}, \code{\link{print.density.lengths}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Compute the histograms
hgl <- hist(gl, plot = FALSE)

# Plot the histograms
plot(hgl, col = "#efffef")
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{which_lines}
\Rdversion{1.1}
\alias{which_lines}

\title{Points Classification through Directional Lines}

\description{The function classifies points which appertain to a same directional line.}

\usage{which_lines(coords, direction, tolerance = pi / 8)}

\arguments{
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It's \code{pi/8} by default.}
}

\details{
The algorithm used by this function searches the nearest points to a directional line. The function classifies such pairs of points that have the minimum distance and the same direction of the vector \eqn{\phi}{phi}.

This operation is done to order points, so that it's possible to compute mean lengths (\link{mlen}) and embedded transition probabilities (\link{embed_MC}).
}

\value{A numerical vector containing the line number for each point.}

\references{Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{embed_MC}}, \code{\link{mlen}}, \code{\link{getlen}}}

\examples{\donttest{
data(ACM)

direction <- c(0,0,1)

loc.id <- which_lines(ACM[, 1:3], direction)}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{classif}

\name{tpfit}
\Rdversion{1.1}
\alias{tpfit}

\title{One-dimensional Model Parameters Estimation}

\description{
The function estimates the model parameters of a 1-D continuous lag spatial Markov chain. Transition rates matrix along a user defined direction and proportions of categories are computed.
}

\usage{tpfit(data, coords, direction, method = "ml",
      tolerance = pi/8, max.it = 9000, mle = "avg", ...)}

\arguments{
%%         data vector of data
%%       coords coordinates matrix
%%    direction vector (or versor) of choosen direction
%%       method estimation method c("ml", "ils", "me")
%%    tolerance angle tolerance (in radians)
%%       max.it maximum number of iterations for the optimization (used only for the 'me' method)
%%          mle argument to pass to the function mlen (not used for the 'ils' method)
%%          ... further arguments to pass to tpfit_ils function, such as:
%%              * max.dist maximum distance for counting
%%              *  mpoints number of lags
%%              *        q constant greater than one controlling the growth of rho
%%              *     echo logical value to print the optimization output
%%              *      ... further arguments to pass to nlminb function
%%              *    tpfit tpfit object for a further optimization
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{method}{a character object specifying the method to estimate the transition rates. Possible choises are \code{"ml"} (by default) for the mean length method, \code{"ils"} for the iterated least squares and \code{"me"} for the maximum entropy method.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It's \code{pi/8} by default.}
  \item{max.it}{a numerical value which denotes the maximum number of iterations to perform during the optimization phase. It is \code{9000} by default and used only when the method is \code{"me"}.}
  \item{mle}{a character value to pass to the function \code{\link{mlen}}. It is \code{"avg"} by default and not use when the method is \code{"ils"}.}
  \item{\dots}{other arguments to pass to the functions \code{\link{tpfit_ml}}, \code{\link{tpfit_ils}} or \code{\link{tpfit_me}}.}
}

\details{
A 1-D continuous-lag spatial Markov chain is probabilistic model which involves a transition rate matrix \eqn{R}{R} computed for the direction \eqn{\phi}{phi}. It defines the transition probability \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through the entry \eqn{t_{jk}}{t_(jk)} of the following matrix
\deqn{T = \mbox{expm} (h R),}{T = expm(h R),}
where \eqn{h}{h} is a positive lag value.

Three methods are available to calculate entries of the transition rate matrix. The mean length method is performed by the use of the function \code{\link{tpfit_ml}}, the iterated least squares are applied through the function \code{\link{tpfit_ils}}, while the function \code{\link{tpfit_me}} implements the maximum entropy method.
}

\value{
An object of the class \code{tpfit} is returned. The function \code{\link{print.tpfit}} is used to print the fitted model. The object is a list with the following components: 
  \item{coefficients}{the transition rates matrix computed for the user defined direction.}
  \item{prop}{a vector containing the proportions of each observed category.}
  \item{tolerance}{a numerical value which denotes the tolerance angle (in radians).}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{predict.tpfit}}, \code{\link{print.tpfit}}, \code{\link{multi_tpfit}}, \code{\link{transiogram}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# one-dimensional MC model
tpfit(ACM$MAT5, ACM[, 1:3], c(0, 0, 1))
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{hist.lengths}
\Rdversion{1.1}
\alias{hist.lengths}

\title{Histograms of Stratum Lengths for Each Observed Category}

\description{The function compute the histograms of the stratum lengths for each category. If \code{plot = TRUE}, the resulting object of class \code{hist.lengths} is plotted before it is returned.}

\usage{\method{hist}{lengths}(x, ..., log = FALSE, zeros.rm = TRUE)}

\arguments{
  \item{x}{an object of the class \code{lengths}, typically with the output of the function \code{\link{getlen}}.}
  \item{\dots}{further arguments to pass to the function \code{\link{hist}}.}
  \item{log}{a logical value. If \code{TRUE}, histograms will be calculated for the logarithm of the lengths. It is \code{FALSE} by default.}
  \item{zeros.rm}{a logical value. If \code{FALSE}, histograms will be computed by including zero values. It is \code{TRUE} by default.}
}

\value{If \code{plot = TRUE}, an image is produced on the current graphics device. The function returns an object of class \code{hist.lengths}. It contains class \code{histogram} objects, the given direction of the stratum lengths and a logical value which points out if histograms are computed for the logarithm of stratum lengths.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{getlen}}, \code{\link{hist}}, \code{\link{density.lengths}}, \code{\link{plot.density.lengths}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Plot the histograms
hist(gl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{sim_path}
\Rdversion{1.1}
\alias{sim_path}

\title{Conditional Simulation Based on Path Algorithms}

\description{
The function simulates a random field through the Fixed Path algorithm or Random Path technique.
}

\usage{sim_path(x, data, coords, grid, radius, fixed = FALSE, entropy = FALSE)}

\arguments{
%%        x a multi_tpfit object
%%     data vector of data
%%   coords coordinates matrix
%%     grid simulation points
%%   radius radius to find neighbour points
%%    fixed boolean for random or fixed path algorithm
%%  entropy logical value to compute uncertainties
  \item{x}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{grid}{an \eqn{m \times d}{m x d} matrix where each row denotes the \eqn{d}{d}-D coordinates in the simulation grid.}
  \item{radius}{a numerical value that specifies a proper radius to search the nearest observed points within a \eqn{d}{d}-D sphere.}
  \item{fixed}{a logical value; if \code{TRUE}, the fixed path algorithm is performed. The random path algorithm is performed by default.}
  \item{entropy}{a logical value. If \code{TRUE}, the prediction uncertainties are computed through the entropy (and standardized entropy). The default value is \code{FALSE}.}
}

\details{
These methods compute an approximation of posterior probabilities
\deqn{\Pr\left(Z(\mathbf{s}_0) = z_k \left\vert \bigcap_{i = 1}^n Z(\mathbf{s}_i) = z(\mathbf{s}_i)\right.\right).}{Pr(Z(s_0) = z_k | Z(s_i) = z(s_i)),}
\eqn{\mbox{\hspace{0cm}}}{where i = 1, ..., n.} Path algorithms are based on Pickard random fields, so that the states of such chain at any unsampled location depends on the state of its nearest known neighbours in axial directions.
}

\value{A data frame containing the simulation grid, the simulated random field, predicted values and the approximated probabilities is returned. Two extra columns respectively denoting the entropy and standardized entorpy are bindend to the data frame when argument \code{entropy = TRUE}.}

\references{Li, W. (2007) A Fixed-Path Markov Chain Algorithm for Conditional Simulation of Discrete Spatial Variables. \emph{Mathematical Geology}, \bold{39}(2), 159-176.

Li, W. (2007) Markov Chain Random Fields for Estimation of Categorical Variables. \emph{Mathematical Geology}, \bold{39}(June), 321-335.

Pickard, D. K. (1980) Unilateral Markov Fields. \emph{Advances in Applied Probability}, \bold{12}(3), 655-671.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}
%%\note{
%%%%  ~~further notes~~
%%}

\seealso{\code{\link{sim_ck}}, \code{\link{sim_ik}}, \code{\link{sim_mcs}}}

\examples{\donttest{
data(ACM)

# Model parameters estimation for the
# multinomial categorical simulation
x <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Generate the simulation grid
mygrid <- list()
mygrid$X <- seq(min(ACM$X), max(ACM$X), length = 20)
mygrid$Y <- seq(min(ACM$Y), max(ACM$Y), length = 20)
mygrid$Z <- -40 * 0:9 - 1
mygrid <- as.matrix(expand.grid(mygrid$X, mygrid$Y, mygrid$Z))

# Simulate the random field through
# the fixed path algorithm
myFixPathSim <- sim_path(x, ACM$MAT5, ACM[, 1:3], mygrid,
                         radius = 50, fixed = TRUE)

# Simulate the random field through
# the random path algorithm
myRndPathSim <- sim_path(x, ACM$MAT5, ACM[, 1:3], mygrid, radius = 50)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{sim_mcs}
\Rdversion{1.1}
\alias{sim_mcs}

\title{Multinomial Categorical Simulation}

\description{
The function simulates a random field through the Multinomial Categorical Simulation technique (MCS).
}

\usage{sim_mcs(x, data, coords, grid, knn = NULL, entropy = FALSE)}

\arguments{
%%        x a multi_tpfit object
%%     data vector of data
%%   coords coordinates matrix
%%     grid simulation points
%%      knn number of k-nearest neighbours (if NULL all data are neighbours)
%%  entropy logical value to compute uncertainties
  \item{x}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{grid}{an \eqn{m \times d}{m x d} matrix where each row denotes the \eqn{d}{d}-D coordinates in the simulation grid.}
  \item{knn}{an integer value which specifies the number of k-nearest neighbours for each simulation point. If \code{NULL} (by default), all observations are considered.}
  \item{entropy}{a logical value. If \code{TRUE}, the prediction uncertainties are computed through the entropy (and standardized entropy). The default value is \code{FALSE}.}
}

\details{
This method computes an approximation of posterior probabilities 
\deqn{\Pr\left(Z(\mathbf{s}_0) = z_k \left\vert \bigcap_{i = 1}^n Z(\mathbf{s}_i) = z(\mathbf{s}_i)\right.\right).}{Pr(Z(s_0) = z_k | Z(s_i) = z(s_i)),}
\eqn{\hspace{0cm}}{where i = 1, ..., n.} The algorithm is based on the Bayesian maximum entropy approach and it honours both the model structure and observed data.
}

\value{A data frame containing the simulation grid, the simulated random field, predicted values and the approximated probabilities is returned. Two extra columns respectively denoting the entropy and standardized entorpy are bindend to the data frame when argument \code{entropy = TRUE}.}

\references{Allard, D., D'Or, D., Froidevaux, R. (2011) An efficient maximum entropy approach for categorical variable prediction. \emph{European Journal of Soil Science}, \bold{62}(3), 381-393.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{sim_ck}}, \code{\link{sim_ik}}, \code{\link{sim_path}}}

\examples{\donttest{
data(ACM)

# Model parameters estimation for the
# multinomial categorical simulation
x <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Generate the simulation grid
mygrid <- list()
mygrid$X <- seq(min(ACM$X), max(ACM$X), length = 3)
mygrid$Y <- seq(min(ACM$Y), max(ACM$Y), length = 3)
mygrid$Z <- -40 * 0:9 - 1
mygrid <- as.matrix(expand.grid(mygrid$X, mygrid$Y, mygrid$Z))

# Simulate the random field
myMCSim <- sim_mcs(x, ACM$MAT5, ACM[, 1:3], mygrid)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{print.density.lengths}
\Rdversion{1.1}
\alias{print.density.lengths}

\title{Printing Empirical Densities Estimates of Stratum Lengths}

\description{he function a summary of the empirical density stratum lengths calculated by \code{\link{density.lengths}}.}

\usage{\method{print}{density.lengths}(x, digits = NULL, ...)}

\arguments{
  \item{x}{an object of the class \code{density.lengths}, typically with the output of the function \code{\link{density.lengths}}.}
  \item{digits}{minimal number of digits, see \code{\link{print.default}}.}
  \item{\dots}{further arguments to pass to the function \code{\link{summary.data.frame}}.}
}

\value{A summary of the empirical distributions is printed on the screen or other output devices. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{density.lengths}}, \code{\link{plot.density.lengths}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appartaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Compute the empirical densities of stratum lengths
dgl <- density(gl)

# Print the empirical densities of stratum lengths
print(dgl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{sim}
\Rdversion{1.1}
\alias{sim}

\title{Random Field Simulation}

\description{
The function simulates a random field. The simulation methods available are based on Indicator Kriging techniques (IK and CK), Fixed and Random Path (PATH) and Multinomial Categorical Simulation (MCS).
}

\usage{sim(x, data, coords, grid, method = "ik", ..., entropy = FALSE)}

\arguments{
%%          x a multi.tpfit object
%%       data vector of data
%%     coords coordinates matrix
%%       grid simulation points
%%     method method to perform prediction and simulation c("ik", "ck", "path", "mcs")
%%        ... further option to pass to the function sim_*
%%    entropy logical value to compute uncertainties
%%
%%   Further arguments for Indicator Kriging (ik) and coKriging (ck)
%%        knn number of k-nearest neighbours
%%   ordinary boolean (if TRUE ordinary Kriging is applied rather than simple Kriging)
%%         GA boolean (if TRUE genetic algorithm is applied rather than simulated annealing)
%%     optype character with the objective function to minimize after the simulation
%%     max.it maximum number of iteration for the optimization method
%%
%%   Further arguments for Fixed and Random Path methods (path)
%%   radius radius to find neighbour points
%%    fixed boolean for random or fixed path algorithm
%%
%%   Further arguments for Multinomial Categorical Simulation (mcs)
%%      knn number of k-nearest neighbours (if NULL all data are neighbours)
%%   radius radius to find neighbour points
  \item{x}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{grid}{an \eqn{m \times d}{m x d} matrix where each row denotes the \eqn{d}{d}-D coordinates in the simulation grid.}
  \item{method}{a character object specifying the method to simulate the random field. Possible choises are \code{"ik"} (by default) for the indicator Kriging, \code{"ck"} for the indicator coKriging, \code{"path"} for the fixed and random path and \code{"mcs"} for the multinomial categorical simulation method.}
  \item{\dots}{other arguments to pass to the functions \code{\link{sim_ik}}, \code{\link{sim_ck}}, \code{\link{sim_path}} or \code{\link{sim_mcs}}.}
  \item{entropy}{a logical value. If \code{TRUE}, the prediction uncertainties are computed through the entropy (and standardized entropy). The default value is \code{FALSE}.}
}

\details{
The methods implemented compute the approximation of posterior probabilities
\deqn{\Pr\left(Z(\mathbf{s}_0) = z_k \left\vert \bigcap_{i = 1}^n Z(\mathbf{s}_i) = z(\mathbf{s}_i)\right.\right).}{Pr(Z(s_0) = z_k | Z(s_i) = z(s_i)),}
\eqn{\hspace{0cm}}{where i = 1, ..., n.}

Once the probabilities are calculated for all the points in the simulation grid, the predictions (based on most probable category) and simulations are returned.
}

\value{A data frame containing the simulation grid, the simulated random field, predicted values and the approximated probabilities is returned. Two extra columns respectively denoting the entropy and standardized entorpy are bindend to the data frame when argument \code{entropy = TRUE}.}

\references{Allard, D., D'Or, D., Froidevaux, R. (2011) An efficient maximum entropy approach for categorical variable prediction. \emph{European Journal of Soil Science}, \bold{62}(3), 381-393.

Carle, S. F., Fogg, G. E. (1996) Transition Probability-Based Indicator Geostatistics. \emph{Mathematical Geosciences}, \bold{28}(4), 453-476.

Carle, S. F. (1999) T-PROGS: Transition Probability Geostatistical Software. University of California, Davis.

Li, W. (2007) A Fixed-Path Markov Chain Algorithm for Conditional Simulation of Discrete Spatial Variables. \emph{Mathematical Geology}, \bold{39}(2), 159-176.

Li, W. (2007) Markov Chain Random Fields for Estimation of Categorical Variables. \emph{Mathematical Geology}, \bold{39}(June), 321-335.

Pickard, D. K. (1980) Unilateral Markov Fields. \emph{Advances in Applied Probability}, \bold{12}(3), 655-671.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.

%Tolosana-Delgado, R., Pawlowsky-Glahn, V., Egozcue, J.J. (2008) Indicator Kriging without Order Relation Violations. \emph{Mathematical Geosciences}, \bold{40}(3), 327-347.

Weise, T. (2009) \emph{Global Optimization Algorithms - Theory and Application}. \url{https://www.researchgate.net/publication/200622167_Global_Optimization_Algorithm_Theory_and_Application}.}

\seealso{\code{\link{sim_ik}}, \code{\link{sim_ck}}, \code{\link{sim_path}}, \code{\link{sim_mcs}}}

\examples{\donttest{
data(ACM)

# Model parameters estimation for the
# multinomial categorical simulation
x <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Generate the simulation grid
mygrid <- list()
mygrid$X <- seq(min(ACM$X), max(ACM$X), length = 20)
mygrid$Y <- seq(min(ACM$Y), max(ACM$Y), length = 20)
mygrid$Z <- -40 * 0:9 - 1
mygrid <- as.matrix(expand.grid(mygrid$X, mygrid$Y, mygrid$Z))

# Simulate the random field through
# Simple Indicator Kriging algorithm and
mySim <- sim(x, ACM$MAT5, ACM[, 1:3], mygrid)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{print.transiogram}
\Rdversion{1.1}
\alias{print.transiogram}

\title{Printing Theoretical or Empirical One-dimensional Transiograms}

\description{The function prints transition probabilities given by \code{\link{predict.multi_tpfit}} or \code{\link{transiogram}}.}

\usage{\method{print}{transiogram}(x, ...)}

\arguments{
  \item{x}{an object of the class \code{transiogram}, typically with the output of the function \code{\link{predict.tpfit}} or \code{\link{transiogram}}.}
  \item{\dots}{further arguments passed to or from other methods.}
}

\value{Transition probabilities are printed on the screen or other output devices. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{transiogram}}, \code{\link{predict.tpfit}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# one-dimensional MC model
RTm <- tpfit(ACM$MAT5, ACM[, 1:3], c(0, 0, 1))

# Compute theoretical transition probabilities 
# from the one-dimensional MC model
TTPr <- predict(RTm, lags = 0:2/2)

# Compute empirical transition probabilities 
ETPr <- transiogram(ACM$MAT5, ACM[, 1:3], c(0, 0, 1), 200, 20)

# Print results
print(TTPr)
print(ETPr)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{plot.transiogram}
\Rdversion{1.1}
\alias{plot.transiogram}

\title{Plot One-dimensional Transiograms}

\description{
The function makes a graphical representation of transition probabilities by the use of transiogram.
}

\usage{\method{plot}{transiogram}(x, ..., main, legend = FALSE, ci = NULL)}

\arguments{
  \item{x}{an object of the class \code{transiogram}, typically with the output of the function \code{\link{transiogram}} or \code{\link{predict.tpfit}}.}
  \item{\dots}{other arguments to pass to the function \code{\link{plot}}.}
  \item{main}{the main title (on top) whose font and size are fixed.}
  \item{legend}{a logical value; if \code{TRUE}, the legend is plot on the bottom.}
  \item{ci}{a numerical value in the interval (0, 1) denoting the confidence of the interval around transition probabilities. If \code{NULL} (by default), no confidence interval is plotted.}
}

\details{
Transiogram is a diagram which is drawn for a single pair of categories in the direction \eqn{\phi}{phi}. It shows the transition probabilities in the \eqn{y}{y}-axis for some specific lags in the \eqn{x}{x}-axis.

Confidence intervals are computed on the log odds of the transition probabilities. The approximation of the confidence bounds is based on the delta method applied on the logistic transformation.
}

\value{An image is produced on the current graphics device. No values are returned.}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Li, W. (2007) Transiograms for Characterizing Spatial Variability of Soil Classes. \emph{Soil Science Society of America Journal}, \bold{71}(3), 881-893.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}
%%\note{
%%%%  ~~further notes~~
%%}

\seealso{\code{\link{tpfit}}, \code{\link{predict.tpfit}}, \code{\link{mixplot}}, \code{\link{image.multi_tpfit}}, \code{\link{plot}}}

\examples{\donttest{
data(ACM)

# Estimate empirical transition 
# probabilities by points
ETr <- transiogram(ACM$MAT3, ACM[, 1:3], c(0, 0, 1), 100, 100)

# Estimate the transition rate matrix
RTm <- tpfit(ACM$MAT3, ACM[, 1:3], c(0, 0, 1))

# Compute transition probabilities 
# from the one-dimensional MC model
TPr <- predict(RTm, lags = ETr$lags)

# Plot empirical transition probabilities
plot(ETr, type = "l", ci = 0.99)

# Plot theoretical transition probabilities
plot(TPr, type = "l")
}}

\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{boxplot.lengths}
\Rdversion{1.1}
\alias{boxplot.lengths}

\title{Stratum Lengths Boxplot}

\description{Produce box-and-whisker plots of the stratum lengths.}

\usage{\method{boxplot}{lengths}(x, ..., log = FALSE, zeros.rm = TRUE)}

\arguments{
  \item{x}{an object of the class \code{lengths}, typically with the output of the function \code{\link{getlen}}.}
  \item{\dots}{other arguments to pass to the function \code{\link{boxplot}}.}
  \item{log}{a logical value. If \code{TRUE}, the logarithm of the stratum lengths will be plotted. It is \code{FALSE} by default.}
  \item{zeros.rm}{a logical value. If \code{FALSE}, the box-and-whisker will be drawn by including zero values. It is \code{TRUE} by default.}
}

\details{The box-and-whisker plots give some information about the distribution of the stratum lengths for the observed categories along a given direction.}

\value{An image is produced on the current graphics device. The function returns a list with the following components:
  \item{stats}{a matrix containing the values used to plot the box-and-whisker plots.}
  \item{n}{a vector with the number of observations for each category.}
  \item{conf}{a matrix containing further values to draw the lower and upper extremes of the notch.}
  \item{out}{a vectors with the values of the outlier points.}
  \item{group}{a vector whose elements indicate to which category the outlier belongs.}
  \item{names}{a character vector with the names of each category.}
}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{plot.lengths}}, \code{\link{boxplot}}, \code{\link{getlen}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)

# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)

# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Make the boxplot of the object gl
\dontshow{par(mfrow = c(1, 1))}
boxplot(gl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{plot.density.lengths}
\Rdversion{1.1}
\alias{plot.density.lengths}

\title{Plot Empirical Densities Estimates of Stratum Lengths}

\description{The function plot the empirical densities of stratum lengths computed along a given direction.}

\usage{\method{plot}{density.lengths}(x, main = NULL, xlab = NULL, ylab = "Density", type = "l",
     zero.line = TRUE, ...)}

\arguments{
  \item{x}{an object of the class \code{density.lengths}, typically with the output of the function \code{\link{density.lengths}}.}
  \item{main}{an overall title for the plot.}
  \item{xlab}{a title for the \eqn{x}{x}-axis.}
  \item{ylab}{a title for the \eqn{y}{y}-axis.}
  \item{type}{plotting parameter for the type of graphic (see \code{\link{plot}}).}
  \item{zero.line}{logical value. If \code{TRUE} (by default), the function adds a base line at \eqn{y = 0}{y = 0}.}
  \item{\dots}{other plotting parameters.}
}

\value{An image is produced on the current graphics device. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{density.default}}, \code{\link{density.lengths}}, \code{\link{plot}}, \code{\link{print.density.lengths}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Compute the empirical densities of stratum log-lengths
dgl <- density(gl, log = TRUE)

# Plot the empirical densities of stratum log-lengths
plot(dgl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{sim_ck}
\Rdversion{1.1}
\alias{sim_ck}

\title{Conditional Simulation Based on Indicator Cokriging}

\description{
The function simulates a random field through the Indicator Cokriging technique.
}

\usage{
sim_ck(x, data, coords, grid, knn = 12, ordinary = TRUE, entropy = FALSE)}

\arguments{
%%        x a multi_tpfit object
%%     data vector of data
%%   coords coordinates matrix
%%     grid simulation points
%%      knn number of k-nearest neighbours
%% ordinary boolean (if TRUE ordinary coKriging is applied rather than simple Kriging)
%%       GA boolean (if TRUE genetic algorithm is applied rather than simulated annealing)
%%   optype character with the objective function to minimize after the simulation
%%   max.it maximum number of iteration for the optimization method
%%  entropy logical value to compute uncertainties
  \item{x}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{grid}{an \eqn{m \times d}{m x d} matrix where each row denotes the \eqn{d}{d}-D coordinates in the simulation grid.}
  \item{knn}{an integer value which specifies the number of k-nearest neighbours for each simulation point. An optimal number is between 4 and 12. If \code{NULL} all observations are considered (just for very small dataset!!). It is \code{12} by default.}
  \item{ordinary}{a logical value; if \code{FALSE}, the probabilities are computed through the Simple coKriging technique, otherwise the Ordinary coKriging method is used.}
  \item{entropy}{a logical value. If \code{TRUE}, the prediction uncertainties are computed through the entropy (and standardized entropy). The default value is \code{FALSE}.}
}

\details{
This method computes an approximation of posterior probabilities
\deqn{\Pr\left(Z(\mathbf{s}_0) = z_k \left\vert \bigcap_{i = 1}^n Z(\mathbf{s}_i) = z(\mathbf{s}_i)\right.\right).}{Pr(Z(s_0) = z_k | Z(s_i) = z(s_i)),}
\eqn{\hspace{0cm}}{where i = 1, ..., n.}

The probability is calculated as the weighted sum of indicator variables which denote the presence of the \eqn{k}{k}-th category in observed points \eqn{\mathbf{s}_i}{s_i}. Weights involved in the sum are the solution of a system of equations.

Probabilities approximated are usually truncated and normalized with respect to the probability constraints, because such probabilities might lie outside the interval \eqn{[0, 1]}{[0, 1]}. The normalization procedure is designed such that it is not possible to obtain vectors such that the sum of their probabilities is always equal to one.

When an initial configuration is simulated, it should be modified to reach a pattern similar to the sample by the use of the \code{\link{quench}} function.
}

\value{A data frame containing the simulation grid, the simulated random field, predicted values and the approximated probabilities is returned. Two extra columns respectively denoting the entropy and standardized entorpy are bindend to the data frame when argument \code{entropy = TRUE}.}

\references{Carle, S. F., Fogg, G. E. (1996) Transition Probability-Based Indicator Geostatistics. \emph{Mathematical Geosciences}, \bold{28}(4), 453-476.

Carle, S. F. (1999) T-PROGS: Transition Probability Geostatistical Software. University of California, Davis.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.

%Tolosana-Delgado, R., Pawlowsky-Glahn, V., Egozcue, J.J. (2008) Indicator Kriging without Order Relation Violations. \emph{Mathematical Geosciences}, \bold{40}(3), 327-347.

Weise, T. (2009) \emph{Global Optimization Algorithms - Theory and Application}. \url{https://www.researchgate.net/publication/200622167_Global_Optimization_Algorithm_Theory_and_Application}.}

\author{Luca Sartore \email{drwolf85@gmail.com}}
%%\note{
%%%%  ~~further notes~~
%%}

\seealso{\code{\link{sim_ik}}, \code{\link{sim_mcs}}, \code{\link{sim_path}}}

\examples{\donttest{
data(ACM)

# Model parameters estimation for the
# multinomial categorical simulation
x <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Generate the simulation grid
mygrid <- list()
mygrid$X <- seq(min(ACM$X), max(ACM$X), length = 20)
mygrid$Y <- seq(min(ACM$Y), max(ACM$Y), length = 20)
mygrid$Z <- -40 * 0:9 - 1
mygrid <- as.matrix(expand.grid(mygrid$X, mygrid$Y, mygrid$Z))

# Simulate the random field through
# Simple Indicator Cokriging algorithm
mySCKSim <- sim_ck(x, ACM$MAT5, ACM[, 1:3], mygrid, ordinary = FALSE)

# Simulate the random field through
# Ordinary Indicator Cokriging algorithm
myOCKSim <- sim_ck(x, ACM$MAT5, ACM[, 1:3], mygrid)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{mixplot}
\Rdversion{1.1}
\alias{mixplot}

\title{Plot of Multiple One-dimensional Transiograms}

\description{
The function makes a graphical representation of transition probabilities by the use of multiple transiograms.
}

\usage{
mixplot(x, main, legend = TRUE, ...)
}

\arguments{
  \item{x}{a \code{list} object whose elements are of the class \code{transiogram} (typically with the output of the function \code{\link{transiogram}} or \code{\link{predict.tpfit}}).}
  \item{main}{the main title (on top) whose font and size are fixed.}
  \item{legend}{a logical value for printing the legend in the graphic. It is \code{TRUE} by default.}
  \item{\dots}{other arguments to pass to the function \code{\link{plot}}.}
}

\details{
Transiogram is a diagram which is drawn for a single pair of categories in the direction \eqn{\phi}{phi}. It shows the transition probabilities in the \eqn{y}{y}-axis for some specific lags in the \eqn{x}{x}-axis.

This function permits a graphical approach to compare theoretical vs. empirical transition probabilities for multiple directions.
}

\value{An image is produced on the current graphics device. No values are returned.}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Li, W. (2007) Transiograms for Characterizing Spatial Variability of Soil Classes. \emph{Soil Science Society of America Journal}, \bold{71}(3), 881-893.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}
%%\note{
%%%%  ~~further notes~~
%%}

\seealso{\code{\link{transiogram}}, \code{\link{tpfit}}, \code{\link{predict.tpfit}}, \code{\link{plot.transiogram}}, \code{\link{image.multi_tpfit}}, \code{\link{plot}}}

\examples{\donttest{
data(ACM)

# Estimate empirical transition 
# probabilities by points
ETr <- transiogram(ACM$MAT3, ACM[, 1:3], c(0, 0, 1), 100)

# Estimate the transition rate matrix
RTm <- tpfit(ACM$MAT3, ACM[, 1:3], c(0, 0, 1))

# Compute transition probabilities 
# from the one-dimensional MC model
TPr <- predict(RTm, lags = ETr$lags)

# Plot empirical vs. theoretical transition probabilities
mixplot(list(ETr, TPr), type = c("p", "l"), pch = "+", col = c(3, 1))
}}

\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{tpfit_ils}
\Rdversion{1.1}
\alias{tpfit_ils}

\title{Iterated Least Squares Method for One-dimensional Model Parameters Estimation}

\description{
The function estimates the model parameters of a 1-D continuous lag spatial Markov chain by the use of the iterated least squares and the bound-constrained Lagrangian methods. Transition rates matrix along a user defined direction and proportions of categories are computed.
}

\usage{tpfit_ils(data, coords, direction, max.dist = Inf, mpoints = 20, 
          tolerance = pi/8, q = 10, echo = FALSE, ..., tpfit)}

\arguments{
%%         data vector of data
%%       coords coordinates matrix
%%    direction vector (or versor) of chosen direction
%%     max.dist maximum distance for counting
%%      mpoints number of lags
%%    tolerance angle tolerance (in radians)
%%         echo logical value to print the optimization output
%%            q constant greater than one controlling the growth of rho
%%          ... further arguments to pass to nlminb function
%%        tpfit tpfit object for a further optimization
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{max.dist}{a numerical value which defines the maximum lag value. It's \code{Inf} by default.}
  \item{mpoints}{a numerical value which defines the number of lag intervals.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It's \code{pi/8} by default.}
  \item{q}{a numerical value greater than one for a constant which controls the growth of the penalization term in the loss function. It is equal to \code{10} by default.}
  \item{echo}{a logical value; if \code{TRUE}, the function prints some information about the optimization. It is \code{FALSE} by default.}
  \item{\dots}{other arguments to pass to the function \code{\link{nlminb}}.}
  \item{tpfit}{an object \code{tpfit} to optimize. If missing, the algorithm starts with a null transition rates matrix.}
}

\details{
A 1-D continuous-lag spatial Markov chain is probabilistic model which involves a transition rate matrix \eqn{R}{R} computed for the direction \eqn{\phi}{phi}. It defines the transition probability \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through the entry \eqn{t_{jk}}{t_(jk)} of the following matrix
\deqn{T = \mbox{expm} (h R),}{T = expm(h R),}
where \eqn{h}{h} is a positive lag value.

To calculate entries of the transition rate matrix, we need to minimize the discrepancies between the empirical transiogram (see \code{\link{transiogram}}) and the predicted transition probabilities.

By the use of the iterated least squares, the diagonal entries of \eqn{R}{R} are constrained to be negative,
while the off-diagonal transition rates are constrained to be positive. Further constraints are considered in order to obtain a proper transition rates matrix.
}

\value{
An object of the class \code{tpfit} is returned. The function \code{\link{print.tpfit}} is used to print the fitted model. The object is a list with the following components: 
  \item{coefficients}{the transition rates matrix computed for the user defined direction.}
  \item{prop}{a vector containing the proportions of each observed category.}
  \item{tolerance}{a numerical value which denotes the tolerance angle (in radians).}
}

\references{Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\section{Warning}{If the process is not stationary, the optimization algorithm does not converge.}

\seealso{\code{\link{predict.tpfit}}, \code{\link{print.tpfit}}, \code{\link{multi_tpfit_ils}}, \code{\link{transiogram}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# one-dimensional MC model
tpfit_ils(ACM$MAT3, ACM[, 1:3], c(0,0,1), 100)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{print.multi_tpfit}
\Rdversion{1.1}
\alias{print.multi_tpfit}

\title{Printing Model Parameters for Multidimensional Continuous Lag Spatial MC}

\description{The function prints parameter estimation results given by \code{\link{multi_tpfit}}.}

\usage{\method{print}{multi_tpfit}(x, ...)}

\arguments{
  \item{x}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{\dots}{further arguments passed to or from other methods.}
}

\value{Estimation results are printed on the screen or other output devices. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{multi_tpfit}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# multidimensional MC models
MoPa <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Print results
print(MoPa)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{multi_tpfit_ils}
\Rdversion{1.1}
\alias{multi_tpfit_ils}

\title{Iterated Least Squares Method for Multidimensional Model Parameters Estimation}

\description{
The function estimates the model parameters of a \eqn{d}{d}-D continuous lag spatial Markov chain by the use of the iterated least squares and the bound-constrained Lagrangian methods. Transition rates matrices along axial directions and proportions of categories are computed.
}

\usage{multi_tpfit_ils(data, coords, max.dist = Inf, mpoints = 20,
                tolerance = pi/8, rotation = NULL, q = 10,
                echo = FALSE, ..., mtpfit)}

\arguments{
%%         data vector of data
%%       coords coordinates matrix
%%     max.dist maximum distance for counting (expressed for each direction)
%%      mpoints number of lags (expressed for each direction)
%%    tolerance angle for tolerance (in radians, expressed for each direction)
%%     rotation vector of rotation angles (in radians)
%%            q constant greater than one controlling the growth of rho
%%         echo logical value to print the optimization output
%%          ... further arguments to pass to nlminb function
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{max.dist}{a numerical value which defines the maximum lag value. It is \code{Inf} by default.}
  \item{mpoints}{a numerical value which defines the number of lag intervals.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It is \code{pi/8} by default.}
  \item{rotation}{a numerical vector of length \eqn{d - 1}{d - 1} with rotation angles (in radians), in order to perform the main axes rotation. No rotation is performed by default.}
  \item{q}{a numerical value greater than one for a constant which controls the growth of the penalization term in the loss function. It is equal to \code{10} by default.}
  \item{echo}{a logical value; if \code{TRUE}, the function prints some information about the optimization. It is \code{FALSE} by default.}
  \item{\dots}{other arguments to pass to the function \code{\link{nlminb}}.}
  \item{mtpfit}{an object \code{multi_tpfit} to optimize. If missing, the algorithm starts with null transition rates matrices.}
}

\details{
A \eqn{d}{d}-D continuous-lag spatial Markov chain is probabilistic model which is developed by interpolation of the transition rate matrices computed for the main directions. It defines transition probabilities \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through
\deqn{\mbox{expm} (\Vert h \Vert R),}{expm(||h|| R),}
where \eqn{h}{h} is the lag vector and the entries of \eqn{R}{R} are ellipsoidally interpolated.

The ellipsoidal interpolation is given by
\deqn{\vert r_{jk} \vert = \sqrt{\sum_{i = 1}^d \left( \frac{h_i}{\Vert h \Vert} r_{jk, \mathbf{e}_i} \right)^2},}{|r_(jk, h)| = sqrt(sum_{i = 1}^d h_i / ||h|| r_(jk, e_i)),}
where \eqn{\mathbf{e}_i}{e_i} is a standard basis for a \eqn{d}{d}-D space.

If \eqn{h_i < 0}{h_i < 0} the respective entries \eqn{r_{jk, \mathbf{e}_i}}{r_(jk, e_i)} are replaced by \eqn{r_{jk, -\mathbf{e}_i}}{r_(jk, -e_i)}, which is computed as
\deqn{r_{jk, -\mathbf{e}_i} = \frac{p_k}{p_j} \, r_{kj, \mathbf{e}_i},}{r_(jk, -e_i) = p_k / p_j * r_(kj, e_i),}
where \eqn{p_k}{p_k} and \eqn{p_j}{p_j} respectively denote the proportions for the \eqn{k}{k}-th and \eqn{j}{j}-th categories. In so doing, the model may describe the anisotropy of the process.

In particular, to estimate entries of transition rate matrices computed for the main axial directions, we need to minimize the discrepancies between the empirical transiograms (see \code{\link{transiogram}}) and the predicted transition probabilities.

By the use of the iterated least squares, the diagonal entries of \eqn{R}{R} are constrained to be negative, while the off-diagonal transition rates are constrained to be positive. Further constraints are considered in order to obtain a proper transition rates matrix.
}

\value{
An object of the class \code{multi_tpfit} is returned. The function \code{\link{print.multi_tpfit}} is used to print the fitted model. The object is a list with the following components: 
  \item{coordsnames}{a character vector containing the name of each axis.}
  \item{coefficients}{a list containing the transition rates matrices computed for each axial direction.}
  \item{prop}{a vector containing the proportions of each observed category.}
  \item{tolerance}{a numerical value which denotes the tolerance angle (in radians).}
}

\references{Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\section{Warning}{If the process is not stationary, the optimization algorithm does not converge.}

\seealso{\code{\link{predict.multi_tpfit}}, \code{\link{print.multi_tpfit}}, \code{\link{image.multi_tpfit}}, \code{\link{tpfit_ils}}, \code{\link{transiogram}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# multidimensional MC model
multi_tpfit_ils(ACM$MAT3, ACM[, 1:3], 100)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{multi_tpfit}
\Rdversion{1.1}
\alias{multi_tpfit}

\title{Multidimensional Model Parameters Estimation}

\description{The function estimates the model parameters of a \eqn{d}{d}-D continuous lag spatial Markov chain. Transition rates matrices along axial directions and proportions of categories are computed.}

\usage{multi_tpfit(data, coords, method = "ml", tolerance = pi/8,
            rotation = NULL, max.it = 9000, mle = "avg", ...)}
\arguments{
%%         data vector of data
%%       coords coordinates matrix
%%       method estimation method c("ml", "ils", "me")
%%    tolerance angle tolerance (in radians)
%%     rotation vector of rotation angles (in radians)
%%       max.it maximum number of iterations for the optimization (used only for the 'me' method)
%%          mle argument to pass to the function mlen (not used for the 'ils' method)
%%          ... further arguments to pass to tpfit_ils function, such as:
%%              * max.dist maximum distance for counting
%%              *  mpoints number of lags
%%              *        q constant greater than one controlling the growth of rho
%%              *     echo logical value to print the optimization output
%%              *      ... further arguments to pass to nlminb function
%%              *    mtpfit mulit_tpfit object for a further optimization
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{method}{a character object specifying the method to estimate the transition rates. Possible choises are \code{"ml"} (by default) for the mean length method, \code{"ils"} for the iterated least squares and \code{"me"} for the maximum entropy method.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It's \code{pi/8} by default.}
  \item{rotation}{a numerical vector of length \eqn{d - 1}{d - 1} with rotation angles (in radians), in order to perform the main axes rotation. No rotation is performed by default.}
  \item{max.it}{a numerical value which denotes the maximum number of iterations to perform during the optimization phase. It is \code{9000} by default and used only when the method is \code{"me"}.}
  \item{mle}{a character value to pass to the function \code{\link{tpfit}}. It is \code{"avg"} by default and not use when the method is \code{"ils"}.}
  \item{\dots}{other arguments to pass to the functions \code{\link{multi_tpfit_ml}}, \code{\link{multi_tpfit_ils}} or \code{\link{multi_tpfit_me}}.}
}

\details{
A \eqn{d}{d}-D continuous-lag spatial Markov chain is probabilistic model which is developed by interpolation of the transition rate matrices computed for the main directions. It defines transition probabilities \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through
\deqn{\mbox{expm} (\Vert h \Vert R),}{expm(||h|| R),}
where \eqn{h}{h} is the lag vector and the entries of \eqn{R}{R} are ellipsoidally interpolated.

The ellipsoidal interpolation is given by
\deqn{\vert r_{jk} \vert = \sqrt{\sum_{i = 1}^d \left( \frac{h_i}{\Vert h \Vert} r_{jk, \mathbf{e}_i} \right)^2},}{|r_(jk, h)| = sqrt(sum_{i = 1}^d h_i / ||h|| r_(jk, e_i)),}
where \eqn{\mathbf{e}_i}{e_i} is a standard basis for a \eqn{d}{d}-D space.

If \eqn{h_i < 0}{h_i < 0} the respective entries \eqn{r_{jk, \mathbf{e}_i}}{r_(jk, e_i)} are replaced by \eqn{r_{jk, -\mathbf{e}_i}}{r_(jk, -e_i)}, which is computed as
\deqn{r_{jk, -\mathbf{e}_i} = \frac{p_k}{p_j} \, r_{kj, \mathbf{e}_i},}{r_(jk, -e_i) = p_k / p_j * r_(kj, e_i),}
where \eqn{p_k}{p_k} and \eqn{p_j}{p_j} respectively denote the proportions for the \eqn{k}{k}-th and \eqn{j}{j}-th categories. In so doing, the model may describe the anisotropy of the process.
}

\value{
An object of the class \code{multi_tpfit} is returned. The function \code{\link{print.multi_tpfit}} is used to print the fitted model. The object is a list with the following components: 
  \item{coordsnames}{a character vector containing the name of each axis.}
  \item{coefficients}{a list containing the transition rates matrices computed for each axial direction.}
  \item{prop}{a vector containing the proportions of each observed category.}
  \item{tolerance}{a numerical value which denotes the tolerance angle (in radians).}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{predict.multi_tpfit}}, \code{\link{print.multi_tpfit}}, \code{\link{image.multi_tpfit}}, \code{\link{tpfit}}}

\examples{\donttest{
data(ACM)

# Estimate transition rates matrices and 
# proportions for the categorical variable MAT5
multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Estimate transition rates matrices and
# proportions for the categorical variable MAT3
multi_tpfit(ACM$MAT3, ACM[, 1:3])

# Estimate transition rates matrices and
# proportions for the categorical variable PERM
multi_tpfit(ACM$PERM, ACM[, 1:3])
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{pemt}
\Rdversion{1.1}
\alias{pemt}

\title{Multi-directional Transiograms Estimation}

\description{
The function computes the multi-directional transiograms without any ellipsoidal interpolation for \eqn{2}{2}-D sections.}

\usage{
pemt(data, coords, mpoints, which.dire, max.dist,
     tolerance = pi/8, rotation = NULL, mle = "avg")
}

\arguments{
%%         data vector of data
%%       coords coordinates matrix
%%      mpoints number of points per axes
%%   which.dire two choosen 1D directions
%%     max.dist vector of maximum distances
%%    tolerance angle tolerance (in radians)
%%     rotation vector of rotation angles (in radians) to pass to multi_tpfit
%%          mle logical value to pass to the function tpfit
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{mpoints}{the number of points per axes. It controls the accuracy of images to plot.}
  \item{which.dire}{a vector with two chosen axial directions. If omitted, all \eqn{2}{2}-D sections are plotted.}
  \item{max.dist}{a scalar or a vector of maximum length for the chosen axial directions.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It's \code{pi/8} by default.}
  \item{rotation}{a numerical vector of length \eqn{d - 1}{d - 1} with rotation angles (in radians), in order to perform the main axes rotation when multidimensional transiogram is estimated. No rotation is performed by default. See \code{\link{multi_tpfit_ml}}.}
  \item{mle}{a character value to pass to the function \code{\link{tpfit_ml}}. It is \code{"avg"} by default.}
}

\details{
A multidimensional transiogram is a diagram which shows the transition probabilities for a single pair of categories. The probability is computed for any lag vector \eqn{h}{h} through 
\deqn{\mbox{expm} (\Vert h \Vert R_h),}{expm(||h|| R),}
where entries of \eqn{R_h}{R} are not ellipsoidally interpolated, but they are estimated for the direction specified by the vector \eqn{h}{h}.

In particular cases, some entries of the estimated matrix \eqn{R_h}{R} might be not finite, so that the exponential matrix is computable and the resulting transition probabilities are set to be \code{NaN}. If \code{mle = "mlk"}, this problem may be partially solved.

The exponential matrix is evaluated by the scaling and squaring algorithm.
}

\value{An object of class \code{pemt} is returned.}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Higham, N. J. (2008) \emph{Functions of Matrices: Theory and Computation}. Society for Industrial and Applied Mathematics.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{multi_tpfit_ml}}, \code{\link{tpfit_ml}}, \code{\link{image.pemt}}, \code{\link{plot.transiogram}}}

\examples{\donttest{
data(ACM)

# Compute a 2-D section of a
# multi-directional transiogram
pemt(ACM$MAT3, ACM[, 1:3], 2,
     max.dist = c(200, 200, 20), 
     which.dire=c(1, 3), mle = "mdn")
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{is.pemt}
\Rdversion{1.1}
\alias{is.pemt}

\title{Images with Multi-direct`ional Transiograms}

\description{
The function plots \eqn{2}{2}-D sections of a multi-directional transiogram computed without any ellipsoidal interpolation.}

\usage{is.pemt(object)}

\arguments{
  \item{object}{object to be tested.}
}

\details{The function returns \code{TRUE} if and only if its argument is a \code{pemt} object.}

\value{A logical value.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{pemt}}, \code{\link{image.pemt}}}

\examples{\donttest{
data(ACM)

# Compute a 2-D section of a
# multi-directional transiogram
psEmpTr <- pemt(ACM$MAT3, ACM[, 1:3], 2,
                max.dist = c(20, 10, 5), 
                which.dire=c(1, 3), 
                mle = TRUE)

# Test the object psEmpTr
is.pemt(psEmpTr)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{attribute}

\name{is.lengths}
\Rdversion{1.1}
\alias{is.lengths}

\title{Object test for lengths class}

\description{Function to test if an object is of the class \code{lengths}.}

\usage{is.lengths(object)}

\arguments{
  \item{object}{object to be tested.}
}

\details{The function returns \code{TRUE} if and only if its argument is a \code{lengths} object.}

\value{A logical value.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{getlen}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Test the object gl
is.lengths(gl)

}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{attribute}

\name{is.transiogram}
\Rdversion{1.1}
\alias{is.transiogram}

\title{Object test for transiogram class}

\description{Function to test if an object is of the class \code{transiogram}.}

\usage{is.transiogram(object)}

\arguments{
\item{object}{object to be tested.}
}

\details{The function returns \code{TRUE} if and only if its argument is a \code{transiogram} object.}

\value{A logical value.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{transiogram}}, \code{\link{predict.tpfit}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# one-dimensional MC model
RTm <- tpfit(ACM$MAT5, ACM[, 1:3], c(0, 0, 1))

# Compute theoretical transition probabilities 
# from the one-dimensional MC model
TTPr <- predict(RTm, lags = 0:2/2)

# Compute empirical transition probabilities 
ETPr <- transiogram(ACM$MAT5, ACM[, 1:3], c(0, 0, 1), 200, 20)

# Test the objects TTPr and ETPr
is.transiogram(TTPr)
is.transiogram(ETPr)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{attribute}

\name{density.lengths}
\Rdversion{1.1}
\alias{density.lengths}

\title{Empirical Densities Estimation of Stratum Lengths}

\description{The function estimates the empirical conditional density of the stratum lengths given the category.}

\usage{\method{density}{lengths}(x, ..., log = FALSE, zeros.rm = TRUE)}

\arguments{
  \item{x}{an object of the class \code{lengths}, typically with the output of the function \code{\link{getlen}}.}
  \item{\dots}{other arguments to pass to the function \code{\link{density.default}}.}
  \item{log}{a logical value. If \code{TRUE}, the output density will be calculated for the logarithm of the lengths. It is \code{TRUE} by default.}
  \item{zeros.rm}{a logical value. If \code{FALSE}, the density will be estimated by including zero values. It is \code{TRUE} by default.}
}

\details{The function estimates the empirical density of the stratum lengths for each category by the use of the kernel methodology.}

\value{An object of class \code{density.lengths} is returned. It contains objects of class \code{density}, the given direction of the stratum lengths and a logical value which points out if the density is computed for the logarithm of stratum lengths.}

\references{Simonoff, J. S. (1996) \emph{Smoothing Methods in Statistics}. Springer-Verlag.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{getlen}}, \code{\link{density.default}}, \code{\link{plot.density.lengths}}, \code{\link{print.density.lengths}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Compute the empirical densities of stratum lengths
dgl <- density(gl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{print.summary.lengths}
\Rdversion{1.1}
\alias{print.summary.lengths}

\title{Printing Stratum Lengths Summary for Each Observed Category}

\description{The function prints the summary of stratum lengths given by \code{\link{summary.lengths}}.}

\usage{\method{print}{summary.lengths}(x, ...)}

\arguments{
  \item{x}{an object of the class \code{summary.lengths}, typically with the output of the function \code{\link{summary.lengths}}.}
  \item{\dots}{further arguments passed to or from other methods.}
}

\value{The summary of stratum lengths grouped by category is printed on the screen or other output devices. No values are returned.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{getlen}}, \code{\link{summary.lengths}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)
     
# Compute the appartaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)
     
# Estimate stratum lengths
gl <- getlen(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Summarize the stratum lengths
sgl <- summary(gl)

# Print the summary of stratum lengths
print(sgl)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{image.pemt}
\Rdversion{1.1}
\alias{image.pemt}

\title{Images with Multi-directional Transiograms}

\description{
The function plots \eqn{2}{2}-D sections of a multidirectional transiogram computed without any ellipsoidal interpolation.}

\usage{
\method{image}{pemt}(x, main, mar, ask = TRUE, ..., 
      nlevels = 10, contour = TRUE)
}

\arguments{
%%            x object return by the function pemt()
%%         main title string
%%          mar vector to pass to par()  
%%          ask boolean to pass to par()
%%          ... other args to pass to image()
%%      nlevels number of levels to pass to contour()
%%      contour boolean values that permits to draw contour lines
  \item{x}{an object of class \code{pemt}.}
  \item{main}{the main title (on top) whose font and size are fixed.}
  \item{mar}{a scalar or a numerical vector of the form \code{c(bottom, left, top, right)} which gives the number of margin lines to be specified on the four sides of image to plot. See \code{\link{par}}(\code{mar=}.).}
  \item{ask}{a logical value; if \code{TRUE}, the user is asked for input, before each plot. See \code{\link{par}}(ask=.).}
  \item{\dots}{other arguments to pass to the function \code{\link{image}}.}
  \item{nlevels}{the number of levels to pass to the function \code{\link{contour}}.}
  \item{contour}{logical. If \code{TRUE}, the function \code{\link{contour}} is used to draw contour lines over images. Defaults to \code{TRUE}.}
}

\details{
A multidimensional transiogram is a diagram which shows the transition probabilities for a single pair of categories. The probability is computed for any lag vector \eqn{h}{h} through 
\deqn{\mbox{expm} (\Vert h \Vert R_h),}{expm(||h|| R),}
where entries of \eqn{R_h}{R} are not ellipsoidally interpolated, but they are estimated for the direction specified by the vector \eqn{h}{h}.

The exponential matrix is evaluated by the scaling and squaring algorithm.
}

\value{An image is produced on the current graphics device. No values are returned.}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Higham, N. J. (2008) \emph{Functions of Matrices: Theory and Computation}. Society for Industrial and Applied Mathematics.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{image.multi_tpfit}}, \code{\link{image}}, \code{\link{plot.transiogram}}}

\examples{\donttest{
data(ACM)

# Compute a 2-D section of a
# multi-directional transiogram
psEmpTr <- pemt(ACM$MAT3, ACM[, 1:3], 2,
                max.dist = c(200, 200, 20), 
                which.dire=c(1, 3), 
                mle = "mlk")

# Plot 2-D sections of
# a multi-directional transiogram
image(psEmpTr, col = rev(heat.colors(500)), 
      breaks = 0:500 / 500, mar = .7,
      contour = FALSE)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{tpfit_ml}
\Rdversion{1.1}
\alias{tpfit_ml}

\title{Mean Length Method for One-dimensional Model Parameters Estimation}

\description{
The function estimates the model parameters of a 1-D continuous lag spatial Markov chain by the use of the mean length method. Transition rates matrix along a user defined direction and proportions of categories are computed.
}

\usage{tpfit_ml(data, coords, direction, tolerance = pi/8, mle = "avg")}

\arguments{
%%         data vector of data
%%       coords coordinates matrix
%%    direction vector (or versor) of chosen direction
%%    tolerance angle tolerance (in radians)
%%          mle argument to pass to the function mlen
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{tolerance}{a numerical value for the tolerance angle (in radians). It's \code{pi/8} by default.}
  \item{mle}{a character value to pass to the function \code{\link{mlen}}. It is \code{"avg"} by default.}
}

\details{
A 1-D continuous-lag spatial Markov chain is probabilistic model which involves a transition rate matrix \eqn{R}{R} computed for the direction \eqn{\phi}{phi}. It defines the transition probability \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through the entry \eqn{t_{jk}}{t_(jk)} of the following matrix
\deqn{T = \mbox{expm} (h R),}{T = expm(h R),}
where \eqn{h}{h} is a positive lag value.

To calculate entries of the transition rate matrix, we need to compute the mean lengths and the embedded transition probabilities.

By the use of the mean lengths, diagonal entries of \eqn{R}{R} are computed as
\deqn{\hat{r}_{kk} = \frac{1}{\bar{L}_k},}{r_(kk) = 1 / L_k,}
where \eqn{\bar{L}_k}{L_k} is the mean length of the \eqn{k}{k}-th category.

The off-diagonal transition rates of the matrix \eqn{R}{R} are estimated by the use of embedded transition probabilities and mean lengths:
\deqn{\hat{r}_{jk} = \frac{\pi_{jk}}{\bar{L}_k}, \quad \forall j \neq k, }{r_(kk) = pi_(jk) / L_k,   for all j != k,}
where \eqn{\pi_{jk}}{pi_(jk)} is a specific embedded transition probability.

When some entries of the matrix \eqn{R}{R} are not identifiable, it is suggested to vary the \code{tolerance} coefficient or to set the input argument \code{mle} to \code{"mlk"}.
}

\value{
An object of the class \code{tpfit} is returned. The function \code{\link{print.tpfit}} is used to print the fitted model. The object is a list with the following components: 
  \item{coefficients}{the transition rates matrix computed for the user defined direction.}
  \item{prop}{a vector containing the proportions of each observed category.}
  \item{tolerance}{a numerical value which denotes the tolerance angle (in radians).}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{predict.tpfit}}, \code{\link{print.tpfit}}, \code{\link{multi_tpfit_ml}}, \code{\link{transiogram}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# one-dimensional MC model
tpfit_ml(ACM$MAT5, ACM[, 1:3], c(0, 0, 1))}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{quench}
\Rdversion{1.1}
\alias{quench}

\title{Conditional Simulation Adjuster Via Quenching Algorithm}

\description{
The function adjusts a simulated random field generated by the \code{\link{sim}} function.
}

\usage{quench(x, data, coords, sim, GA = FALSE, optype = c("param", 
       "fullprobs", "semiprobs", "coordprobs"), max.it = 1000,
       knn = 12)}

\arguments{
%%        x a multi_tpfit object
%%     data vector of data
%%   coords coordinates matrix
%%      sim simulation results (tipically an "spsim" object)
%%       GA boolean (if TRUE genetic algorithm is applied rather than simulated annealing)
%%   optype character with the objective function to minimize after the simulation
%%   max.it maximum number of iteration for the optimization method
%%      knn number of k-nearest neighbours
  \item{x}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{sim}{an object of the class \code{spsim}, it is usually the output of the function \code{\link{sim}}.}
  \item{GA}{a logical value; if \code{TRUE}, the function performs the Genetic Algorithm instead of the Simulated Annealing.}
  \item{optype}{a character which denotes the objective function to compute when the optimization is performed.}
  \item{max.it}{a numerical value which specifies the maximum number of iterations to stop the optimization algorithm. For proper results, it should be a multiple of the number of simulation points.}
  \item{knn}{an integer value which specifies the number of k-nearest neighbours for each simulation point. An optimal number is between 4 and 12. If \code{NULL} all observations are considered (just for very small dataset!!). It is \code{12} by default.}
}

\details{
This method perform a simulated annealing or a genetic algorithm to modify the simulation results, in order to reduce artifacts effects. In practice, each simulated configuration is adjusted to reach a pattern similar to the observed sample data. There are several objective functions for this purpose, by setting \code{optype} equal to \code{"param"} the optimization is performed through parametric methods. The alternatives \code{"fullprobs"} and \code{"semiprobs"} are based on transition probabilities computed among simulation points, while the option \code{"coordprobs"} is based on transition probabilities calculated among observation and simulation points.

This procedure should be executed by setting \code{max.it} equal at least to the simulation grid size, or its multiples.
}

\value{A data frame containing the simulation grid, the simulated random field, predicted values and the approximated probabilities.}

\references{Carle, S. F., Fogg, G. E. (1996) Transition Probability-Based Indicator Geostatistics. \emph{Mathematical Geosciences}, \bold{28}(4), 453-476.

Carle, S. F. (1999) T-PROGS: Transition Probability Geostatistical Software. University of California, Davis.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.

%Tolosana-Delgado, R., Pawlowsky-Glahn, V., Egozcue, J.J. (2008) Indicator Kriging without Order Relation Violations. \emph{Mathematical Geosciences}, \bold{40}(3), 327-347.

Weise, T. (2009) \emph{Global Optimization Algorithms - Theory and Application}. \url{https://www.researchgate.net/publication/200622167_Global_Optimization_Algorithm_Theory_and_Application}.}

\author{Luca Sartore \email{drwolf85@gmail.com}}
%%\note{
%%%%  ~~further notes~~
%%}

\seealso{\code{\link{sim_ck}}, \code{\link{sim_ik}}, \code{\link{sim_mcs}}, \code{\link{sim_path}}}

\examples{\donttest{
data(ACM)

# Model parameters estimation for the
# multinomial categorical simulation
x <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Generate the simulation grid
mygrid <- list()
mygrid$X <- seq(min(ACM$X), max(ACM$X), length = 20)
mygrid$Y <- seq(min(ACM$Y), max(ACM$Y), length = 20)
mygrid$Z <- -40 * 0:9 - 1
mygrid <- as.matrix(expand.grid(mygrid$X, mygrid$Y, mygrid$Z))

# Simulate the random field through
# Ordinary Indicator Kriging algorithm
myOIKSim <- sim_ik(x, ACM$MAT5, ACM[, 1:3], mygrid)
 
# Perform the quenching algorithm 
# to adjust simulation
quench(x, ACM$MAT5, ACM[, 1:3], myOIKSim, optype = "coordprobs",
       max.it = 2, knn = 12) 
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}

\name{predict.tpfit}
\Rdversion{1.1}
\alias{predict.tpfit}

\title{Compute Theoretical One-dimensional Transiograms}

\description{
The function computes theoretical transition probabilities of a 1-D continuous-lag spatial Markov chain for a specified set of lags.
}

\usage{\method{predict}{tpfit}(object, lags, ...)}

\arguments{
  \item{object}{an object of the class \code{tpfit}, typically with the output of the function \code{\link{tpfit}}.}
  \item{lags}{a vector of 1-D lags.}
  \item{\dots}{further arguments passed from other methods.}
}

\details{
A 1-D continuous-lag spatial Markov chain is probabilistic model which involves a transition rate matrix \eqn{R}{R} computed for the direction \eqn{\phi}{phi}. It defines the transition probability \eqn{\Pr(Z(s + h) = z_k | Z(s) = z_j)}{Pr(Z(s + h) = z_k | Z(s) = z_j)} through the entry \eqn{t_{jk}}{t_(jk)} of the following matrix
\deqn{T = \mbox{expm} (h R),}{T = expm(h R),}
where \eqn{h}{h} is a positive lag value.
}

\value{
An object of the class \code{transiogram} is returned. The function \code{\link{print.transiogram}} is used to print computed probabilities. The object is a list with the following components: 
  \item{Tmat}{a 3-D array containing the probabilities.}
  \item{lags}{a vector containing one-dimensional lags.}
  \item{type}{a character string which specifies that computed probabilities are theoretical.}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{tpfit}}, \code{\link{print.tpfit}}, \code{\link{plot.transiogram}}, \code{\link{transiogram}}, \code{\link{multi_tpfit}}}

\examples{\donttest{
data(ACM)

# Estimate the parameters of a 
# one-dimensional MC model
RTm <- tpfit(ACM$MAT3, ACM[, 1:3], c(0, 0, 1))

# Compute transition probabilities 
# from the one-dimensional MC model
predict(RTm, lags = 0:2/2)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{image.multi_tpfit}
\Rdversion{1.1}
\alias{image.multi_tpfit}

\title{Images with Multidimensional Transiograms}

\description{The function plots \eqn{2}{2}-D sections of a predicted multidimensional transiograms computed through ellipsoidal interpolation.}

\usage{\method{image}{multi_tpfit}(x, mpoints, which.dire, max.dist, main,
      mar, ask = TRUE, ..., nlevels = 10, contour = TRUE)}

\arguments{
%%            x multi_tpfit object
%%      mpoints number of points per axes
%%   which.dire two chosen 1D directions
%%     max.dist vector of maximum distances
%%         main title string
%%          mar vector to pass to par()
%%          ask boolean to pass to par()
%%          ... other args to pass to image()
%%      nlevels number of levels to pass to contour()
%%      contour boolean values that permits to draw contour lines
  \item{x}{an object of the class \code{multi_tpfit}, typically with the output of the function \code{\link{multi_tpfit}}.}
  \item{mpoints}{the number of points per axes. It controls the accuracy of images to plot.}
  \item{which.dire}{a vector with two chosen axial directions. If omitted, all \eqn{2}{2}-D sections are plotted.}
  \item{max.dist}{a scalar or a vector of maximum length for the chosen axial directions.}
  \item{main}{the main title (on top) whose font and size are fixed.}
  \item{mar}{a scalar or a numerical vector of the form \code{c(bottom, left, top, right)} which gives the number of margin lines to be specified on the four sides of image to plot. See \code{\link{par}}(\code{mar=}.).}
  \item{ask}{a logical value; if \code{TRUE}, the user is asked for input, before each plot. See \code{\link{par}}(\code{ask=}.).}
  \item{\dots}{other arguments to pass to the function \code{\link{image}}.}
  \item{nlevels}{the number of levels to pass to the function \code{\link{contour}}.}
  \item{contour}{logical. If \code{TRUE}, the function \code{\link{contour}} is used to draw contour lines over the image. Defaults to \code{TRUE}.}
}

\details{
A multidimensional transiogram is a diagram which shows the transition probabilities for a single pair of categories. It is computed for any lag vector \eqn{h}{h} through 
\deqn{\mbox{expm} (\Vert h \Vert R),}{expm(||h|| R),}
where entries of \eqn{R}{R} are ellipsoidally interpolated (see \code{\link{multi_tpfit}}).

The exponential matrix is evaluated by the scaling and squaring algorithm.
}

\value{An image is produced on the current graphics device. No values are returned.}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Higham, N. J. (2008) \emph{Functions of Matrices: Theory and Computation}. Society for Industrial and Applied Mathematics.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}


\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{multi_tpfit}}, \code{\link{pemt}}, \code{\link{image.pemt}}, \code{\link{image}}, \code{\link{plot.transiogram}}}

\examples{\donttest{
data(ACM)

# Estimate model parameter
x <- multi_tpfit(ACM$MAT5, ACM[, 1:3])

# Set short names for categories 3 and 4
names(x$prop)[3:4] <- c("Clay and Sand", "Gravel and Sand")

# Plot 2-D theoretical sections of
# a multidimensional transiogram
image(x, 40, max.dist=c(200,200,20), which.dire=2:3,
    mar = .7, col=rev(heat.colors(500)),
    breaks=0:500/500, nlevels = 5)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{hplot}

\name{getlen}
\Rdversion{1.1}
\alias{getlen}

\title{Estimation of Stratum Lengths for Embedded Markov Chain}

\description{The function estimates the stratum lengths for a \eqn{d}{d}-D spatial embedded Markov chain for a specified direction \eqn{\phi}{phi}.}

\usage{getlen(data, coords, loc.id, direction, zero.allowed = FALSE)}

\arguments{
%%         data vector of data
%%       coords matrix of coordinates
%%       loc.id location Id (which_lines output)
%%    direction vector (or versor) of choosen direction
%% zero.allowed logical, it allows zero stratum lengths
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{loc.id}{a vector of \eqn{n}{n} values which indicates the directional line of each location. It is usually the output of the function \code{\link{which_lines}}.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
  \item{zero.allowed}{a logical value which allows to return zero stratum lengths. It is \code{FALSE} by default.}
}

\details{
Stratum lengths are the lengths occupied by the same \eqn{k}{k}-th category along lines in the direction \eqn{\phi}{phi}.
}

\value{A list containing the following components:
  \item{length}{a numerical vector with the stratum lengths along the given direction.}
  \item{categories}{a vector with the stratum categories.}
  \item{maxcens}{a vector with the maxima estimated censored lengths for each stratum.}
  \item{directions}{a \eqn{d}{d}-D numerical vector which represents the chosen direction.}
  \item{zeros}{a logical values which denotes the possible presence of zero lengths.}
}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{mlen}}, \code{\link{which_lines}}}

\examples{\donttest{
data(ACM)
direction <- c(0,0,1)

# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction)

# Estimate stratum lengths
gl <- getlen(ACM$MAT5, ACM[, 1:3], loc.id, direction)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}

\name{spMC-package}
\Rdversion{1.1}
\alias{spMC-package}
\alias{spMC}
\docType{package}

\title{Continuous Lag Spatial Markov Chains}

\description{
\if{html}{\figure{logo.svg}{options: style='float:right;'}}
The main goal of this package is to provide a set of functions for
 \enumerate{
  \item the stratum lengths analysis along a chosen direction,
  \item fast estimation of continuous lag spatial Markov chains model parameters and probability computing (also for large data sets), 
  \item transition probability maps and transiograms drawing, 
  \item simulation methods for categorical random fields.
 }
}

\details{
\tabular{ll}{
Package: \tab spMC\cr
Type: \tab Package\cr
Version: \tab 0.3.16\cr
Date: \tab 2026-08-23\cr
License: \tab GPL (>= 2)\cr
LazyLoad: \tab yes\cr
}

Several functions are available for the stratum lengths analysis, in particular they compute the stratum lengths for each stratum category, they compute the empirical distributions and many other tools for a graphical analysis.

Usually, the basic inputs for the most of the functions are a vector of categorical data and their location coordinates. They are used to estimate empirical transition probabilities (\link{transiogram}), to estimate model parameters (\link{tpfit} for one-dimensional Markov chains or \link{multi_tpfit} for multidimensional Markov chains). Once parameters are estimated, it's possible to compute theoretical transition probabilities by the use of the function \link{predict.tpfit} for one-dimensional Markov chains and \link{predict.multi_tpfit} for multidimensional ones.

The function \link{plot.transiogram} allows to plot one-dimensional transiograms, while \link{image.multi_tpfit} permit to draw transition probability maps. A powerful tool to explore graphically the anisotropy of such process is given by the functions \link{pemt} and \link{image.pemt}, which let the user to draw "quasi-empirical" transition probability maps.

Simulation methods are based on Indicator Kriging (\link{sim_ik}), Indicator Cokriging (\link{sim_ck}), Fixed or Random Path algorithms (\link{sim_path}) and Multinomial Categorical Simulation technique (\link{sim_mcs}).
}

\author{
Luca Sartore

Maintainer: Luca Sartore \email{drwolf85@gmail.com}
}

\references{
Allard, D., D'Or, D., Froidevaux, R. (2011) An efficient maximum entropy approach for categorical variable prediction. \emph{European Journal of Soil Science}, \bold{62}(3), 381-393.

Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Dynkin, E. B. (1961) \emph{Theory of Markov Processes}. Englewood Cliffs, N.J.: Prentice-Hall, Inc.

Higham, N. J. (2008) \emph{Functions of Matrices: Theory and Computation}. Society for Industrial and Applied Mathematics.

Li, W. (2007) A Fixed-Path Markov Chain Algorithm for Conditional Simulation of Discrete Spatial Variables. \emph{Mathematical Geology}, \bold{39}(2), 159-176.

Li, W. (2007) Markov Chain Random Fields for Estimation of Categorical Variables. \emph{Mathematical Geology}, \bold{39}(June), 321-335.

Li, W. (2007) Transiograms for Characterizing Spatial Variability of Soil Classes. \emph{Soil Science Society of America Journal}, \bold{71}(3), 881-893.

Pickard, D. K. (1980) Unilateral Markov Fields. \emph{Advances in Applied Probability}, \bold{12}(3), 655-671.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.

Sartore, L. (2013). spMC: Modelling Spatial Random Fields with Continuous Lag Markov Chains. \emph{The R Journal}, \bold{5}(2), 16-28.

Sartore, L., Fabbri, P. and Gaetan, C. (2016). spMC: an R-package for 3D lithological reconstructions based on spatial Markov chains. \emph{Computers & Geosciences}, \bold{94}(September), 40-47.

%Tolosana-Delgado, R., Pawlowsky-Glahn, V., Egozcue, J.J. (2008) Indicator Kriging without Order Relation Violations. \emph{Mathematical Geosciences}, \bold{40}(3), 327-347.

Weise, T. (2009) \emph{Global Optimization Algorithms - Theory and Application}. \url{https://www.researchgate.net/publication/200622167_Global_Optimization_Algorithm_Theory_and_Application}.

}

\keyword{package}
\keyword{spatial}

\name{embed_MC}
\Rdversion{1.1}
\alias{embed_MC}

\title{Transition Probabilities Estimation for Embedded Markov Chain}

\description{The function estimates the embedded transition probabilities matrix for a \eqn{1}{1}-D spatial embedded Markov chain.}

\usage{embed_MC(data, coords, loc.id, direction)}

\arguments{
%%        data vector of data
%%      coords matrix of coordinates
%%      loc.id location Id (which_lines output)
%%   direction vector (or versor) of chosen direction
  \item{data}{a categorical data vector of length \eqn{n}{n}.}
  \item{coords}{an \eqn{n \times d}{n x d} matrix where each row denotes the \eqn{d}{d}-D coordinates of data locations.}
  \item{loc.id}{a vector of \eqn{n}{n} values which indicats the directional line of each location. It is usually the output of the function \code{\link{which_lines}}.}
  \item{direction}{a \eqn{d}{d}-D numerical vector (or versor) which represents the chosen direction.}
}

\details{
An embedded Markov chain is probabilistic model which defines the transition probabilities between embedded occurrences. 

The resulting matrix is given by normalizing a transition count matrix, which doesn't depend on the length of embedded occurrences. Self-transitions of embedded occurrences are not observable, so diagonal entries are set to be \code{NA}.

It's also possible to calculate the transition probabilities matrix for several directions in a \eqn{d}{d}-D space through arguments \code{direction} and \code{loc.id}. If the user has no previous knowledge about \code{loc.id}, the function \code{\link{which_lines}} provides a method to compute the right values.
}

\value{A \eqn{K \times K}{K x K} transition probability matrix, where \eqn{K}{K} denotes the number of observed categories. Another \eqn{K \times K}{K x K} matrix with the counts of transitions is attached as an attribute.}

\references{Carle, S. F., Fogg, G. E. (1997) Modelling Spatial Variability with One and Multidimensional Continuous-Lag Markov Chains. \emph{Mathematical Geology}, \bold{29}(7), 891-918.

Dynkin, E. B. (1961) \emph{Theory of Markov Processes. Englewood Cliffs}, N.J.: Prentice-Hall, Inc.

Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\author{Luca Sartore \email{drwolf85@gmail.com}}

\seealso{\code{\link{which_lines}}, \code{\link{predict.tpfit}}, \code{\link{predict.multi_tpfit}}}

\examples{\donttest{
data(ACM)
direction <- c(0, 0, 1)

# Compute the appertaining directional line for each location
loc.id <- which_lines(ACM[, 1:3], direction, pi/8)

# Estimate the embedded transition probabilities
# matrix for the categorical variable MAT5
embed_MC(ACM$MAT5, ACM[, 1:3], loc.id, direction)

# Estimate the embedded transition probabilities
# matrix for the categorical variable MAT3
embed_MC(ACM$MAT3, ACM[, 1:3], loc.id, direction)

# Estimate the embedded transition probabilities
# matrix for the categorical variable PERM
embed_MC(ACM$PERM, ACM[, 1:3], loc.id, direction)
}}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{spatial}
\keyword{distribution}
\keyword{models}

\name{ACM}
\Rdversion{1.1}
\alias{ACM}
\docType{data}

\title{ACM Data}

\description{
The data set refers to a sampled area which is located in the province of Venice. Its sample units report the geographical position of the perforation, the depth, the ground permeability and other two categorical variables which denote the soil composition.
}

\usage{data(ACM)}

\format{
  A data frame with 2321 observations on the following 6 variables.
  \describe{
    \item{\code{X}}{a numeric vector (longitude)}
    \item{\code{Y}}{a numeric vector (latitude)}
    \item{\code{Z}}{a numeric vector (depth)}
    \item{\code{MAT5}}{a factor with levels \code{Clay}, \code{Gravel}, \code{Mix of Sand and Clay}, \code{Mix of Sand and Gravel} and \code{Sand}}
    \item{\code{MAT3}}{a factor with levels \code{Clay}, \code{Gravel} and \code{Sand}}
    \item{\code{PERM}}{a logical vector (symmetric dichotomous variable)}
  }
}

\source{Fabbri, P. (2010) Professor at the Geosciences Department of the University of Padua.\cr\email{paolo.fabbri@unipd.it}}

\references{Sartore, L. (2010) Geostatistical models for 3-D data. M.Phil. thesis, Ca' Foscari University of Venice.}

\examples{\donttest{
data(ACM)
str(ACM)
summary(ACM)
}}

\keyword{datasets}
